(function() {
  "use strict";
  try {
    if (typeof document != "undefined") {
      var elementStyle = document.createElement("style");
      elementStyle.appendChild(document.createTextNode(`button {
  cursor: pointer !important;
}

#jsonforms-wrapper {
  max-width: calc(100% - 47px);
}

.jsonforms-dispatch-container,
.array-item-header,
div[class^='spectrum-Textfield'] {
  width: 100%;
}

.spectrum-array-item-number {
  --spectrum-array-item-number-size: 1.2rem;

  display: flex;
  align-items: center;
  justify-content: center;
  width: var(--spectrum-array-item-number-size);
  height: var(--spectrum-array-item-number-size);
  border-radius: 50%;
  overflow: hidden;
  line-height: var(--spectrum-array-item-number-size);
  font-size: 0.75em;
  font-weight: 500;
  text-align: center;
  color: var(--spectrum-tooltip-text-color, var(--spectrum-global-color-static-white));
  flex-shrink: 0;
  background-color: var(
    --spectrum-tooltip-background-color,
    var(--spectrum-global-color-static-gray-700)
  ) !important;
}

.grabbable {
  display: flex;
  width: 50px;
  background-color: transparent;
  fill: var(--spectrum-actionbutton-icon-color, var(--spectrum-alias-icon-color));
  border-radius: var(
    --spectrum-actionbutton-quiet-border-radius,
    var(--spectrum-alias-border-radius-regular)
  );
  border-color: transparent;
  margin: -5px -12px -5px 0px;
  touch-action: none;
  min-width: 34px;
  -webkit-touch-callout: none; /* iOS Safari */
  -webkit-user-select: none; /* Safari */
  -khtml-user-select: none; /* Konqueror HTML */
  -moz-user-select: none; /* Old versions of Firefox */
  -ms-user-select: none; /* Internet Explorer/Edge */
  user-select: none; /* Non-prefixed version, currently supported by Chrome, Edge, Opera and Firefox */
  outline: none;
}

.grabcursor {
  cursor: move !important; /* fallback if grab cursor is unsupported */
  cursor: grab !important;
  cursor: -webkit-grab !important;
  cursor: -moz-grab !important;
  cursor: -o-grab !important;
  cursor: -ms-grab !important;
}

/* Apply a "closed-hand" cursor during drag operation. */
.grabcursor:active {
  cursor: grabbing !important;
  cursor: -webkit-grabbing !important;
  cursor: -moz-grabbing !important;
  cursor: -o-grabbing !important;
  cursor: -ms-grabbing !important;
}

.arrow-icon {
  padding: 6px 0px;
}

.grabbable:focus-visible {
  box-shadow: 0 0 0 1px
    var(
      --spectrum-actionbutton-quiet-border-color-key-focus,
      var(--spectrum-alias-border-color-focus)
    );
  border-color: var(
    --spectrum-actionbutton-quiet-border-color-key-focus,
    var(--spectrum-alias-border-color-focus)
  );
  border-width: var(--spectrum-actionbutton-border-size, var(--spectrum-alias-border-size-thin));
}

.animated-modal-item.animated-modal-item-div.detailed-view {
  background-color: var(--spectrum-global-color-gray-100);
  top: 0;
  z-index: 9000;
  width: 95%;
  min-height: 100%;
  height: 100%;
  flex-grow: 1;
  position: absolute;
  background-color: var(--spectrum-global-color-gray-100);
  overflow-x: hidden;
  overflow-y: auto;

  border-left-color: var(
    --spectrum-alias-border-color-dark,
    var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
  );
  border-left-width: var(--spectrum-alias-border-size-thin);
  border-left-style: solid;
}
.animated-modal-item.animated-modal-item-div.detailed-view
  > .jsonforms-dispatch-wrapper
  > .array-item-header {
  position: sticky;
  width: 100%;
  padding: 10px 13px 10px 13px;
  margin-top: -12px;
  top: -12px;
  left: 0;

  background-color: var(--spectrum-global-color-gray-100);
  z-index: 1;
  border-bottom-color: var(
    --spectrum-alias-border-color-dark,
    var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
  );
  border-bottom-width: var(--spectrum-alias-border-size-thin);
  border-bottom-style: solid;
}

.modal-element,
.array-item-content {
  margin-left: var(--spectrum-global-dimension-size-250, var(--spectrum-alias-size-250)) !important;
  margin-right: var(
    --spectrum-global-dimension-size-250,
    var(--spectrum-alias-size-250)
  ) !important;
  margin-top: 12px !important;
}

.animated-modal-item.animated-modal-item-div.detailed-view
  > .jsonforms-dispatch-wrapper
  > div.array-item-header {
  top: 0;
  width: calc(100% - 26px);
}

.list-array-item:has(.jsonforms-dispatch-wrapper) {
  display: flex;
  flex-direction: column;
}

.jsonforms-dispatch-wrapper {
  display: flex;
  flex-direction: column;
  width: 100%;
}

.jsonforms-dispatch-wrapper:not(:has(section)) > .array-item-content {
  margin: var(--spectrum-global-dimension-size-160, var(--spectrum-alias-size-160));
  border: 2px solid transparent;
}

[class^='spectrum-Tabs_'] {
  margin: var(--spectrum-global-dimension-size-160, var(--spectrum-alias-size-160));
}

section section,
section [class^='spectrum-Tabs_'] {
  margin: 0;
}

.animated-modal-item.dark-background {
  background-color: rgba(0, 0, 0, 1);
  opacity: 0.2;
  z-index: 8000;
  position: absolute;
  top: 0;
  left: 0;
  height: 100%;
  width: 95%;
}

.animated-modal-item.animated-modal-wrapper {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  overflow-x: hidden;
  overflow-y: auto;
}

#jsonforms-array-wrapper {
  overflow-x: hidden;
  overflow-y: auto;
}

/* Just for the Playground */
.App-Form {
  min-height: 80vh;
  position: relative;
  overflow-x: hidden;
  overflow-y: auto;
}

.jsonforms-dispatch-container label {
  display: none;
}

.jsonforms-dispatch-container section {
  margin: 0 0 0 10px !important;
}

.list-array-item {
  background-color: var(--spectrum-global-color-gray-100);
  padding: 10px !important;
  min-height: 62px !important;
  display: flex;
  align-items: center;
}

.list-array-item:not(:has(.jsonforms-dispatch-wrapper)) {
  height: 62px !important;
}

.list-array-item.no-accordion {
  padding: 8px 12px !important;
}
.list-array-item.no-accordion [class^='spectrum-FieldLabel_'] {
  display: none;
}

.disabledMovement {
  cursor: not-allowed !important;
}

.keyboard-movement {
  fill: var(
    --spectrum-actionbutton-quiet-border-color-key-focus,
    var(--spectrum-alias-border-color-focus)
  );
}
@media (hover: none) and (pointer: coarse) {
  .keyboard-movement {
    fill: inherit;
  }
}

.grabbable .keyboard-user,
.keyboard-user .mouse-drag-handle {
  display: none;
}

.keyboard-user .keyboard-user,
.pointer-user .mouse-user {
  display: flex;
  fill: var(--spectrum-actionbutton-icon-color, var(--spectrum-alias-icon-color));
}

.keyboard-user .keyboard-user {
  fill: currentColor;
}

.add-item {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 62px;
  cursor: pointer;
  background-color: var(--spectrum-global-color-gray-100);
  outline: none;
  padding: 0;
  margin: 0 0 10px 0;
  border-radius: var(--spectrum-alias-border-radius-medium) !important;
  border: 1px dashed
    var(
      --spectrum-alias-border-color-dark,
      var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
    ) !important;
}

.add-item:focus {
  outline: none;
}

.add-item:focus-visible {
  outline: none;
  border: 2px solid
    var(
      --spectrum-actionbutton-quiet-border-color-key-focus,
      var(--spectrum-alias-border-color-focus)
    ) !important;
  box-shadow: none;
}
.add-container {
  display: flex;
  justify-content: center;
  position: absolute;
  width: 100%;
  z-index: 80;
}

.add-container:before {
  content: '';
  position: absolute;
  top: 50%;
  left: 0;
  border-top: 3px solid
    var(
      --spectrum-actionbutton-quiet-border-color-key-focus,
      var(--spectrum-alias-border-color-focus)
    );
  background: var(
    --spectrum-actionbutton-quiet-border-color-key-focus,
    var(--spectrum-alias-border-color-focus)
  );
  width: 100%;
  transform: translateY(-50%);
}

/* List with Detail */
.list-with-detail-master-item-row[aria-selected='true'] {
  background-color: var(--spectrum-global-color-gray-200);
}

.list-with-detail-master-item-number {
  --list-with-detail-master-item-number-size: 1.2rem;

  display: flex;
  align-items: center;
  justify-content: center;
  width: var(--list-with-detail-master-item-number-size);
  height: var(--list-with-detail-master-item-number-size);
  border-radius: 50%;
  overflow: hidden;
  line-height: var(--list-with-detail-master-item-number-size);
  font-size: 0.75em;
  font-weight: 500;
  text-align: center;
  background-color: var(
    --spectrum-tooltip-background-color,
    var(--spectrum-global-color-static-gray-700)
  );
  color: var(--spectrum-tooltip-text-color, var(--spectrum-global-color-static-white));
}

[aria-selected='true'] .list-with-detail-master-item-number {
  background-color: var(--spectrum-global-color-gray-900);
  color: var(--spectrum-tooltip-text-color, var(--spectrum-global-color-static-white));
}

/* TipTap */
.ProseMirror {
  background-color: var(
    --spectrum-textfield-background-color,
    var(--spectrum-global-color-gray-50)
  );
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
  box-sizing: border-box;
  border: var(--spectrum-textfield-border-size, var(--spectrum-alias-border-size-thin)) solid;
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
  border-radius: 0 0
    var(--spectrum-textfield-border-radius, var(--spectrum-alias-border-radius-regular))
    var(--spectrum-textfield-border-radius, var(--spectrum-alias-border-radius-regular));
  height: auto;
  max-height: 45vh;
  overflow-x: hidden;
  overflow-y: auto;
  width: auto;
  min-height: 129px;
  padding: 3px var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) 5px
    calc(var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) - 1px);
  text-indent: 0;
  vertical-align: top;
  font-size: var(--spectrum-textfield-text-size, var(--spectrum-alias-font-size-default));
  line-height: var(
    --spectrum-textfield-text-line-height,
    var(--spectrum-alias-body-text-line-height)
  );
  text-overflow: ellipsis;
  outline: 0;
}

.no-toolbar > .ProseMirror {
  border-radius: var(
    --spectrum-textfield-border-radius,
    var(--spectrum-alias-border-radius-regular)
  ) !important;
}

.ProseMirror-focused {
  border-color: var(
    --spectrum-textfield-border-color-down,
    var(--spectrum-alias-border-color-mouse-focus)
  );
}

.keyboard-user .ProseMirror-focused {
  border-width: 2px;
}

.tiptap-toolbar {
  border-radius: var(
      --spectrum-textfield-border-radius,
      var(--spectrum-alias-border-radius-regular)
    )
    var(--spectrum-textfield-border-radius, var(--spectrum-alias-border-radius-regular)) 0 0 !important;
  border-bottom: none !important;
}

.last-toolbar-button {
  margin-right: 8px;
}

.read-only > .ProseMirror {
  background-color: var(
    --spectrum-textfield-background-color-disabled,
    var(--spectrum-global-color-gray-200)
  );
  color: var(--spectrum-textfield-text-color-disabled, var(--spectrum-alias-text-color-disabled));
  -webkit-text-fill-color: var(
    --spectrum-textfield-text-color-disabled,
    var(--spectrum-alias-text-color-disabled)
  );
}

.read-only.no-toolbar > .ProseMirror {
  border-color: var(
    --spectrum-textfield-border-color-disabled,
    var(--spectrum-alias-border-color-transparent)
  );
}

/* CodeMirror */
.spectrum-codemirror {
  background-color: var(
    --spectrum-textfield-background-color,
    var(--spectrum-global-color-gray-50)
  );
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
  box-sizing: border-box;
  border: var(--spectrum-textfield-border-size, var(--spectrum-alias-border-size-thin)) solid;
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
  border-radius: var(
    --spectrum-textfield-border-radius,
    var(--spectrum-alias-border-radius-regular)
  );
  height: auto;
  min-height: 30px;
  max-height: 45vh;
  overflow-x: hidden;
  overflow-y: auto;
  width: auto;
  padding: 0 3px var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) 5px
    calc(var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) - 1px);
  text-indent: 0;
  vertical-align: top;
  font-size: var(--spectrum-textfield-text-size, var(--spectrum-alias-font-size-default));
  line-height: var(
    --spectrum-textfield-text-line-height,
    var(--spectrum-alias-body-text-line-height)
  );
  outline: 0;
}

.cm-gutters,
.cm-gutter {
  min-height: 28px !important;
  height: 100% !important;
  padding-bottom: 2.5px !important;
}

.cm-content {
  padding: 5px 0 !important;
}

.spectrum-codemirror:focus-within {
  border-color: var(
    --spectrum-textfield-border-color-down,
    var(--spectrum-alias-border-color-mouse-focus)
  ) !important;
  border: var(--spectrum-textfield-border-size, var(--spectrum-alias-border-size-thin)) solid;
  border-radius: var(
    --spectrum-textfield-border-radius,
    var(--spectrum-alias-border-radius-regular)
  );
}

.spectrum-label {
  font-size: var(--spectrum-fieldlabel-text-size, var(--spectrum-global-dimension-font-size-75));
  font-weight: var(
    --spectrum-fieldlabel-text-font-weight,
    var(--spectrum-global-font-weight-regular)
  );
  line-height: var(
    --spectrum-fieldlabel-text-line-height,
    var(--spectrum-global-font-line-height-small)
  );
  color: var(--spectrum-fieldlabel-text-color, var(--spectrum-alias-label-text-color));
}

.spectrum-codemirror > .cm-editor {
  background-color: var(
    --spectrum-textfield-background-color,
    var(--spectrum-global-color-gray-50)
  );
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
}

.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-gutters {
  background-color: var(
    --spectrum-fieldbutton-background-color-down,
    var(--spectrum-global-color-gray-200)
  );
  border-color: var(
    --spectrum-fieldbutton-border-color-down,
    var(--spectrum-alias-border-color-down)
  );
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
}

.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-content > .cm-activeLine,
.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-gutters > .cm-gutter > .cm-activeLineGutter {
  background-color: var(
    --spectrum-table-row-background-color-selected-hover,
    var(--spectrum-alias-highlight-selected-hover)
  ) !important;
}

/* Creates a Zebra Layout */
.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-content > div:nth-child(even) {
  background-color: var(
    --spectrum-table-row-background-color-hover,
    var(--spectrum-alias-highlight-hover)
  );
}

.read-only,
.spectrum-codemirror.read-only > .cm-editor > .cm-scroller {
  background-color: var(
    --spectrum-textfield-background-color-disabled,
    var(--spectrum-global-color-gray-200)
  );
  color: var(--spectrum-textfield-text-color-disabled, var(--spectrum-alias-text-color-disabled));
  -webkit-text-fill-color: var(
    --spectrum-textfield-text-color-disabled,
    var(--spectrum-alias-text-color-disabled)
  );
  border-color: var(
    --spectrum-textfield-border-color-disabled,
    var(--spectrum-alias-border-color-transparent)
  );
}

.spectrum-codemirror.read-only,
.spectrum-codemirror.read-only > .cm-editor > .cm-scroller {
  background-color: var(
    --spectrum-textfield-background-color-disabled,
    var(--spectrum-global-color-gray-200)
  );
  color: var(--spectrum-textfield-text-color-disabled, var(--spectrum-alias-text-color-disabled));
  -webkit-text-fill-color: var(
    --spectrum-textfield-text-color-disabled,
    var(--spectrum-alias-text-color-disabled)
  );
  border-color: var(
    --spectrum-textfield-border-color-disabled,
    var(--spectrum-alias-border-color-transparent)
  );
}

.spectrum-codemirror.read-only > .cm-editor > .cm-scroller > .cm-content > .cm-activeLine,
.spectrum-codemirror.read-only
  > .cm-editor
  > .cm-scroller
  > .cm-gutters
  > .cm-gutter
  > .cm-activeLineGutter {
  background-color: transparent !important;
}

.keyboard-user .spectrum-codemirror:focus-within {
  border-width: 2px;
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
}

/* SpectrumCategorizationStepper */
.categorization-stepper {
  counter-reset: categorization-step-number;
}

.categorization-stepper div[role='tab'] {
  counter-increment: categorization-step-number;
}

.categorization-stepper div[role='tab'] > span:before {
  --categorization-stepper-number-size: 1.2rem;

  display: inline-block;
  width: var(--categorization-stepper-number-size);
  height: var(--categorization-stepper-number-size);
  border-radius: 50%;
  margin-right: 0.4rem;
  overflow: hidden;
  content: counter(categorization-step-number);
  text-align: center;
  vertical-align: middle;
  line-height: var(--categorization-stepper-number-size);
  font-size: 0.75em;
  font-weight: 500;
  background-color: var(--spectrum-global-color-gray-500);
  color: var(--spectrum-global-color-gray-200);
}

.categorization-stepper div[role='tab'][aria-selected='true'] > span:before {
  background-color: var(--spectrum-global-color-gray-900);
  color: var(--spectrum-global-color-gray-100);
}

.animated-modal-item.animated-modal-item-div.detailed-view > .array-item-header {
  position: sticky;
  width: 100%;
  padding: 10px 13px 10px 13px;
  margin-top: -12px;
  top: -12px;
  left: 0;

  background-color: var(--spectrum-global-color-gray-100);
  z-index: 1;
  border-bottom-color: var(
    --spectrum-alias-border-color-dark,
    var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
  );
  border-bottom-width: var(--spectrum-alias-border-size-thin);
  border-bottom-style: solid;
}

/* InputText */
.assetpicker-button {
  min-width: min-content !important;
  /* margin-top: 25px !important; */
  margin-left: 5px !important;
}

.assetpicker-button-bottom {
  min-width: min-content !important;
  margin-top: 5px !important;
  margin-right: 3px !important;
}

div:has(> div[id^='#/'][hidden]) {
  display: none !important;
}

.arrowContainer {
  padding: 3px 7px;
}`));
      document.head.appendChild(elementStyle);
    }
  } catch (e) {
    console.error("vite-plugin-css-injected-by-js", e);
  }
})();
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _breadcrumbs, _copy, copy_fn;
import { jsx, jsxs, Fragment } from "react/jsx-runtime";
import { getAjv, resolveSchema, Actions, update, rankWith, and, isBooleanControl, optionIs, isEnumControl, isIntegerControl, isNumberControl, isRangeControl, isMultiLineControl, isStringControl, isDescriptionHidden, isControl, NOT_APPLICABLE, uiTypeIs, schemaMatches, isOneOfEnumControl, schemaTypeIs, or, isDateControl, isDateTimeControl, isTimeControl, isObjectControl, findUISchema, composePaths, Resolve, getData, createDefaultValue, Helpers, hasType, Generate, isAnyOfControl, createCombinatorRenderInfos, isAllOfControl, findMatchingUISchema, isVisible, categorizationHasCategory, isOneOfControl, computeLabel } from "@jsonforms/core";
import { useJsonForms, withJsonFormsContext, ctxToArrayControlProps, ctxDispatchToControlProps, withJsonFormsCellProps, withJsonFormsEnumCellProps, withJsonFormsEnumProps, withJsonFormsControlProps, DispatchCell, withJsonFormsOneOfEnumProps, withJsonFormsMultiEnumProps, withJsonFormsDetailProps, JsonFormsDispatch, withJsonFormsAnyOfProps, withJsonFormsAllOfProps, withJsonFormsLayoutProps, withJsonFormsOneOfProps, withJsonFormsMasterListItemProps, withJsonFormsArrayLayoutProps } from "@jsonforms/react";
import { DialogContainer, Dialog, Heading, Divider, Content, ButtonGroup, Button, View, ContextualHelp, Text, useProvider, defaultTheme, Provider, ToggleButton, Checkbox, Picker, Item, ComboBox, NumberField, RadioGroup, Radio, Slider, Switch, Flex, TextField, ActionButton, TextArea, DialogTrigger, Tabs, TabList, TabPanels, Grid, TooltipTrigger, Tooltip, MenuTrigger, Menu, ActionMenu, ListBox } from "@adobe/react-spectrum";
import get from "lodash/get";
import set from "lodash/set";
import * as React from "react";
import React__default, { useState, createElement, useContext } from "react";
import ReactDom from "react-dom";
import { useSpring, easings, animated } from "react-spring";
import ReactFocusLock from "react-focus-lock";
import isEqual from "lodash/isEqual";
import debounce from "lodash/debounce";
import merge from "lodash/merge";
import { DatePicker, TimeField } from "@react-spectrum/datepicker";
import { TagGroup } from "@react-spectrum/tag";
import Add from "@spectrum-icons/workflow/Add";
import ArrowDown from "@spectrum-icons/workflow/ArrowDown";
import ArrowUp from "@spectrum-icons/workflow/ArrowUp";
import Asset from "@spectrum-icons/workflow/Asset";
import ChevronDown from "@spectrum-icons/workflow/ChevronDown";
import ChevronUp from "@spectrum-icons/workflow/ChevronUp";
import Close from "@spectrum-icons/workflow/Close";
import Delete from "@spectrum-icons/workflow/Delete";
import DragHandle from "@spectrum-icons/workflow/DragHandle";
import Duplicate from "@spectrum-icons/workflow/Duplicate";
import Edit from "@spectrum-icons/workflow/Edit";
import FolderOpen from "@spectrum-icons/workflow/FolderOpen";
import FolderSearch from "@spectrum-icons/workflow/FolderSearch";
import Link from "@spectrum-icons/workflow/Link";
import Properties from "@spectrum-icons/workflow/Properties";
import Redo from "@spectrum-icons/workflow/Redo";
import Star from "@spectrum-icons/workflow/Star";
import StarOutline from "@spectrum-icons/workflow/StarOutline";
import TableAdd from "@spectrum-icons/workflow/TableAdd";
import TableColumnAddLeft from "@spectrum-icons/workflow/TableColumnAddLeft";
import TableColumnAddRight from "@spectrum-icons/workflow/TableColumnAddRight";
import TableColumnRemoveCenter from "@spectrum-icons/workflow/TableColumnRemoveCenter";
import TableEdit from "@spectrum-icons/workflow/TableEdit";
import TableMergeCells from "@spectrum-icons/workflow/TableMergeCells";
import TableRowAddBottom from "@spectrum-icons/workflow/TableRowAddBottom";
import TableRowAddTop from "@spectrum-icons/workflow/TableRowAddTop";
import TableRowRemoveCenter from "@spectrum-icons/workflow/TableRowRemoveCenter";
import TableRowSplit from "@spectrum-icons/workflow/TableRowSplit";
import TagBold from "@spectrum-icons/workflow/TagBold";
import TagItalic from "@spectrum-icons/workflow/TagItalic";
import TagUnderline from "@spectrum-icons/workflow/TagUnderline";
import TextAlignCenter from "@spectrum-icons/workflow/TextAlignCenter";
import TextAlignJustify from "@spectrum-icons/workflow/TextAlignJustify";
import TextAlignLeft from "@spectrum-icons/workflow/TextAlignLeft";
import TextAlignRight from "@spectrum-icons/workflow/TextAlignRight";
import TextBulleted from "@spectrum-icons/workflow/TextBulleted";
import TextNumbered from "@spectrum-icons/workflow/TextNumbered";
import TextStrikethrough from "@spectrum-icons/workflow/TextStrikethrough";
import TextSubscript from "@spectrum-icons/workflow/TextSubscript";
import TextSuperscript from "@spectrum-icons/workflow/TextSuperscript";
import Undo from "@spectrum-icons/workflow/Undo";
import { parseDate, today, getLocalTimeZone, now, parseAbsoluteToLocal, parseDateTime, parseTime } from "@internationalized/date";
import maxBy from "lodash/maxBy";
import isArray from "lodash/isArray";
import isEmpty$1 from "lodash/isEmpty";
import { useEditor, EditorContent } from "@tiptap/react";
import Document from "@tiptap/extension-document";
import Focus from "@tiptap/extension-focus";
import Highlight from "@tiptap/extension-highlight";
import Image from "@tiptap/extension-image";
import Link$1 from "@tiptap/extension-link";
import Subscript from "@tiptap/extension-subscript";
import Superscript from "@tiptap/extension-superscript";
import Text$1 from "@tiptap/extension-text";
import TextAlign from "@tiptap/extension-text-align";
import TypographyExtension from "@tiptap/extension-typography";
import UnderlineExtension from "@tiptap/extension-underline";
import { Blockquote } from "@tiptap/extension-blockquote";
import { Bold } from "@tiptap/extension-bold";
import { BulletList } from "@tiptap/extension-bullet-list";
import { Code } from "@tiptap/extension-code";
import { CodeBlock } from "@tiptap/extension-code-block";
import { Dropcursor } from "@tiptap/extension-dropcursor";
import { HardBreak } from "@tiptap/extension-hard-break";
import { History } from "@tiptap/extension-history";
import { HorizontalRule } from "@tiptap/extension-horizontal-rule";
import { Italic } from "@tiptap/extension-italic";
import { ListItem } from "@tiptap/extension-list-item";
import { OrderedList } from "@tiptap/extension-ordered-list";
import { Strike } from "@tiptap/extension-strike";
import { Node, mergeAttributes, Mark } from "@tiptap/core";
import { Heading as Heading$1 } from "@tiptap/extension-heading";
import { Paragraph } from "@tiptap/extension-paragraph";
import { TextStyle } from "@tiptap/extension-text-style";
import Table from "@tiptap/extension-table";
import TableCell from "@tiptap/extension-table-cell";
import TableHeader from "@tiptap/extension-table-header";
import TableRow from "@tiptap/extension-table-row";
import startCase from "lodash/startCase";
import ArrayKeyedMap from "array-keyed-map";
import { useDrag } from "@use-gesture/react";
import { useSprings, useSpringRef, animated as animated$1 } from "@react-spring/web";
import CodeMirror from "@uiw/react-codemirror";
import { json, jsonParseLinter } from "@codemirror/lang-json";
import { linter, lintGutter } from "@codemirror/lint";
function DeleteDialog({
  cancelBtnText = "Cancel",
  confirmBtnText = "Delete",
  contentText = "Are you sure you wish to delete this item?",
  deleteModalOpen,
  headingText = "Delete Item?",
  onPressEndHandler,
  onPressStartHandler,
  setDeleteModalOpen
}) {
  return /* @__PURE__ */ jsx(DialogContainer, { onDismiss: () => setDeleteModalOpen(false), children: deleteModalOpen && /* @__PURE__ */ jsxs(Dialog, { children: [
    /* @__PURE__ */ jsx(Heading, { children: headingText }),
    /* @__PURE__ */ jsx(Divider, {}),
    /* @__PURE__ */ jsx(Content, { children: contentText }),
    /* @__PURE__ */ jsxs(ButtonGroup, { children: [
      /* @__PURE__ */ jsx(Button, { variant: "secondary", onPress: () => setDeleteModalOpen(false), children: cancelBtnText }),
      /* @__PURE__ */ jsx(
        Button,
        {
          autoFocus: true,
          variant: "cta",
          onPressStart: onPressStartHandler,
          onPressEnd: onPressEndHandler,
          children: confirmBtnText
        }
      )
    ] })
  ] }) });
}
const withAjvProps = (Component) => (props) => {
  const ctx = useJsonForms();
  const ajv = getAjv({ jsonforms: { ...ctx } });
  return /* @__PURE__ */ jsx(Component, { ...props, ajv });
};
const findAllItemsWithGivenPathRecursive = (obj, _path, result) => {
  if (obj) {
    if (obj._path === _path) {
      result.push(obj);
    }
    for (const value of Object.values(obj)) {
      if (typeof value === "object") {
        findAllItemsWithGivenPathRecursive(value, _path, result);
      }
    }
  }
};
const findAllItemsWithGivenPath = (data, _path) => {
  const result = [];
  findAllItemsWithGivenPathRecursive(data, _path, result);
  return result;
};
const allCopiesUpdater = (jsonPath, newData) => (data) => {
  const jsonPathSegments = jsonPath.split(".");
  let i = jsonPathSegments.length - 1;
  let changedCfPath = void 0;
  while (i >= 0) {
    changedCfPath = get(data, [...jsonPathSegments.slice(0, i), "_path"]);
    if (changedCfPath) {
      break;
    }
    --i;
  }
  if (i >= 0) {
    for (const item of findAllItemsWithGivenPath(data, changedCfPath)) {
      set(item, jsonPathSegments.slice(i, jsonPathSegments.length), newData);
    }
  } else {
    set(data, jsonPath, newData);
  }
  return data;
};
const ModalItemAnimationWrapper = ({
  children,
  elements,
  enableDetailedView = true,
  expanded,
  setExpanded,
  header,
  isAnimating,
  path,
  setIsAnimating
}) => {
  const [isBlackoutHovered, setIsBlackoutHovered] = React__default.useState(false);
  const [lockOverride, setLockOverride] = React__default.useState(false);
  const jsonFormWrapper = document.getElementById("jsonforms-wrapper") || document.getElementsByClassName("App-Form")[0];
  const addToZIndex = 2 * Math.round(((path == null ? void 0 : path.split(".").length) ?? 1) / 2);
  const leftOffset = (addToZIndex - 2) * 2.5;
  const onRestFunction = () => {
    setIsAnimating(false);
  };
  const modalHandler = (event) => {
    var _a, _b;
    if (event.data.type === "assetPickerClose") {
      setLockOverride(false);
    }
    if (event.data.type === "assetPickerOpen") {
      setLockOverride(true);
    }
    if ((_b = (_a = event == null ? void 0 : event.data) == null ? void 0 : _a.type) == null ? void 0 : _b.includes("customPicker")) {
      typeof event.data.open === "boolean" && setLockOverride(event.data.open);
    }
    return;
  };
  React__default.useEffect(() => {
    if (expanded) {
      window.addEventListener("message", modalHandler);
    } else {
      window.removeEventListener("message", modalHandler);
    }
    return () => window.removeEventListener("message", modalHandler);
  }, [expanded]);
  const slideAnim = useSpring({
    config: {
      duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : 700,
      easing: easings.easeOutQuart
    },
    left: expanded ? isBlackoutHovered && !isAnimating ? `${10 + leftOffset}%` : `${5 + leftOffset}%` : "100%",
    onRest: () => onRestFunction()
  });
  const darkenAnim = useSpring({
    config: {
      duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : 400,
      easing: easings.easeInOutCubic
    },
    opacity: expanded ? 0.5 : 0,
    display: expanded ? 1 : 0
  });
  return ReactDom.createPortal(
    /* @__PURE__ */ jsx(
      ReactFocusLock,
      {
        className: "spectrum-detailed-view-dialog-wrapper",
        disabled: !expanded || isAnimating || lockOverride,
        returnFocus: true,
        as: "div",
        shards: [document.getElementById("debug-menu-button")],
        children: /* @__PURE__ */ jsxs(
          "div",
          {
            className: `animated-modal-item animated-modal-wrapper ${expanded ? "expanded" : ""}`,
            style: {
              visibility: expanded || isAnimating ? "visible" : "collapse"
            },
            children: [
              /* @__PURE__ */ jsx(
                animated.div,
                {
                  className: `animated-modal-item animated-modal-item-div ${enableDetailedView ? "detailed-view" : ""}`,
                  style: enableDetailedView ? {
                    left: slideAnim.left,
                    zIndex: 8001 + addToZIndex,
                    width: `${95 - leftOffset}%`
                  } : {},
                  children: elements ? expanded || isAnimating ? /* @__PURE__ */ jsxs(View, { UNSAFE_className: "jsonforms-dispatch-wrapper", children: [
                    header,
                    /* @__PURE__ */ jsx(Content, { UNSAFE_className: "modal-element", children: elements })
                  ] }) : null : expanded || isAnimating ? children : null
                }
              ),
              /* @__PURE__ */ jsx(
                animated.div,
                {
                  onClick: () => expanded && setExpanded(false),
                  onMouseEnter: () => setIsBlackoutHovered(true),
                  onMouseLeave: () => setIsBlackoutHovered(false),
                  className: "animated-modal-item dark-background",
                  style: {
                    opacity: darkenAnim.opacity,
                    display: darkenAnim.display.to((e) => e > 0 ? "block" : "none"),
                    zIndex: 8e3 + addToZIndex,
                    cursor: expanded ? "pointer" : "default"
                  }
                }
              )
            ]
          }
        )
      }
    ),
    jsonFormWrapper || document.getElementById("root") || document.getElementById("__next") || document.body
  );
};
const areEqual = (prevProps, nextProps) => {
  return get(prevProps, "renderers.length") === get(nextProps, "renderers.length") && get(prevProps, "cells.length") === get(nextProps, "cells.length") && get(prevProps, "uischemas.length") === get(nextProps, "uischemas.length") && get(prevProps, "schema") === get(nextProps, "schema") && isEqual(get(prevProps, "uischema"), get(nextProps, "uischema")) && get(prevProps, "path") === get(nextProps, "path");
};
const circularReferenceReplacer = () => {
  const paths = /* @__PURE__ */ new Map();
  const finalPaths = /* @__PURE__ */ new Map();
  let root = null;
  return function(field, value) {
    const p = paths.get(this) + "/" + field;
    const isComplex = value === Object(value);
    if (isComplex)
      paths.set(value, p);
    const existingPath = finalPaths.get(value) || "";
    const path = p.replace(/undefined\/\/?/, "");
    let val = existingPath ? { $ref: `#/${existingPath}` } : value;
    if (!root) {
      root = value;
    } else if (val === root) {
      val = { $ref: "#/" };
    }
    if (!existingPath && isComplex)
      finalPaths.set(value, path);
    return val;
  };
};
const cssToObject = (cssString) => {
  let cssObject = {};
  let cssProperties = cssString.split(";");
  cssProperties.forEach((property) => {
    if (property.trim()) {
      let [name, value] = property.split(":");
      cssObject[name.trim()] = value.trim();
    }
  });
  return cssObject;
};
const objectToCss = (cssObject) => {
  let cssString = "";
  if (!cssObject) {
    return cssString;
  }
  Object.keys(cssObject).forEach((key) => {
    cssString += `${key}: ${cssObject[key]}; `;
  });
  return cssString.trim();
};
const dataTestId = (testId) => ({
  "data-test-id": testId
});
const useDebouncedChange = (handleChange, defaultValue, data, path) => {
  const timeout = 250;
  const [input, setInput] = React__default.useState(data ?? defaultValue);
  const debouncedUpdate = React__default.useCallback(
    debounce((newValue) => {
      handleChange(path, newValue);
    }, timeout),
    [handleChange, path, timeout]
  );
  React__default.useEffect(() => {
    setInput(data ?? defaultValue);
    debouncedUpdate(input);
  }, []);
  const onChange = React__default.useCallback(
    (value) => {
      setInput(value ?? defaultValue);
      debouncedUpdate(value);
    },
    [debouncedUpdate]
  );
  const onClear = React__default.useCallback(() => {
    setInput(defaultValue);
    handleChange(path, void 0);
  }, [defaultValue, handleChange, path]);
  return [input, onChange, onClear];
};
function dkuHandlePointer() {
  document.documentElement.classList.add("pointer-user");
  document.documentElement.classList.remove("keyboard-user");
  window.removeEventListener("mousedown", dkuHandlePointer, true);
  window.removeEventListener("touchstart", dkuHandlePointer, true);
  window.addEventListener("keydown", dkuHandleKeyboard, true);
}
function dkuHandleKeyboard(e) {
  if (e instanceof KeyboardEvent && e.key === "Tab") {
    document.documentElement.classList.add("keyboard-user");
    document.documentElement.classList.remove("pointer-user");
    window.removeEventListener("keydown", dkuHandleKeyboard, true);
    window.addEventListener("mousedown", dkuHandlePointer, true);
    window.addEventListener("touchstart", dkuHandlePointer, true);
  }
}
class DetectKeyboardUser {
  constructor() {
    this.init();
  }
  init() {
    document.documentElement.classList.add("pointer-user");
    window.addEventListener("touchstart", dkuHandleKeyboard, true);
    window.addEventListener("keydown", dkuHandleKeyboard, true);
  }
  destroy() {
    document.documentElement.classList.remove("pointer-user");
    document.documentElement.classList.remove("keyboard-user");
  }
  refresh() {
    this.destroy();
    this.init();
  }
}
const width = screen.availWidth;
const height = screen.availHeight;
function checkIfUserIsOnMobileDevice($userAgent) {
  if ($userAgent.includes("mobi") || $userAgent.includes("tablet")) {
    return true;
  }
  if ($userAgent.includes("android")) {
    if (height > width && width < 800) {
      return true;
    }
    if (width > height && height < 800) {
      return true;
    }
  }
  return false;
}
const ErrorIndicator = ({ errors }) => {
  return /* @__PURE__ */ jsxs(ContextualHelp, { variant: "info", children: [
    /* @__PURE__ */ jsx(Heading, { children: "Error" }),
    /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: errors }) })
  ] });
};
const findValue = (obj, key) => {
  if (!obj || !key) {
    return void 0;
  }
  if (Array.isArray(key)) {
    for (const k of key) {
      const result = findValue(obj, k);
      if (result) {
        return result;
      }
    }
    return void 0;
  }
  if (obj[key]) {
    return obj[key];
  }
  for (const prop in obj) {
    if (obj.hasOwnProperty(prop)) {
      if (typeof obj[prop] === "object") {
        const result = findValue(obj[prop], key);
        if (result) {
          return result;
        }
      }
    }
  }
};
const useFocus = () => {
  const [focused, setFocused] = React__default.useState(false);
  const onFocus = React__default.useCallback(() => setFocused(true), []);
  const onBlur = React__default.useCallback(() => setFocused(false), []);
  return [focused, onFocus, onBlur];
};
function isEmpty(obj) {
  return [Object, Array].includes((obj || {}).constructor) && !Object.keys(obj || {}).length;
}
const isoDateRegExp = new RegExp(
  /(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+([+-][0-2]\d:[0-5]\d|Z))|(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d([+-][0-2]\d:[0-5]\d|Z))|(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d([+-][0-2]\d:[0-5]\d|Z))/
);
const isISODate = (date) => {
  return isoDateRegExp.test(date);
};
const lengthErrorMessage = (minLength, maxLength) => {
  if (minLength && maxLength) {
    return `Must be between ${minLength} and ${maxLength} characters`;
  } else if (minLength) {
    if (minLength === 1) {
      return "Must be at least 1 character";
    }
    return `Must be at least ${minLength} characters`;
  } else if (maxLength) {
    return `Must not be longer than ${maxLength} characters`;
  }
};
const valueErrorMessage = (minValue, maxValue) => {
  if (minValue && maxValue) {
    return `Must be between ${minValue} and ${maxValue}`;
  } else if (minValue) {
    return `Must be at least ${minValue}`;
  } else if (maxValue) {
    return `Must not be more than ${maxValue}`;
  }
};
const resolveSubSchemas = (schema, rootSchema, keyword) => {
  const schemas = schema[keyword];
  if (schemas.findIndex((e) => e.$ref !== void 0) !== -1) {
    return {
      ...schema,
      [keyword]: schema[keyword].map(
        (e) => e.$ref ? resolveSchema(rootSchema, e.$ref, rootSchema) : e
      )
    };
  }
  return schema;
};
const settings = {
  toolTipDelay: 500
};
const withHandleChange = (Component) => (props) => {
  const ctx = useJsonForms();
  const dispatch = ctx.dispatch;
  const handleChange = React__default.useCallback(
    (path, data) => {
      if (dispatch) {
        dispatch(Actions.update("", allCopiesUpdater(path, data)));
      }
    },
    [dispatch]
  );
  return /* @__PURE__ */ jsx(Component, { ...props, handleChange });
};
const mapDispatchToArrayControlProps = (dispatch) => ({
  addItem: (path, value) => () => {
    dispatch(update(path, (array) => (array == null ? void 0 : array.length) ? [...array, value] : [value]));
  },
  removeItems: (path, toDelete) => () => {
    dispatch(update(path, (array) => array.filter((_, index) => !toDelete.includes(index))));
  },
  moveUp: (path, toMove) => () => {
    dispatch(
      update(
        path,
        (array) => toMove > 0 && toMove < array.length ? array.map(
          (_, index) => array[index > toMove || index < toMove - 1 ? index : index === toMove ? toMove - 1 : toMove]
        ) : array
      )
    );
  },
  moveDown: (path, toMove) => () => {
    dispatch(
      update(
        path,
        (array) => toMove < array.length - 1 ? array.map(
          (_, index) => array[index < toMove || index > toMove + 1 ? index : index === toMove ? toMove + 1 : toMove]
        ) : array
      )
    );
  }
});
const ctxDispatchToArrayControlProps = (dispatch) => ({
  ...ctxDispatchToControlProps(dispatch),
  ...React__default.useMemo(() => mapDispatchToArrayControlProps(dispatch), [dispatch])
});
const withContextToArrayControlProps = (Component) => ({ ctx, props }) => {
  const stateProps = ctxToArrayControlProps(ctx, props);
  const dispatchProps = ctxDispatchToArrayControlProps(ctx.dispatch);
  return /* @__PURE__ */ jsx(Component, { ...props, ...stateProps, ...dispatchProps });
};
const withJsonFormsArrayControlProps = (Component, memoize = true) => withJsonFormsContext(withContextToArrayControlProps(memoize ? React__default.memo(Component) : Component));
const ContextualHelpComponent = (uischema, schema, config) => {
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const contextualHelp = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.contextualHelp) ?? (schema == null ? void 0 : schema.fieldDescription);
  if (!contextualHelp) {
    return void 0;
  }
  return /* @__PURE__ */ jsxs(ContextualHelp, { variant: (contextualHelp == null ? void 0 : contextualHelp.variant) === "help" ? "help" : "info", children: [
    (contextualHelp == null ? void 0 : contextualHelp.title) && /* @__PURE__ */ jsx(Heading, { children: contextualHelp == null ? void 0 : contextualHelp.title }),
    /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: (schema == null ? void 0 : schema.fieldDescription) ?? (contextualHelp == null ? void 0 : contextualHelp.content) }) })
  ] });
};
const styles = "";
const SpectrumProvider = (props) => {
  let { children } = props;
  const parentProvider = useProvider();
  const theme = parentProvider ? parentProvider.theme : defaultTheme;
  var dku = new DetectKeyboardUser();
  React__default.useEffect(() => {
    dku.init();
  }, []);
  return /* @__PURE__ */ jsx(Provider, { ...props, theme, id: "SpectrumInputControlProvider", children });
};
const InputBooleanButton = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const autoFocus = !!appliedUiSchemaOptions.focus;
    let [isSelected, setSelected] = React__default.useState(data ?? (schema == null ? void 0 : schema.default) ?? false);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    React__default.useEffect(() => {
      handleChange(path, isSelected);
    }, [isSelected]);
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          "aria-label": label ? void 0 : path,
          autoFocus,
          id,
          isDisabled: enabled === void 0 ? false : !enabled,
          isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isSelected,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          onChange: setSelected,
          staticColor: appliedUiSchemaOptions.staticColor ?? false,
          width: width2,
          ...dataTestId(path),
          children: label
        }
      ),
      appliedUiSchemaOptions.description ? /* @__PURE__ */ jsx("div", { style: { fontStyle: "italic" }, children: appliedUiSchemaOptions.description }) : null,
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const InputCheckbox = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    let [isSelected, setSelected] = React__default.useState(data ?? (schema == null ? void 0 : schema.default) ?? false);
    React__default.useEffect(() => {
      handleChange(path, isSelected);
    }, [isSelected]);
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, children: [
      /* @__PURE__ */ jsx(
        Checkbox,
        {
          autoFocus: appliedUiSchemaOptions.focus,
          id,
          isDisabled: enabled === void 0 ? false : !enabled,
          isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
          isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
          isRequired: required,
          isSelected,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          onChange: setSelected,
          validationState: isValid ? "valid" : "invalid",
          value: data ?? (schema == null ? void 0 : schema.default),
          width: width2,
          ...dataTestId(path),
          children: label
        }
      ),
      appliedUiSchemaOptions.description ? /* @__PURE__ */ jsx("div", { style: { fontStyle: "italic" }, children: appliedUiSchemaOptions.description }) : null,
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const calculateLimit$1 = (value) => {
  if (value === "today") {
    return today(getLocalTimeZone());
  } else if (value) {
    return parseDate(value);
  }
};
const InputDate = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    var _a;
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = appliedUiSchemaOptions.maxValue;
    let minValue = appliedUiSchemaOptions.minValue;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const onChange = React__default.useCallback(
      (calendarDate) => {
        handleChange(path, calendarDate.toString());
      },
      [handleChange, path]
    );
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(SpectrumProvider, { width: width2, locale: appliedUiSchemaOptions.locale ?? "gregory", children: /* @__PURE__ */ jsx(
      DatePicker,
      {
        "aria-label": label ?? "Date picker",
        autoFocus: (uischema == null ? void 0 : uischema.options) && ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.focus),
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(calculateLimit$1(minValue), calculateLimit$1(maxValue)),
        granularity: "day",
        hideTimeZone: appliedUiSchemaOptions.hideTimeZone ?? true,
        id,
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        maxValue: calculateLimit$1(maxValue),
        maxVisibleMonths: appliedUiSchemaOptions.maxVisibleMonths ?? 1,
        maxWidth: "100%",
        minValue: calculateLimit$1(minValue),
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange,
        showFormatHelpText: appliedUiSchemaOptions.showFormatHelpText ?? false,
        value: data ? parseDate(data) : void 0,
        width: width2,
        ...dataTestId(path)
      }
    ) });
  }
);
const calculateLimit = (value, suffix) => {
  if (value === "now") {
    return now(getLocalTimeZone());
  } else if ((value == null ? void 0 : value.length) > 10) {
    return parseAbsoluteToLocal(value);
  } else if ((value == null ? void 0 : value.length) === 10) {
    return parseDateTime(value + suffix);
  } else {
    return void 0;
  }
};
const calculateMin = (value) => calculateLimit(value, "T00:00:00");
const calculateMax = (value) => calculateLimit(value, "T23:59:59");
const InputDateTime = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    var _a;
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = appliedUiSchemaOptions.maxValue;
    let minValue = appliedUiSchemaOptions.minValue;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const onChange = React__default.useCallback(
      (zonedDateTime) => {
        handleChange(path, zonedDateTime.toString().replace(/\[[^\]]*\]$/, ""));
      },
      [handleChange, path]
    );
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        if (schema.default === "now") {
          onChange(now(getLocalTimeZone()));
        } else {
          handleChange(path, schema.default);
        }
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(SpectrumProvider, { width: width2, locale: appliedUiSchemaOptions.locale ?? "gregory", children: /* @__PURE__ */ jsx(
      DatePicker,
      {
        "aria-label": label ?? "DateTime",
        autoFocus: (uischema == null ? void 0 : uischema.options) && ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.focus),
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(calculateMin(minValue), calculateMax(maxValue)),
        granularity: appliedUiSchemaOptions.granularity ?? "minute",
        hideTimeZone: appliedUiSchemaOptions.hideTimeZone ?? true,
        hourCycle: appliedUiSchemaOptions.hourCycle,
        id,
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        maxValue: calculateMin(minValue),
        maxVisibleMonths: appliedUiSchemaOptions.maxVisibleMonths ?? 1,
        minValue: calculateMax(maxValue),
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange,
        showFormatHelpText: appliedUiSchemaOptions.showFormatHelpText ?? false,
        value: data ? parseAbsoluteToLocal(data) : void 0,
        width: width2,
        ...dataTestId(path)
      }
    ) });
  }
);
const InputEnum = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    options,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    let [value, setValue] = React__default.useState(data ?? "");
    const isArray2 = (schema == null ? void 0 : schema.type) === "array";
    const handleOnChange = (myValue) => {
      if (typeof myValue === "object") {
        if (!allowMultipleTags && isArray2) {
          handleChange(path, [value]);
        } else {
          handleChange(path, value);
        }
        options == null ? void 0 : options.push({ value, label: value });
      } else {
        if (!allowMultipleTags && isArray2) {
          handleChange(path, [myValue]);
        } else {
          setValue(myValue);
          if (isArray2) {
            if (!((data == null ? void 0 : data.indexOf(myValue)) >= 0)) {
              if (data) {
                handleChange(path, [...data, myValue]);
              } else {
                handleChange(path, [myValue]);
              }
            }
            setTimeout(() => {
              setValue(null);
            }, 100);
          } else {
            handleChange(path, myValue);
          }
        }
      }
    };
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleOnChange(schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    label = label || "Enum";
    const deleteTag = (value2) => {
      handleChange(
        path,
        data.filter((item) => item !== value2)
      );
    };
    const findEnumSchema2 = (schemas) => {
      if (schemas !== void 0) {
        return schemas == null ? void 0 : schemas.find(
          (s) => s.enum !== void 0 && (s.type === "string" || s.type === void 0)
        );
      }
    };
    const tryEnumSchema = (anyOf) => {
      var _a;
      const enumSchema = findEnumSchema2(anyOf);
      return (_a = enumSchema == null ? void 0 : enumSchema.enum) == null ? void 0 : _a.map((v) => {
        return { value: v, label: v };
      });
    };
    const allowMultipleTags = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.allowMultipleTags) ?? true;
    const showAllOptions = appliedUiSchemaOptions.showAllOptions ?? false;
    const filteredOptions = options == null ? void 0 : options.filter((option) => {
      if (typeof data === "object" && data) {
        const values = Object.values(data);
        return !values.includes(option.value);
      }
      return !(data == null ? void 0 : data.includes(option.value));
    });
    const items = allowMultipleTags && isArray2 ? filteredOptions ?? tryEnumSchema(schema == null ? void 0 : schema.anyOf) : options;
    const isDisabled = allowMultipleTags && isArray2 && !showAllOptions && !(filteredOptions == null ? void 0 : filteredOptions.length) ? true : enabled === void 0 ? false : !enabled;
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, children: [
      appliedUiSchemaOptions.autocomplete === false ? /* @__PURE__ */ jsx(
        Picker,
        {
          align: appliedUiSchemaOptions.align ?? "start",
          "aria-label": label ?? "picker",
          autoFocus: appliedUiSchemaOptions.focus,
          contextualHelp: ContextualHelpComponent(uischema, schema, config),
          defaultOpen: appliedUiSchemaOptions.defaultOpen ?? false,
          description: appliedUiSchemaOptions.description ?? false,
          direction: appliedUiSchemaOptions.direction ?? "bottom",
          errorMessage: appliedUiSchemaOptions.errorMessage ?? false,
          id,
          isDisabled,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isRequired: required,
          items,
          label,
          labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
          labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
          menuWidth: appliedUiSchemaOptions.menuWidth ?? false,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
          onSelectionChange: handleOnChange,
          placeholder: appliedUiSchemaOptions.placeholder,
          selectedKey: !allowMultipleTags && isArray2 ? data[0] : isArray2 ? null : value,
          shouldFlip: appliedUiSchemaOptions.shouldFlip ?? true,
          width: width2,
          ...dataTestId(path),
          children: (item) => /* @__PURE__ */ jsx(
            Item,
            {
              children: item.label
            },
            item.value
          )
        },
        id
      ) : /* @__PURE__ */ jsx(
        ComboBox,
        {
          allowsCustomValue: appliedUiSchemaOptions.allowsCustomValue ?? false,
          "aria-label": label ?? "combobox",
          autoFocus: appliedUiSchemaOptions.focus,
          contextualHelp: ContextualHelpComponent(uischema, schema, config),
          defaultItems: items,
          description: appliedUiSchemaOptions.description ?? false,
          direction: appliedUiSchemaOptions.direction ?? "bottom",
          errorMessage: appliedUiSchemaOptions.errorMessage ?? false,
          id,
          isDisabled,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
          isRequired: required,
          label,
          labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
          labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
          menuTrigger: appliedUiSchemaOptions.menuTrigger ?? "input",
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
          onInputChange: data ? setValue : void 0,
          onSelectionChange: handleOnChange,
          selectedKey: !allowMultipleTags && isArray2 ? (data == null ? void 0 : data[0]) ?? null : isArray2 ? null : data ?? value,
          shouldFlip: appliedUiSchemaOptions.shouldFlip ?? true,
          shouldFocusWrap: appliedUiSchemaOptions.shouldFocusWrap ?? false,
          width: width2,
          ...dataTestId(path),
          children: (item) => /* @__PURE__ */ jsx(
            Item,
            {
              children: item.label
            },
            item.value
          )
        },
        id
      ),
      isArray2 && allowMultipleTags && /* @__PURE__ */ jsx(
        TagGroup,
        {
          items: data,
          allowsRemoving: true,
          onRemove: (key) => deleteTag(key),
          "aria-label": "TagGroup",
          ...dataTestId(path),
          children: data == null ? void 0 : data.map((item) => {
            const option = options == null ? void 0 : options.find((option2) => option2.value === item);
            if (option)
              return /* @__PURE__ */ jsx(
                Item,
                {
                  children: option == null ? void 0 : option.label
                },
                option == null ? void 0 : option.value
              );
          })
        }
      )
    ] });
  }
);
const InputInteger = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = schema.maximum;
    let minValue = schema.minimum;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const stepValue = appliedUiSchemaOptions.step ?? 1;
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(
      NumberField,
      {
        "aria-label": "integerfield" + label,
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        decrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Decrement -${stepValue}`,
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(minValue, maxValue),
        formatOptions: appliedUiSchemaOptions.formatOptions ?? false,
        hideStepper: appliedUiSchemaOptions.hideStepper ?? false,
        id,
        incrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Increment +${stepValue}`,
        isDisabled: enabled === void 0 ? false : !enabled,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        maxValue: schema.maximum,
        maxWidth: "100%",
        minValue: schema.minimum,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange: (value) => handleChange(path, value),
        step: stepValue,
        validationState: isValid ? "valid" : "invalid",
        value: data ?? schema.default,
        width: width2,
        ...dataTestId(path)
      }
    );
  }
);
const InputNumber = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = schema.maximum;
    let minValue = schema.minimum;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const stepValue = appliedUiSchemaOptions.step ?? 0.1;
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(
      NumberField,
      {
        "aria-label": "numberfield" + label,
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        decrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Decrement -${stepValue}`,
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(minValue, maxValue),
        formatOptions: appliedUiSchemaOptions.formatOptions ?? false,
        hideStepper: appliedUiSchemaOptions.hideStepper ?? false,
        id,
        incrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Increment +${stepValue}`,
        isDisabled: enabled === void 0 ? false : !enabled,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        maxValue: schema.maximum,
        maxWidth: "100%",
        minValue: schema.minimum,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange: (value) => handleChange(path, value),
        step: stepValue,
        validationState: isValid ? "valid" : "invalid",
        value: data ?? schema.default,
        width: width2,
        ...dataTestId(path)
      }
    );
  }
);
const InputRating = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const [hover, setHover] = React__default.useState(null);
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    let [selected, setSelected] = React__default.useState(data);
    const handleOnChange = (value) => {
      setSelected(value);
      handleChange(path, value);
    };
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleOnChange(schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(
      RadioGroup,
      {
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        id,
        isDisabled: enabled === void 0 ? false : !enabled,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange: handleOnChange,
        orientation: appliedUiSchemaOptions.orientation ?? "horizontal",
        validationState: isValid ? "valid" : "invalid",
        value: selected,
        width: width2,
        ...dataTestId(path),
        children: [...Array(schema.maximum ?? 5)].map((Stars, i) => {
          const ratingValue = i + 1;
          return /* @__PURE__ */ jsxs(
            "label",
            {
              onMouseEnter: () => setHover(ratingValue),
              onMouseLeave: () => setHover(null),
              children: [
                /* @__PURE__ */ jsx(
                  Radio,
                  {
                    value: "" + ratingValue,
                    isHidden: true,
                    "aria-label": "Rating " + ratingValue + "/" + (schema.maximum ?? 5) + ", currently selected value: " + data
                  }
                ),
                /* @__PURE__ */ jsx("span", { children: ratingValue <= (hover ?? data) ? /* @__PURE__ */ jsx(Star, { id: Stars, margin: "size-25", size: "S" }) : /* @__PURE__ */ jsx(StarOutline, { id: Stars, margin: "size-25", size: "S" }) })
              ]
            },
            ratingValue + "/" + (schema.maximum ?? 5)
          );
        })
      }
    );
  }
);
const InputSlider = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    label,
    path,
    schema,
    uischema,
    visible
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const [inputSlider, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? (schema == null ? void 0 : schema.minimum),
      data,
      path
    );
    return /* @__PURE__ */ jsx(
      Slider,
      {
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        fillOffset: appliedUiSchemaOptions.fillOffset ?? false,
        formatOptions: appliedUiSchemaOptions.formatOptions ?? false,
        getValueLabel: appliedUiSchemaOptions.getValueLabel ? (value) => `${value} ${appliedUiSchemaOptions.getValueLabel}` : void 0,
        isDisabled: enabled === void 0 ? false : !enabled,
        isFilled: appliedUiSchemaOptions.isFilled ?? false,
        isHidden: !visible,
        label,
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        maxValue: schema.maximum,
        minValue: schema.minimum,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        onChange,
        orientation: appliedUiSchemaOptions.orientation ?? "horizontal",
        showValueLabel: appliedUiSchemaOptions.showValueLabel ?? true,
        step: schema.multipleOf || 1,
        trackGradient: appliedUiSchemaOptions.trackGradient ?? false,
        value: inputSlider,
        width: width2,
        ...dataTestId(path)
      }
    );
  }
);
const InputSwitch = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    let [isSelected, setSelected] = React__default.useState(data ?? (schema == null ? void 0 : schema.default) ?? false);
    React__default.useEffect(() => {
      handleChange(path, isSelected);
    }, [isSelected]);
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, children: [
      /* @__PURE__ */ jsx(
        Switch,
        {
          autoFocus: appliedUiSchemaOptions.focus,
          id,
          isDisabled: enabled === void 0 ? false : !enabled,
          isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
          isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
          isSelected,
          onChange: setSelected,
          width: width2,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          ...dataTestId(path),
          children: label
        }
      ),
      appliedUiSchemaOptions.description ? /* @__PURE__ */ jsx("div", { style: { fontStyle: "italic" }, children: appliedUiSchemaOptions.description }) : null,
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const InputText = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    var _a;
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const minLength = (schema == null ? void 0 : schema.minLength) ?? appliedUiSchemaOptions.minLength ?? (required ? 1 : 0);
    const maxLength = (schema == null ? void 0 : schema.maxLength) ?? appliedUiSchemaOptions.maxLength;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const [inputText, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const isValidCheck = React__default.useMemo(() => {
      if (isValid && !inputText && minLength === 0) {
        return true;
      } else if (!inputText) {
        return false;
      } else if (isValid && inputText.length >= minLength && inputText.length <= (maxLength ?? Infinity)) {
        return true;
      } else {
        return false;
      }
    }, [inputText, minLength, maxLength, isValid]);
    const idlePostMessage = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.idlePostMessage;
    const sendMessage = React__default.useCallback(() => {
      const message = {
        type: "assetPickerOpen",
        jsonFormsPath: path
        /* rootPath: 'x_rootPath',
        selectedPath: '_path', */
      };
      const targetOrigin = "*";
      window.postMessage(message, targetOrigin);
    }, [path]);
    const assetPickerCloseHandler = React__default.useCallback(
      (e) => {
        var _a2, _b;
        if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) && ((_b = e == null ? void 0 : e.data) == null ? void 0 : _b.type) === "assetPickerClose") {
          if (e.data.jsonFormsPath !== path)
            return;
          onChange(e.data.selectedPath);
        }
      },
      [path]
    );
    React__default.useEffect(() => {
      window.addEventListener("message", assetPickerCloseHandler);
      return () => {
        window.removeEventListener("message", assetPickerCloseHandler);
      };
    }, [path]);
    const firstRender = React__default.useRef(true);
    if (idlePostMessage) {
      React__default.useEffect(() => {
        if (firstRender.current) {
          firstRender.current = false;
          return;
        }
        const delayDebounceFn = setTimeout(() => {
          sendMessage();
        }, 3e3);
        return () => clearTimeout(delayDebounceFn);
      }, [inputText]);
    }
    React__default.useEffect(() => {
      onChange(data);
    }, [data]);
    return /* @__PURE__ */ jsx(Flex, { direction: "row", alignItems: "stretch", flex: "auto inherit", children: /* @__PURE__ */ jsx(
      TextField,
      {
        "aria-label": label ? label : "textfield",
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? lengthErrorMessage(minLength, maxLength),
        id: id && `${id}-input`,
        inputMode: appliedUiSchemaOptions.inputMode ?? "none",
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        maxLength: appliedUiSchemaOptions.maxLength ?? void 0,
        minLength: appliedUiSchemaOptions.minLength ?? void 0,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange,
        type: appliedUiSchemaOptions.format ?? "text",
        validationState: isValidCheck ? "valid" : "invalid",
        value: inputText,
        width: width2,
        ...dataTestId(path)
      }
    ) });
  }
);
const InputTextAndButton = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _A;
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const minLength = (schema == null ? void 0 : schema.minLength) ?? appliedUiSchemaOptions.minLength ?? (required ? 1 : 0);
    const maxLength = (schema == null ? void 0 : schema.maxLength) ?? appliedUiSchemaOptions.maxLength;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const [inputText, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const isValidCheck = React__default.useMemo(() => {
      if (isValid && !inputText && minLength === 0) {
        return true;
      } else if (!inputText) {
        return false;
      } else if (isValid && inputText.length >= minLength && inputText.length <= (maxLength ?? Infinity)) {
        return true;
      } else {
        return false;
      }
    }, [inputText, minLength, maxLength, isValid]);
    const buttonTop = ((_b = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.buttons) == null ? void 0 : _b.top) ?? true;
    const buttonBottom = (_d = (_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.buttons) == null ? void 0 : _d.bottom;
    const previewMedia = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.previewMedia) ?? false;
    const externalizeAsset = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.externalizeAsset) ?? false;
    const previewMediaSuffix = typeof data === "string" ? data == null ? void 0 : data.substring((data == null ? void 0 : data.lastIndexOf(".")) + 1) : false;
    const idlePostMessage = (_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.idlePostMessage;
    const sendMessage = () => {
      const message = {
        type: "assetPickerOpen",
        jsonFormsPath: path
      };
      const targetOrigin = "*";
      window.postMessage(message, targetOrigin);
    };
    window.addEventListener("message", (e) => {
      var _a2, _b2, _c2, _d2;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) && ((_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.type) === ((_d2 = (_c2 = buttonTop == null ? void 0 : buttonTop.assetPicker) == null ? void 0 : _c2.receive) == null ? void 0 : _d2.type)) {
        onChange(e.data.data);
      }
    });
    window.addEventListener("message", (e) => {
      var _a2, _b2, _c2, _d2, _e2;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) && ((_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.type) === ((_e2 = (_d2 = (_c2 = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _c2.assetPicker) == null ? void 0 : _d2.receive) == null ? void 0 : _e2.type)) {
        onChange(e.data.data);
      }
    });
    window.addEventListener("message", (e) => {
      var _a2, _b2, _c2, _d2, _e2;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) && ((_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.type) === ((_e2 = (_d2 = (_c2 = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _c2.assetPicker) == null ? void 0 : _d2.receive) == null ? void 0 : _e2.type)) {
        onChange(e.data.data);
      }
    });
    const firstRender = React__default.useRef(true);
    if (idlePostMessage) {
      React__default.useEffect(() => {
        if (firstRender.current) {
          firstRender.current = false;
          return;
        }
        const delayDebounceFn = setTimeout(() => {
          sendMessage();
        }, 3e3);
        return () => clearTimeout(delayDebounceFn);
      }, [inputText]);
    }
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, children: [
      /* @__PURE__ */ jsxs(
        Flex,
        {
          direction: "row",
          alignItems: "stretch",
          flex: "auto inherit",
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          children: [
            /* @__PURE__ */ jsx(
              TextField,
              {
                "aria-label": label ? label : "textfield",
                autoFocus: appliedUiSchemaOptions.focus,
                contextualHelp: ContextualHelpComponent(uischema, schema, config),
                description: appliedUiSchemaOptions.description ?? false,
                errorMessage: appliedUiSchemaOptions.errorMessage ?? lengthErrorMessage(minLength, maxLength),
                id: id && `${id}-input`,
                inputMode: appliedUiSchemaOptions.inputMode ?? "none",
                isDisabled: enabled === void 0 ? false : !enabled,
                isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
                isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
                isRequired: required,
                label,
                labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
                labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
                maxLength: appliedUiSchemaOptions.maxLength ?? void 0,
                minLength: appliedUiSchemaOptions.minLength ?? void 0,
                necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
                onChange,
                type: appliedUiSchemaOptions.format ?? "text",
                validationState: isValidCheck ? "valid" : "invalid",
                value: inputText,
                width: width2,
                ...dataTestId(path)
              }
            ),
            buttonTop && /* @__PURE__ */ jsxs(
              ActionButton,
              {
                onPress: () => sendMessage(),
                "aria-label": (buttonTop == null ? void 0 : buttonTop.buttonText) ?? `Asset Picker`,
                UNSAFE_className: "assetpicker-button",
                UNSAFE_style: (buttonTop == null ? void 0 : buttonTop.icon) === false || !(buttonTop == null ? void 0 : buttonTop.text) ? void 0 : { paddingRight: 8 },
                marginTop: label ? "size-300" : "size-0",
                children: [
                  (buttonTop == null ? void 0 : buttonTop.icon) === false ? void 0 : ((_g = (_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.buttonTop) == null ? void 0 : _g.icon) === "url" ? /* @__PURE__ */ jsx(Link, { size: "S" }) : (buttonTop == null ? void 0 : buttonTop.icon) === "asset" ? /* @__PURE__ */ jsx(Asset, { size: "S" }) : (buttonTop == null ? void 0 : buttonTop.icon) === "folder" ? /* @__PURE__ */ jsx(FolderOpen, { size: "S" }) : (buttonTop == null ? void 0 : buttonTop.icon) === "edit" ? /* @__PURE__ */ jsx(Edit, { size: "S" }) : (buttonTop == null ? void 0 : buttonTop.icon) === "add" ? /* @__PURE__ */ jsx(Add, { size: "S" }) : /* @__PURE__ */ jsx(FolderSearch, { size: "S" }),
                  (buttonTop == null ? void 0 : buttonTop.text) ?? null
                ]
              }
            )
          ]
        }
      ),
      (buttonBottom == null ? void 0 : buttonBottom.left) && /* @__PURE__ */ jsxs(
        ActionButton,
        {
          onPress: () => sendMessage(),
          "aria-label": (buttonBottom == null ? void 0 : buttonBottom.buttonText) ?? `Asset Picker`,
          UNSAFE_className: "assetpicker-button-bottom",
          UNSAFE_style: ((_h = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _h.icon) === false || !((_i = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _i.text) ? void 0 : {
            paddingRight: 8
          },
          children: [
            (buttonBottom == null ? void 0 : buttonBottom.icon) === false ? void 0 : ((_l = (_k = (_j = uischema == null ? void 0 : uischema.options) == null ? void 0 : _j.buttonBottom) == null ? void 0 : _k.left) == null ? void 0 : _l.icon) === "url" ? /* @__PURE__ */ jsx(Link, { size: "S" }) : ((_m = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _m.icon) === "asset" ? /* @__PURE__ */ jsx(Asset, { size: "S" }) : ((_n = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _n.icon) === "folder" ? /* @__PURE__ */ jsx(FolderOpen, { size: "S" }) : ((_o = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _o.icon) === "edit" ? /* @__PURE__ */ jsx(Edit, { size: "S" }) : ((_p = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _p.icon) === "add" ? /* @__PURE__ */ jsx(Add, { size: "S" }) : /* @__PURE__ */ jsx(FolderSearch, { size: "S" }),
            ((_q = buttonBottom == null ? void 0 : buttonBottom.left) == null ? void 0 : _q.text) ?? null
          ]
        }
      ),
      (buttonBottom == null ? void 0 : buttonBottom.right) && /* @__PURE__ */ jsxs(
        ActionButton,
        {
          onPress: () => sendMessage(),
          "aria-label": (buttonBottom == null ? void 0 : buttonBottom.buttonText) ?? `Asset Picker`,
          UNSAFE_className: "assetpicker-button-bottom",
          UNSAFE_style: ((_r = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _r.icon) === false || !((_s = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _s.text) ? void 0 : { paddingRight: 8 },
          children: [
            (buttonBottom == null ? void 0 : buttonBottom.icon) === false ? void 0 : ((_v = (_u = (_t = uischema == null ? void 0 : uischema.options) == null ? void 0 : _t.buttonBottom) == null ? void 0 : _u.right) == null ? void 0 : _v.icon) === "url" ? /* @__PURE__ */ jsx(Link, { size: "S" }) : ((_w = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _w.icon) === "asset" ? /* @__PURE__ */ jsx(Asset, { size: "S" }) : ((_x = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _x.icon) === "folder" ? /* @__PURE__ */ jsx(FolderOpen, { size: "S" }) : ((_y = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _y.icon) === "edit" ? /* @__PURE__ */ jsx(Edit, { size: "S" }) : ((_z = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _z.icon) === "add" ? /* @__PURE__ */ jsx(Add, { size: "S" }) : /* @__PURE__ */ jsx(FolderSearch, { size: "S" }),
            ((_A = buttonBottom == null ? void 0 : buttonBottom.right) == null ? void 0 : _A.text) ?? null
          ]
        }
      ),
      previewMedia ? previewMediaSuffix === "mp4" || previewMediaSuffix === "ogg" || previewMediaSuffix === "webm" ? /* @__PURE__ */ jsxs(
        "video",
        {
          controls: true,
          src: externalizeAsset ? `${externalizeAsset}${data}` : data,
          width: 200,
          style: { marginTop: 10 },
          children: [
            'Sorry, but the Media "',
            data,
            `" couldn't be displayed.`
          ]
        }
      ) : /* @__PURE__ */ jsx(
        "img",
        {
          src: externalizeAsset ? `${externalizeAsset}${data}` : data,
          alt: `Preview of ${data}`,
          width: 200,
          style: { marginTop: 10 },
          onError: (e) => {
            e.currentTarget.src = "https://jenkinselite.com/wp-content/uploads/2018/11/no_media.png";
          }
        }
      ) : null
    ] });
  }
);
const InputTextArea = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const minLength = (schema == null ? void 0 : schema.minLength) ?? appliedUiSchemaOptions.minLength ?? (required ? 1 : 0);
    const maxLength = (schema == null ? void 0 : schema.maxLength) ?? appliedUiSchemaOptions.maxLength;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const [inputText, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const isValidCheck = React__default.useMemo(() => {
      if (isValid && !inputText && minLength === 0) {
        return true;
      } else if (!inputText) {
        return false;
      } else if (isValid && inputText.length >= minLength && inputText.length <= (maxLength ?? Infinity)) {
        return true;
      } else {
        return false;
      }
    }, [inputText, minLength, maxLength, isValid]);
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
    }, [!data, schema == null ? void 0 : schema.default]);
    React__default.useEffect(() => {
      onChange(data);
    }, [data]);
    return /* @__PURE__ */ jsx(
      TextArea,
      {
        "aria-label": label ? label : "textarea",
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? lengthErrorMessage(minLength, maxLength),
        height: "auto",
        id: id && `${id}-input`,
        inputMode: appliedUiSchemaOptions.inputMode ?? "none",
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        maxHeight: appliedUiSchemaOptions.maxHeight ?? "45vh",
        maxLength: appliedUiSchemaOptions.maxLength ?? void 0,
        minLength: appliedUiSchemaOptions.minLength ?? void 0,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange,
        type: appliedUiSchemaOptions.format ?? "text",
        validationState: isValidCheck ? "valid" : "invalid",
        value: inputText,
        width: width2,
        ...dataTestId(path)
      }
    );
  }
);
const prependZero = (number) => number.toString().padStart(2, "0");
const InputTime = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const onChange = React__default.useCallback(
      (dateTime) => {
        handleChange(
          path,
          [
            prependZero(dateTime.hour),
            prependZero(dateTime.minute),
            prependZero(dateTime.second)
          ].join(":")
        );
      },
      [handleChange, path]
    );
    const ampm = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.ampm) ? 12 : 24;
    return /* @__PURE__ */ jsx(SpectrumProvider, { width: width2, locale: appliedUiSchemaOptions.locale ?? "gregory", children: /* @__PURE__ */ jsx(
      TimeField,
      {
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        granularity: appliedUiSchemaOptions.granularity ?? "minute",
        hideTimeZone: appliedUiSchemaOptions.hideTimeZone ?? true,
        hourCycle: ampm,
        id,
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
        labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        width: width2,
        minValue: appliedUiSchemaOptions.minValue ? parseTime(appliedUiSchemaOptions.minValue) : void 0,
        maxValue: appliedUiSchemaOptions.maxValue ? parseTime(appliedUiSchemaOptions.maxValue) : void 0,
        value: data ? parseTime(data) : void 0,
        onChange,
        ...dataTestId(path)
      }
    ) });
  }
);
const Label = React__default.memo(({ config, uischema }) => {
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
  const heading = appliedUiSchemaOptions.heading ?? false;
  const headingLevel = appliedUiSchemaOptions.headingLevel ?? 2;
  const content = appliedUiSchemaOptions.content ?? false;
  return /* @__PURE__ */ jsxs(Flex, { direction: "column", alignItems: "stretch", flex: "auto inherit", width: width2, children: [
    heading && /* @__PURE__ */ jsx(Heading, { level: headingLevel, children: heading }),
    content && /* @__PURE__ */ jsx(Content, { children: content })
  ] });
});
const MediaPreview = React__default.memo(
  ({ config, data, uischema, schema }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, children: [
      /* @__PURE__ */ jsxs(
        Flex,
        {
          alignItems: appliedUiSchemaOptions.alignItems ?? "start",
          direction: appliedUiSchemaOptions.flex ?? "column",
          gap: appliedUiSchemaOptions.gap ?? "size-0",
          marginTop: appliedUiSchemaOptions.marginTop ?? "size-100",
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          children: [
            /* @__PURE__ */ jsx(
              "img",
              {
                src: data,
                height: appliedUiSchemaOptions.height ?? "auto",
                width: appliedUiSchemaOptions.width ?? "auto",
                style: {
                  maxWidth: appliedUiSchemaOptions.maxWidth ?? "100%",
                  maxHeight: appliedUiSchemaOptions.maxHeight ?? "70vh",
                  objectFit: "scale-down"
                }
              }
            ),
            appliedUiSchemaOptions.description === true ? data.alt : appliedUiSchemaOptions.description ?? null
          ]
        }
      ),
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const SpectrumBooleanButtonCell = (props) => /* @__PURE__ */ jsx(InputBooleanButton, { ...props });
const SpectrumBooleanButtonCellTester = rankWith(
  4,
  and(isBooleanControl, optionIs("button", true))
);
const SpectrumBooleanButtonCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumBooleanButtonCell));
const SpectrumBooleanCell = (props) => {
  const { data, id, enabled, uischema, path, handleChange, config } = props;
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const autoFocus = !!appliedUiSchemaOptions.focus;
  const isSelected = !!data;
  const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
  return /* @__PURE__ */ jsx(
    Switch,
    {
      isSelected,
      onChange: (selected) => handleChange(path, selected),
      id,
      isDisabled: enabled === void 0 ? false : !enabled,
      autoFocus,
      width: width2,
      "aria-label": props.children ? void 0 : path,
      children: props.children
    }
  );
};
const SpectrumBooleanCellTester = rankWith(
  3,
  and(isBooleanControl, optionIs("switch", true))
);
const SpectrumBooleanCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumBooleanCell));
const SpectrumCheckboxCell = (props) => /* @__PURE__ */ jsx(InputCheckbox, { ...props });
const SpectrumCheckboxCellTester = rankWith(2, isBooleanControl);
const SpectrumCheckboxCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumCheckboxCell));
const SpectrumEnumCell = (props) => /* @__PURE__ */ jsx(InputEnum, { ...props });
const SpectrumEnumCellTester = rankWith(2, isEnumControl);
const SpectrumEnumCell$1 = withJsonFormsEnumCellProps(withHandleChange(SpectrumEnumCell));
const SpectrumIntegerCell = (props) => /* @__PURE__ */ jsx(InputInteger, { ...props });
const SpectrumIntegerCellTester = rankWith(2, isIntegerControl);
const SpectrumIntegerCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumIntegerCell));
const SpectrumNumberCell = (props) => /* @__PURE__ */ jsx(InputNumber, { ...props });
const SpectrumNumberCellTester = rankWith(2, isNumberControl);
const SpectrumNumberCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumNumberCell));
const SpectrumRatingCell = (props) => /* @__PURE__ */ jsx(InputRating, { ...props });
rankWith(
  2,
  and(isIntegerControl, optionIs("rating", true))
);
withJsonFormsCellProps(withHandleChange(SpectrumRatingCell));
const SpectrumSliderCell = (props) => /* @__PURE__ */ jsx(InputSlider, { ...props });
const SpectrumSliderCellTester = rankWith(4, isRangeControl);
const SpectrumSliderCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumSliderCell));
const SpectrumSwitchCell = (props) => /* @__PURE__ */ jsx(InputSwitch, { ...props });
const SpectrumSwitchCellTester = rankWith(
  3,
  and(isBooleanControl, optionIs("toggle", true))
);
const SpectrumSwitchCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumSwitchCell));
const SpectrumTextAreaCell = (props) => /* @__PURE__ */ jsx(InputTextArea, { ...props });
const SpectrumTextAreaCellTester = rankWith(2, isMultiLineControl);
const SpectrumTextAreaCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumTextAreaCell));
const SpectrumTextCell = (props) => /* @__PURE__ */ jsx(InputText, { ...props });
const SpectrumTextCellTester = rankWith(1, isStringControl);
const SpectrumTextCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumTextCell));
const CustomizableCells = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  SpectrumBooleanButtonCell,
  SpectrumBooleanCell,
  SpectrumCheckboxCell,
  SpectrumEnumCell,
  SpectrumIntegerCell,
  SpectrumNumberCell,
  SpectrumRatingCell,
  SpectrumSliderCell,
  SpectrumSwitchCell,
  SpectrumTextAreaCell,
  SpectrumTextCell
}, Symbol.toStringTag, { value: "Module" }));
const SpectrumInputControl = (props) => {
  const [focused, onFocus, onBlur] = useFocus();
  const { description, id, errors, uischema, visible, config, input, customError = false } = props;
  const InnerComponent = input;
  const isValid = errors.length === 0;
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const showDescription = !isDescriptionHidden(
    appliedUiSchemaOptions.showUnfocusedDescription,
    description,
    focused,
    visible
  );
  const showErrors = !isValid && customError;
  return /* @__PURE__ */ jsx(
    "div",
    {
      onFocus,
      onBlur,
      hidden: visible === void 0 || visible === null ? false : !visible,
      id,
      children: /* @__PURE__ */ jsxs(Flex, { direction: "column", children: [
        /* @__PURE__ */ jsx(InnerComponent, { ...props, id: id && `${id}-input`, isValid }),
        customError && /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsx(Text, { children: showErrors ? errors : showDescription ? description : null }) })
      ] })
    }
  );
};
const SpectrumEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const SpectrumEnumControlTester = rankWith(7, isEnumControl);
const SpectrumEnumControl$1 = withJsonFormsEnumProps(withHandleChange(SpectrumEnumControl));
const InputControl = ({
  cells,
  config,
  description,
  errors,
  id,
  path,
  rootSchema,
  schema,
  uischema,
  visible
}) => {
  const [focused, onFocus, onBlur] = useFocus();
  const classNames = {
    wrapper: "control",
    description: "input-description"
  };
  const isValid = errors.length === 0;
  const divClassNames = `validation  ${isValid ? classNames.description : "validation_error"}`;
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const showDescription = !isDescriptionHidden(
    visible,
    description,
    focused,
    appliedUiSchemaOptions.showUnfocusedDescription
  );
  const cell = maxBy(cells, (r) => r.tester(uischema, schema, rootSchema));
  if (cell === void 0 || cell.tester(uischema, schema, rootSchema) === NOT_APPLICABLE) {
    console.warn("No applicable cell found.", uischema, schema);
    return null;
  } else {
    return /* @__PURE__ */ jsx(
      "div",
      {
        className: classNames.wrapper,
        hidden: !visible,
        onFocus,
        onBlur,
        id,
        children: /* @__PURE__ */ jsxs(Flex, { direction: "column", children: [
          /* @__PURE__ */ jsx(DispatchCell, { uischema, schema, path, id: id && `${id}-input` }),
          /* @__PURE__ */ jsx("div", { className: divClassNames, children: /* @__PURE__ */ jsx(Text, { children: !isValid ? errors : showDescription ? description : null }) })
        ] })
      }
    );
  }
};
const inputControlTester = rankWith(1, isControl);
const InputControl$1 = withJsonFormsControlProps(withHandleChange(InputControl));
const MediaPreviewControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: MediaPreview });
const MediaPreviewControlTester = rankWith(4, optionIs("mediaPreview", true));
const MediaPreviewControl$1 = withJsonFormsControlProps(withHandleChange(MediaPreviewControl));
const findEnumSchema = (schemas) => schemas.find((s) => s.enum !== void 0 && (s.type === "string" || s.type === void 0));
const findTextSchema = (schemas) => schemas.find((s) => s.type === "string" && s.enum === void 0);
const SpectrumAnyOfStringOrEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const hasEnumAndText = (schemas) => {
  const enumSchema = findEnumSchema(schemas);
  const stringSchema = findTextSchema(schemas);
  const remainingSchemas = schemas.filter((s) => s !== enumSchema || s !== stringSchema);
  const wrongType = remainingSchemas.find((s) => s.type && s.type !== "string");
  return enumSchema && stringSchema && !wrongType;
};
const simpleAnyOf = and(
  uiTypeIs("Control"),
  schemaMatches((schema) => (schema == null ? void 0 : schema.hasOwnProperty("anyOf")) && hasEnumAndText(schema == null ? void 0 : schema.anyOf))
);
const SpectrumAnyOfStringOrEnumControlTester = rankWith(5, simpleAnyOf);
const SpectrumAnyOfStringOrEnumControl$1 = withJsonFormsEnumProps(withHandleChange(SpectrumAnyOfStringOrEnumControl));
const SpectrumBooleanControl = ({
  config,
  data,
  enabled,
  errors,
  handleChange,
  id,
  label,
  path,
  rootSchema,
  schema,
  uischema,
  visible
}) => {
  return /* @__PURE__ */ jsxs("div", { children: [
    /* @__PURE__ */ jsx(
      SpectrumBooleanCell,
      {
        config,
        data,
        enabled,
        errors,
        handleChange,
        id: id && `${id}-input`,
        isValid: isEmpty(errors),
        path,
        rootSchema,
        schema,
        uischema,
        visible
      }
    ),
    label
  ] });
};
const SpectrumBooleanControlTester = rankWith(
  3,
  and(isBooleanControl, optionIs("switch", true))
);
const SpectrumBooleanControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumBooleanControl));
const SpectrumBooleanButtonControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputBooleanButton });
const SpectrumBooleanButtonControlTester = rankWith(
  4,
  and(isBooleanControl, optionIs("button", true))
);
const SpectrumBooleanButtonControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumBooleanButtonControl));
const SpectrumCheckboxControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputCheckbox });
const SpectrumCheckboxControlTester = rankWith(2, isBooleanControl);
const SpectrumCheckboxControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumCheckboxControl));
const SpectrumSwitchControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputSwitch });
const SpectrumSwitchControlTester = rankWith(
  3,
  and(isBooleanControl, optionIs("toggle", true))
);
const SpectrumSwitchControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumSwitchControl));
const SpectrumIntegerControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputInteger });
const SpectrumIntegerControlTester = rankWith(3, isIntegerControl);
const SpectrumIntegerControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumIntegerControl));
const SpectrumRadioGroup = (props) => {
  const { config, handleChange, label, options, path, required, uischema, visible } = props;
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  return /* @__PURE__ */ jsx(View, { isHidden: visible === void 0 || visible === null ? false : !visible, children: options && /* @__PURE__ */ jsx(
    RadioGroup,
    {
      "aria-label": "radiogroup" + props.data,
      isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
      isRequired: required,
      label,
      labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
      labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
      necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? null,
      onChange: (ev) => handleChange(path, ev),
      orientation: appliedUiSchemaOptions.orientation ?? "vertical",
      value: props.data,
      ...dataTestId(path),
      children: options == null ? void 0 : options.map((option) => /* @__PURE__ */ jsx(Radio, { value: option.value, ...dataTestId(option.value), children: option.label }, option.label))
    }
  ) });
};
const SpectrumRadioGroupControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumRadioGroup, { ...props });
};
const SpectrumRadioGroupControlTester = rankWith(
  20,
  and(isEnumControl, optionIs("format", "radio"))
);
const SpectrumRadioGroupControl$1 = withJsonFormsEnumProps(withHandleChange(SpectrumRadioGroupControl));
const SpectrumRatingControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputRating });
const SpectrumRatingControlTester = rankWith(
  4,
  and(isIntegerControl, optionIs("rating", true))
);
const SpectrumRatingControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumRatingControl));
const SpectrumNumberControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputNumber });
const SpectrumNumberControlTester = rankWith(3, isNumberControl);
const SpectrumNumberControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumNumberControl));
const SpectrumOneOfEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const SpectrumOneOfEnumControlTester = rankWith(5, isOneOfEnumControl);
const SpectrumOneOfEnumControl$1 = withJsonFormsOneOfEnumProps(withHandleChange(SpectrumOneOfEnumControl));
const SpectrumMultiOneOfEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const isMultiOneOfEnumControl = and(
  uiTypeIs("Control"),
  schemaTypeIs("array"),
  schemaMatches(
    (schema) => {
      var _a, _b;
      return (_b = (_a = schema == null ? void 0 : schema.items) == null ? void 0 : _a.oneOf) == null ? void 0 : _b.every((s) => s.const !== void 0);
    }
  )
);
const isMultiEnumControl = and(
  uiTypeIs("Control"),
  schemaTypeIs("array"),
  schemaMatches((schema) => {
    var _a, _b;
    return ((_a = schema == null ? void 0 : schema.items) == null ? void 0 : _a.type) === "string" && isArray((_b = schema == null ? void 0 : schema.items) == null ? void 0 : _b.enum);
  })
);
const SpectrumMultiOneOfEnumControlTester = rankWith(
  5,
  or(isMultiOneOfEnumControl, isMultiEnumControl)
);
const SpectrumMultiOneOfEnumControl$1 = withJsonFormsMultiEnumProps(withHandleChange(SpectrumMultiOneOfEnumControl));
const SpectrumOneOfRadioGroupControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumRadioGroup, { ...props });
};
const SpectrumOneOfRadioGroupControlTester = rankWith(
  20,
  and(isOneOfEnumControl, optionIs("format", "radio"))
);
const SpectrumOneOfRadioGroupControl$1 = withJsonFormsOneOfEnumProps(withHandleChange(SpectrumOneOfRadioGroupControl));
const SpectrumSliderControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputSlider });
const SpectrumSliderControlTester = rankWith(4, isRangeControl);
const SpectrumSliderControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumSliderControl));
const getNodeName$1 = (editor, tag) => {
  if (tag) {
    if (tag.startsWith("h") && tag.length === 2) {
      return "heading";
    } else if (tag === "blockquote") {
      return "blockquote";
    } else if (tag === "span") {
      return "span";
    } else {
      return "paragraph";
    }
  } else {
    if (editor.isActive("heading")) {
      return "heading";
    } else if (editor.isActive("blockquote")) {
      return "blockquote";
    } else if (editor.isActive("span")) {
      return "span";
    } else {
      return "paragraph";
    }
  }
};
function HeadingToolbarButtons({
  editor,
  readOnly
}) {
  const currentText = () => {
    if (editor.isActive("heading")) {
      "H" + editor.getAttributes("heading").level;
    } else if (editor.isActive("blockquote"))
      ;
    else
      ;
  };
  let options = [
    { name: "Paragraph" },
    { name: "H2" },
    { name: "H3" },
    { name: "H4" },
    { name: "H5" },
    { name: "H6" },
    { name: "Blockquote" }
  ];
  let [heading, setHeading] = React__default.useState(null);
  const pickerChange = (selected) => {
    setHeading(selected);
    switch (selected) {
      case "Paragraph":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "p"
        }).unsetBlockquote().run();
        break;
      case "H1":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h1",
          level: 1
        }).unsetBlockquote().run();
        break;
      case "H2":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class ?? void 0,
          tag: "h2",
          level: 2
        }).unsetBlockquote().run();
        break;
      case "H3":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h3",
          level: 3
        }).unsetBlockquote().run();
        break;
      case "H4":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h4",
          level: 4
        }).unsetBlockquote().run();
        break;
      case "H5":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h5",
          level: 5
        }).unsetBlockquote().run();
        break;
      case "H6":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h6",
          level: 6
        }).unsetBlockquote().run();
        break;
      case "Blockquote":
        editor.chain().focus().setParagraph().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "blockquote"
        }).run();
        break;
    }
  };
  React__default.useEffect(() => {
    setHeading(
      editor.isActive("heading") ? "H" + editor.getAttributes("heading").level : editor.isActive("blockquote") ? "Blockquote" : "Paragraph"
    );
  }, [editor, currentText]);
  return /* @__PURE__ */ jsx(Flex, { alignItems: "center", children: /* @__PURE__ */ jsx(
    Picker,
    {
      "aria-label": "Picker",
      label: false,
      items: options,
      selectedKey: heading,
      onSelectionChange: (selected) => pickerChange(selected),
      maxWidth: "size-1600",
      isDisabled: readOnly,
      children: (item) => /* @__PURE__ */ jsx(Item, { children: item.name }, item.name)
    }
  ) });
}
function TablePropertiesMenu({
  readOnly,
  editor
}) {
  const [open, setOpen] = React__default.useState(false);
  const [forceOpen, setForceOpen] = React__default.useState(false);
  React__default.useEffect(() => {
    if (forceOpen) {
      setForceOpen(false);
    }
  }, [forceOpen]);
  const tableAttributes = editor.getAttributes("table");
  const cellType = !isEmpty$1(editor.getAttributes("tableHeader")) ? "tableHeader" : "tableCell";
  const cellAttributes = editor.getAttributes(cellType);
  const updateAttributesOf = (element, object) => {
    editor.chain().updateAttributes(element, object).run();
  };
  const toggleStyle = (styleString, newStyle) => {
    let cssObj = cssToObject(styleString);
    let [name, value] = newStyle.replace(";", "").split(":");
    if (value.trim() === "unset") {
      delete cssObj[name];
      return objectToCss(cssObj);
    }
    cssObj = { ...cssObj, [name.trim()]: value.trim() };
    return objectToCss(cssObj);
  };
  const captionText = () => {
    var _a, _b, _c, _d, _e;
    const path = (_c = (_b = (_a = editor == null ? void 0 : editor.state) == null ? void 0 : _a.selection) == null ? void 0 : _b.$head) == null ? void 0 : _c.path;
    let tableNode;
    for (let i = 0; i < path.length; i++) {
      if (((_e = (_d = path[i]) == null ? void 0 : _d.type) == null ? void 0 : _e.name) === "table") {
        tableNode = path[i];
        break;
      }
    }
    if (!tableNode) {
      return "";
    }
    const tableContent = tableNode.content.content;
    if (tableContent[0].type.name === "caption") {
      return tableContent[0].textContent;
    }
    return "";
  };
  return /* @__PURE__ */ jsxs(
    DialogTrigger,
    {
      type: "popover",
      isOpen: open || forceOpen,
      onOpenChange: (isOpen) => {
        if (!forceOpen) {
          setOpen(isOpen);
        }
      },
      children: [
        /* @__PURE__ */ jsx(ActionButton, { "aria-label": "tableProperties", isDisabled: readOnly, children: /* @__PURE__ */ jsx(Properties, {}) }),
        /* @__PURE__ */ jsx(Dialog, { children: /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsxs(Tabs, { "aria-label": "Cell or Table Properties", children: [
          /* @__PURE__ */ jsxs(TabList, { children: [
            /* @__PURE__ */ jsx(Item, { children: "Cell Properties" }, "cellProperties"),
            /* @__PURE__ */ jsx(Item, { children: "Table Properties" }, "tableProperties")
          ] }),
          /* @__PURE__ */ jsxs(TabPanels, { children: [
            /* @__PURE__ */ jsx(Item, { children: /* @__PURE__ */ jsxs(Flex, { direction: "column", gap: 10, children: [
              /* @__PURE__ */ jsxs(Flex, { alignItems: "center", gap: 10, children: [
                /* @__PURE__ */ jsx(
                  TextField,
                  {
                    "aria-label": "width",
                    defaultValue: cellAttributes.width,
                    label: "Width",
                    onChange: (value) => updateAttributesOf(cellType, { width: value }),
                    contextualHelp: /* @__PURE__ */ jsx(ContextualHelp, { variant: "info", placement: "top start", children: /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: 'Width in pixels. For relative values add "%" e.g. "40%"' }) }) })
                  }
                ),
                /* @__PURE__ */ jsx(
                  TextField,
                  {
                    "aria-label": "height",
                    defaultValue: cellAttributes.height,
                    label: "Height",
                    onChange: (value) => updateAttributesOf(cellType, { height: value }),
                    contextualHelp: /* @__PURE__ */ jsx(ContextualHelp, { variant: "info", placement: "top start", children: /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: 'Width in pixels. For relative values add "%" e.g. "40%"' }) }) })
                  }
                )
              ] }),
              /* @__PURE__ */ jsxs(Flex, { alignItems: "center", justifyContent: "space-between", children: [
                /* @__PURE__ */ jsxs(
                  Picker,
                  {
                    "aria-label": "horizontalAlign",
                    defaultSelectedKey: cellAttributes.style || "text-align: unset;",
                    label: "Horizontal Align",
                    marginEnd: 10,
                    onSelectionChange: (value) => updateAttributesOf(cellType, {
                      style: toggleStyle(cellAttributes.style, value)
                    }),
                    children: [
                      /* @__PURE__ */ jsx(Item, { children: "None" }, "text-align: unset;"),
                      /* @__PURE__ */ jsx(Item, { children: "Left" }, "text-align: left;"),
                      /* @__PURE__ */ jsx(Item, { children: "Center" }, "text-align: center;"),
                      /* @__PURE__ */ jsx(Item, { children: "Right" }, "text-align: right;")
                    ]
                  }
                ),
                /* @__PURE__ */ jsxs(
                  Picker,
                  {
                    "aria-label": "verticalAlign",
                    defaultSelectedKey: cellAttributes.valign || "unset",
                    label: "Vertical Align",
                    onSelectionChange: (value) => updateAttributesOf(cellType, { valign: value }),
                    children: [
                      /* @__PURE__ */ jsx(Item, { children: "None" }, "unset"),
                      /* @__PURE__ */ jsx(Item, { children: "Top" }, "top"),
                      /* @__PURE__ */ jsx(Item, { children: "Middle" }, "middle"),
                      /* @__PURE__ */ jsx(Item, { children: "Bottom" }, "bottom"),
                      /* @__PURE__ */ jsx(Item, { children: "Baseline" }, "baseline")
                    ]
                  }
                )
              ] }),
              /* @__PURE__ */ jsxs(
                Picker,
                {
                  label: "Cell Type",
                  "aria-label": "cellType",
                  defaultSelectedKey: cellType || "tableCell",
                  onSelectionChange: (value) => {
                    if (value !== cellType) {
                      editor.chain().toggleHeaderCell().run();
                    }
                  },
                  children: [
                    /* @__PURE__ */ jsx(Item, { children: "Data" }, "tableCell"),
                    /* @__PURE__ */ jsx(Item, { children: "Header" }, "tableHeader")
                  ]
                }
              ),
              cellType === "tableHeader" && /* @__PURE__ */ jsxs(Flex, { alignItems: "end", justifyContent: "space-between", children: [
                /* @__PURE__ */ jsx(
                  TextField,
                  {
                    width: 150,
                    label: "Id",
                    "aria-label": "id",
                    defaultValue: cellAttributes.id,
                    onChange: (value) => updateAttributesOf(cellType, { id: value })
                  }
                ),
                /* @__PURE__ */ jsx(
                  Switch,
                  {
                    "aria-label": "hiddenHeader",
                    onChange: (value) => {
                      updateAttributesOf(cellType, {
                        hiddenheader: value,
                        style: toggleStyle(
                          cellAttributes.style,
                          value ? "background-color: rgb(215,215,215);" : "background-color: unset;"
                        )
                      });
                    },
                    children: "Hidden Header"
                  }
                )
              ] }),
              /* @__PURE__ */ jsxs(
                Picker,
                {
                  label: "Scope",
                  "aria-label": "scope",
                  defaultSelectedKey: cellAttributes.scope || "none",
                  onSelectionChange: (value) => updateAttributesOf(cellType, { scope: value }),
                  children: [
                    /* @__PURE__ */ jsx(Item, { children: "Scope" }, "none"),
                    /* @__PURE__ */ jsx(Item, { children: "Column" }, "col"),
                    /* @__PURE__ */ jsx(Item, { children: "Row" }, "row")
                  ]
                }
              )
            ] }) }, "cellProperties"),
            /* @__PURE__ */ jsxs(Item, { children: [
              /* @__PURE__ */ jsxs(Flex, { gap: 20, children: [
                /* @__PURE__ */ jsxs(Flex, { direction: "column", gap: 10, width: "30%", wrap: "wrap", children: [
                  /* @__PURE__ */ jsx(
                    TextField,
                    {
                      label: "Width",
                      "aria-label": "width",
                      defaultValue: tableAttributes.width,
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { width: value })
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    TextField,
                    {
                      label: "Height",
                      "aria-label": "height",
                      defaultValue: tableAttributes.height,
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { height: value })
                    }
                  )
                ] }),
                /* @__PURE__ */ jsxs(Grid, { columns: ["1fr", "1fr"], gap: 10, alignItems: "end", width: "70%", children: [
                  /* @__PURE__ */ jsx(
                    NumberField,
                    {
                      label: "Cell Padding",
                      "aria-label": "cellPadding",
                      defaultValue: Number(tableAttributes.cellPadding),
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { cellPadding: value })
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    NumberField,
                    {
                      label: "Border",
                      "aria-label": "border",
                      defaultValue: Number(tableAttributes.border),
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { border: value })
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    NumberField,
                    {
                      label: "Cell Spacing",
                      "aria-label": "callSpacing",
                      defaultValue: Number(tableAttributes.cellSpacing),
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { cellSpacing: value })
                    }
                  )
                ] })
              ] }),
              /* @__PURE__ */ jsx(
                TextField,
                {
                  label: "Table Caption",
                  "aria-label": "tableCaption",
                  defaultValue: captionText(),
                  width: "100%",
                  onChange: (value) => {
                    if (value === "") {
                      setForceOpen(true);
                      editor.chain().removeCaption().run();
                    } else {
                      setForceOpen(true);
                      editor.chain().setCaption(value).run();
                    }
                  }
                }
              )
            ] }, "tableProperties")
          ] })
        ] }) }) })
      ]
    }
  );
}
function TableToolbarToggleButton({
  editor,
  readOnly,
  toolbarView,
  setShowTableControls
}) {
  if (toolbarView === "table") {
    return /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            setShowTableControls(true);
          },
          "aria-label": "EditTable",
          isSelected: editor.isActive("EditTable"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableEdit, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Edit Table" })
    ] });
  }
  return /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
    /* @__PURE__ */ jsx(
      ToggleButton,
      {
        onPress: () => {
          editor.chain().focus().insertTable({ rows: 3, cols: 3, withHeaderRow: true }).run();
          setShowTableControls(true);
        },
        "aria-label": "createTable",
        isSelected: editor.isActive("createTable"),
        isDisabled: readOnly,
        children: /* @__PURE__ */ jsx(TableAdd, {})
      }
    ),
    /* @__PURE__ */ jsx(Tooltip, { children: "Create Table" })
  ] });
}
function TableToolbarButtons({
  editor,
  readOnly,
  setShowTableControls
}) {
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().addColumnBefore().run();
          },
          "aria-label": "insertLeft",
          isSelected: editor.isActive("insertLeft"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableColumnAddLeft, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Left" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().addColumnAfter().run();
          },
          "aria-label": "insertRight",
          isSelected: editor.isActive("insertRight"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableColumnAddRight, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Right" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().deleteColumn().run();
          },
          "aria-label": "insertRight",
          isSelected: editor.isActive("insertRight"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableColumnRemoveCenter, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Delete Column" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().addRowBefore().run();
          },
          "aria-label": "insertAbove",
          isSelected: editor.isActive("insertAbove"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowAddTop, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Above" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().addRowAfter().run();
          },
          "aria-label": "insertBelow",
          isSelected: editor.isActive("insertBelow"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowAddBottom, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Below" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().deleteRow().run();
          },
          "aria-label": "deleteRow",
          isSelected: editor.isActive("deleteRow"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowRemoveCenter, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Delete Row" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().mergeCells().run();
          },
          "aria-label": "mergeCells",
          isSelected: editor.isActive("mergeCells"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableMergeCells, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Merge Cells" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.chain().focus().splitCell().run();
          },
          "aria-label": "splitCell",
          isSelected: editor.isActive("splitCell"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowSplit, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Split Cells" })
    ] }),
    /* @__PURE__ */ jsx(TablePropertiesMenu, { readOnly, editor }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            editor.commands.deleteNode("table");
            setShowTableControls(false);
          },
          "aria-label": "deleteTable",
          isSelected: editor.isActive("deleteTable"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(Delete, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Delete Table" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().undo().run(),
          "aria-label": "undo",
          isSelected: false,
          isDisabled: !editor.can().undo(),
          children: /* @__PURE__ */ jsx(Undo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Undo" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().redo().run(),
          "aria-label": "redo",
          isSelected: false,
          isDisabled: !editor.can().redo(),
          UNSAFE_className: "last-toolbar-button",
          children: /* @__PURE__ */ jsx(Redo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Redo" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => {
            setShowTableControls(false);
          },
          "aria-label": "closeTableEditor",
          isSelected: editor.isActive("closeTableEditor"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(Close, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Close Table Editor" })
    ] })
  ] });
}
function DefaultToobbarButtons({
  disableTables,
  editor,
  readOnly,
  setShowTableControls,
  showTableControls,
  toolbarView
}) {
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleBold().run(),
          "aria-label": "bold",
          isSelected: editor.isActive("bold"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TagBold, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Bold" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleItalic().run(),
          "aria-label": "italic",
          isSelected: editor.isActive("italic"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TagItalic, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Italic" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleUnderline().run(),
          "aria-label": "underline",
          isSelected: editor.isActive("underline"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TagUnderline, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Underlined" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleStrike().run(),
          "aria-label": "strike",
          isSelected: editor.isActive("strike"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextStrikethrough, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Strikethrough" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().setTextAlign("left").run(),
          "aria-label": "left aligned",
          isSelected: editor.isActive({ textAlign: "left" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignLeft, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align left" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().setTextAlign("center").run(),
          "aria-label": "Center aligned",
          isSelected: editor.isActive({ textAlign: "center" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignCenter, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align centered" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().setTextAlign("right").run(),
          "aria-label": "Right aligned",
          isSelected: editor.isActive({ textAlign: "right" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignRight, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align right" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().setTextAlign("justify").run(),
          "aria-label": "Justify aligned",
          isSelected: editor.isActive({ textAlign: "justify" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignJustify, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align justified" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleSuperscript().run(),
          "aria-label": "superscript",
          isSelected: editor.isActive("superscript"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextSuperscript, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Superscript" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleSubscript().run(),
          "aria-label": "subscript",
          isSelected: editor.isActive("subscript"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextSubscript, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Subscript" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleBulletList().run(),
          "aria-label": "bullettList",
          isSelected: editor.isActive("bulletList"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextBulleted, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Bullet List" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().toggleOrderedList().run(),
          "aria-label": "orderedList",
          isSelected: editor.isActive("orderedList"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextNumbered, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Ordered List" })
    ] }),
    !disableTables && /* @__PURE__ */ jsx(
      TableToolbarToggleButton,
      {
        editor,
        readOnly,
        toolbarView,
        showTableControls,
        setShowTableControls
      }
    ),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().undo().run(),
          "aria-label": "undo",
          isSelected: false,
          isDisabled: !editor.can().undo(),
          children: /* @__PURE__ */ jsx(Undo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Undo" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          onPress: () => editor.chain().focus().redo().run(),
          "aria-label": "redo",
          isSelected: false,
          isDisabled: !editor.can().redo(),
          UNSAFE_className: "last-toolbar-button",
          children: /* @__PURE__ */ jsx(Redo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Redo" })
    ] })
  ] });
}
const AddClassButton = (props) => {
  var _a;
  const currentClass = props.editor.state.selection.$head.parent.attrs.class;
  const nodeItems = (_a = props == null ? void 0 : props.options) == null ? void 0 : _a.map((nodeClass) => {
    return {
      id: nodeClass == null ? void 0 : nodeClass.class,
      name: (nodeClass == null ? void 0 : nodeClass.name) ?? (nodeClass == null ? void 0 : nodeClass.class),
      active: currentClass == null ? void 0 : currentClass.includes(nodeClass == null ? void 0 : nodeClass.class)
    };
  });
  let [selectedClasses, setSelectedClasses] = React__default.useState(
    nodeItems.map((item) => item.id).filter((id) => {
      const item = nodeItems.find((item2) => item2.id === id);
      return item && item.active === true;
    })
  );
  const activeNodeOption = (selected) => {
    let selectedKey = selected == null ? void 0 : selected.currentKey;
    if ((selected == null ? void 0 : selected.currentKey) === void 0) {
      selectedKey = selectedClasses.filter((x) => ![...selected.keys()].includes(x))[0];
    }
    setSelectedClasses((prevSelectedClasses) => {
      if (prevSelectedClasses.includes(selectedKey)) {
        return prevSelectedClasses.filter((key) => key !== selectedKey);
      } else {
        return [...prevSelectedClasses, selectedKey];
      }
    });
    props.editor.chain().focus().toggleNodeWithClass({
      class: selectedKey == null ? void 0 : selectedKey.toString()
    }).run();
  };
  return /* @__PURE__ */ jsxs(MenuTrigger, { children: [
    /* @__PURE__ */ jsxs(ActionButton, { UNSAFE_style: { paddingLeft: "10px" }, children: [
      props.buttonText ?? "Add a Class",
      /* @__PURE__ */ jsx(ChevronDown, { size: "S" })
    ] }),
    /* @__PURE__ */ jsx(
      Menu,
      {
        items: nodeItems,
        onSelectionChange: (selected) => activeNodeOption(selected),
        selectedKeys: selectedClasses,
        selectionMode: "multiple",
        children: (item) => /* @__PURE__ */ jsx(Item, { children: item.name }, item.id)
      }
    )
  ] });
};
const AddStyleButton = (props) => {
  var _a;
  const currentStyle = props.editor.state.selection.$head.parent.attrs.style;
  const nodeItems = (_a = props == null ? void 0 : props.options) == null ? void 0 : _a.map((nodeStyle) => {
    return {
      id: nodeStyle == null ? void 0 : nodeStyle.style,
      name: (nodeStyle == null ? void 0 : nodeStyle.name) ?? (nodeStyle == null ? void 0 : nodeStyle.style),
      active: currentStyle == null ? void 0 : currentStyle.includes(nodeStyle == null ? void 0 : nodeStyle.style)
    };
  });
  let [selectedStyles, setSelectedStyles] = React__default.useState(
    nodeItems.map((item) => item.id).filter((id) => {
      const item = nodeItems.find((item2) => item2.id === id);
      return item && item.active === true;
    })
  );
  const activeNodeOption = (selected) => {
    let selectedKey = selected == null ? void 0 : selected.currentKey;
    if ((selected == null ? void 0 : selected.currentKey) === void 0) {
      selectedKey = selectedStyles.filter((x) => ![...selected.keys()].includes(x))[0];
    }
    setSelectedStyles((prevSelectedStyles) => {
      if (prevSelectedStyles.includes(selectedKey)) {
        return prevSelectedStyles.filter((key) => key !== selectedKey);
      } else {
        return [...prevSelectedStyles, selectedKey];
      }
    });
    props.editor.chain().focus().toggleNodeWithStyle({
      style: selectedKey == null ? void 0 : selectedKey.toString()
    }).run();
  };
  return /* @__PURE__ */ jsxs(MenuTrigger, { children: [
    /* @__PURE__ */ jsxs(ActionButton, { UNSAFE_style: { paddingLeft: "10px" }, children: [
      props.buttonText ?? "Add a Style",
      /* @__PURE__ */ jsx(ChevronDown, { size: "S" })
    ] }),
    /* @__PURE__ */ jsx(
      Menu,
      {
        items: nodeItems,
        onSelectionChange: (selected) => activeNodeOption(selected),
        selectedKeys: selectedStyles,
        selectionMode: "multiple",
        children: (item) => /* @__PURE__ */ jsx(Item, { children: item.name }, item.id)
      }
    )
  ] });
};
const TipTapToolbar = ({
  disableTables,
  editor,
  readOnly,
  uischema,
  toolbarView
}) => {
  var _a, _b, _c, _d, _e, _f;
  const [showTableControls, setShowTableControls] = useState(false);
  return /* @__PURE__ */ jsx(
    View,
    {
      borderWidth: "thin",
      borderColor: "dark",
      borderRadius: "regular",
      UNSAFE_className: "tiptap-toolbar",
      children: /* @__PURE__ */ jsxs(Flex, { gap: "size-25", margin: "size-100", wrap: true, children: [
        /* @__PURE__ */ jsx(HeadingToolbarButtons, { editor, readOnly }),
        ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.nodeClasses) && /* @__PURE__ */ jsx(
          AddClassButton,
          {
            options: (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.nodeClasses,
            editor,
            buttonText: (_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.nodeClassButton
          }
        ),
        ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.nodeStyles) && /* @__PURE__ */ jsx(
          AddStyleButton,
          {
            options: (_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.nodeStyles,
            editor,
            buttonText: (_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.nodeStyleButton
          }
        ),
        showTableControls && toolbarView === "table" ? /* @__PURE__ */ jsx(
          TableToolbarButtons,
          {
            editor,
            readOnly,
            toolbarView,
            showTableControls,
            setShowTableControls
          }
        ) : /* @__PURE__ */ jsx(
          DefaultToobbarButtons,
          {
            disableTables,
            editor,
            readOnly,
            uischema,
            toolbarView,
            showTableControls,
            setShowTableControls
          }
        )
      ] })
    }
  );
};
const removeWhiteSpace = (str) => {
  if (typeof str !== "string") {
    return void 0;
  } else {
    return str == null ? void 0 : str.replace(/\s+/g, " ").trim();
  }
};
const getNodeName = (editor, tag) => {
  if (tag) {
    if (tag.startsWith("h") && tag.length === 2) {
      return "heading";
    } else if (tag === "blockquote") {
      return "blockquote";
    } else if (tag === "span") {
      return "span";
    } else {
      return "paragraph";
    }
  } else {
    if (editor.isActive("heading")) {
      return "heading";
    } else if (editor.isActive("blockquote")) {
      return "blockquote";
    } else if (editor.isActive("span")) {
      return "span";
    } else {
      return "paragraph";
    }
  }
};
const getMarkName = (editor, tag) => {
  if (tag) {
    if (tag.startsWith("h") && tag.length === 2) {
      return "heading";
    } else if (tag === "blockquote") {
      return "blockquote";
    } else if (tag === "span") {
      return "span";
    } else {
      return "paragraph";
    }
  } else {
    if (editor.isActive("heading")) {
      return "heading";
    } else if (editor.isActive("blockquote")) {
      return "blockquote";
    } else if (editor.isActive("span")) {
      return "span";
    } else {
      return "paragraph";
    }
  }
};
const getTag = (editor) => {
  if (editor.isActive("heading")) {
    return `h${editor.getAttributes("heading").level}`;
  } else if (editor.isActive("blockquote")) {
    return "blockquote";
  } else if (editor.isActive("span")) {
    return "span";
  } else {
    return "p";
  }
};
const nodeWithClass = Node.create({
  name: "nodeWithClass",
  addOptions() {
    return {
      tag: "p",
      nodeName: "paragraph",
      classes: [""],
      styles: [""],
      level: 6,
      excludes: "nodeWithClass",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  content: "inline*",
  group: "block",
  defining: true,
  addAttributes() {
    return {
      level: {
        default: this.options.level,
        parseHTML: (element) => element.getAttribute("level"),
        renderHTML: (attributes) => {
          if (!attributes.level) {
            return {};
          }
          return {
            level: attributes.level
          };
        }
      },
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: this.options.styles[0],
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          if (!attributes.style) {
            return {};
          }
          return {
            style: attributes.style
          };
        }
      },
      tag: {
        default: "p",
        parseHTML: (element) => element.getAttribute("tag"),
        renderHTML: (attributes) => {
          if (!attributes.tag) {
            return {};
          }
          return {
            tag: attributes.tag
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag,
        getAttrs: (element) => {
          const hasClass = element.hasAttribute("class");
          if (!hasClass) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    var _a;
    const tag = (HTMLAttributes == null ? void 0 : HTMLAttributes.tag) || ((_a = this == null ? void 0 : this.options) == null ? void 0 : _a.tag);
    HTMLAttributes == null ? true : delete HTMLAttributes.tag;
    return [tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleNodeWithClass: (attributes) => ({ chain, editor }) => {
        const nodeName = getNodeName(editor, (attributes == null ? void 0 : attributes.tag) ?? getTag(editor));
        const currentClass = removeWhiteSpace(
          editor.getAttributes(nodeName).class ?? ""
        );
        const currClass = ` ${currentClass} `;
        const regex = new RegExp(`\\b${attributes.class}\\b`, "g");
        const newClass = currentClass ? removeWhiteSpace(currClass.replace(regex, "")) : void 0;
        let nodeClass = void 0;
        const isNewTag = attributes.tag && getTag(editor) !== attributes.tag;
        if (newClass !== currentClass && !isNewTag) {
          nodeClass = newClass ?? attributes.class;
        } else {
          if (isNewTag) {
            nodeClass = attributes.class;
          } else {
            nodeClass = removeWhiteSpace(
              `${currentClass ?? void 0} ${attributes.class ?? void 0}`
            );
          }
        }
        if (nodeClass === "") {
          nodeClass = void 0;
        }
        if (nodeName === "heading") {
          const level = attributes.level || editor.getAttributes(nodeName).level || this.options.level;
          return chain().setHeading({ level }).updateAttributes(nodeName, {
            class: nodeClass,
            level,
            style: editor.getAttributes(nodeName).style ?? void 0
          }).unsetBlockquote().run();
        } else if (nodeName === "blockquote") {
          return chain().setParagraph().setBlockquote().updateAttributes(nodeName, {
            class: nodeClass,
            style: editor.getAttributes(nodeName).style ?? void 0
          }).run();
        } else {
          return chain().setParagraph().updateAttributes(nodeName, {
            class: nodeClass,
            style: editor.getAttributes(nodeName).style ?? void 0
          }).unsetBlockquote().run();
        }
      }
    };
  }
});
const markWithClass = Mark.create({
  name: "markWithClass",
  addOptions() {
    return {
      tag: "p",
      markName: "paragraph",
      classes: [""],
      level: 6,
      excludes: "markWithClass",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  content: "inline*",
  group: "block",
  defining: true,
  addAttributes() {
    return {
      level: {
        default: this.options.level,
        rendered: false,
        parseHTML: (element) => element.getAttribute("level"),
        renderHTML: (attributes) => {
          if (!attributes.level) {
            return {};
          }
          return {
            level: attributes.level
          };
        }
      },
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      tag: {
        default: "p",
        parseHTML: (element) => element.getAttribute("tag"),
        renderHTML: (attributes) => {
          if (!attributes.tag) {
            return {};
          }
          return {
            tag: attributes.tag
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag,
        getAttrs: (element) => {
          const hasClass = element.hasAttribute("class");
          if (!hasClass) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    var _a;
    const tag = (HTMLAttributes == null ? void 0 : HTMLAttributes.tag) || ((_a = this == null ? void 0 : this.options) == null ? void 0 : _a.tag);
    HTMLAttributes == null ? true : delete HTMLAttributes.tag;
    return [tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleMarkWithClass: (attributes) => ({ chain, editor }) => {
        const markName = getMarkName(editor, (attributes == null ? void 0 : attributes.tag) ?? getTag(editor));
        const currentClass = removeWhiteSpace(
          editor.getAttributes(markName).class ?? ""
        );
        const currClass = ` ${currentClass} `;
        const regex = new RegExp(`\\b${attributes.class}\\b`, "g");
        const newClass = currentClass ? removeWhiteSpace(currClass.replace(regex, "")) : void 0;
        let markClass = void 0;
        const isNewTag = attributes.tag && getTag(editor) !== attributes.tag;
        if (newClass !== currentClass && !isNewTag) {
          markClass = newClass ?? attributes.class;
        } else {
          if (isNewTag) {
            markClass = attributes.class;
          } else {
            markClass = removeWhiteSpace(
              `${currentClass ?? void 0} ${attributes.class ?? void 0}`
            );
          }
        }
        if (markClass === "") {
          markClass = void 0;
        }
        if (markName === "heading") {
          const level = attributes.level || editor.getAttributes(markName).level || this.options.level;
          return chain().setHeading({ level }).updateAttributes(markName, {
            class: markClass,
            level
          }).unsetBlockquote().run();
        } else if (markName === "blockquote") {
          return chain().setParagraph().setBlockquote().updateAttributes(markName, {
            class: markClass
          }).run();
        } else {
          return chain().setParagraph().updateAttributes(markName, {
            class: markClass
          }).unsetBlockquote().run();
        }
      }
    };
  }
});
const markWithStyle = Mark.create({
  name: "markWithStyle",
  addOptions() {
    return {
      tag: "span",
      classes: [""],
      styles: [""],
      excludes: "markWithStyle",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: this.options.styles[0],
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          if (!attributes.style) {
            return {};
          }
          return {
            style: attributes.style
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag ?? "span",
        getAttrs: (element) => {
          const hasStyle = element.hasAttribute("style");
          if (!hasStyle) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    return [this.options.tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleMarkWithStyle: (attributes) => ({ chain, editor }) => {
        const currentStyle = removeWhiteSpace(
          editor.getAttributes("span").style ?? ""
        );
        const currStyle = ` ${currentStyle} `;
        let newStyle;
        if (typeof (attributes == null ? void 0 : attributes.style) === "string") {
          const regex = new RegExp(attributes.style.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), "g");
          newStyle = currentStyle ? removeWhiteSpace(currStyle.replace(regex, "")) : void 0;
        } else {
          newStyle = currentStyle ? removeWhiteSpace(currStyle) : void 0;
        }
        let markStyle = void 0;
        if (newStyle !== currentStyle) {
          markStyle = newStyle ?? (attributes == null ? void 0 : attributes.style);
        } else {
          markStyle = removeWhiteSpace(
            `${currentStyle ?? void 0} ${(attributes == null ? void 0 : attributes.style) ?? void 0}`
          );
        }
        if (markStyle === "") {
          markStyle = void 0;
        }
        return chain().toggleMark(this.name, {
          style: markStyle,
          class: editor.getAttributes("textStyle").class ?? void 0
        }).run();
      }
    };
  }
});
const nodeWithStyle = Node.create({
  name: "nodeWithStyle",
  addOptions() {
    return {
      tag: "p",
      nodeName: "paragraph",
      classes: [""],
      styles: [""],
      level: 6,
      excludes: "nodeWithStyle",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  content: "inline*",
  group: "block",
  defining: true,
  addAttributes() {
    return {
      level: {
        default: this.options.level,
        parseHTML: (element) => element.getAttribute("level"),
        renderHTML: (attributes) => {
          if (!attributes.level) {
            return {};
          }
          return {
            level: attributes.level
          };
        }
      },
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: this.options.styles[0],
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          if (!attributes.style) {
            return {};
          }
          return {
            style: attributes.style
          };
        }
      },
      tag: {
        default: "p",
        parseHTML: (element) => element.getAttribute("tag"),
        renderHTML: (attributes) => {
          if (!attributes.tag) {
            return {};
          }
          return {
            tag: attributes.tag
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag,
        getAttrs: (element) => {
          const hasStyle = element.hasAttribute("style");
          if (!hasStyle) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    var _a;
    const tag = (HTMLAttributes == null ? void 0 : HTMLAttributes.tag) || ((_a = this == null ? void 0 : this.options) == null ? void 0 : _a.tag);
    HTMLAttributes == null ? true : delete HTMLAttributes.tag;
    return [tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleNodeWithStyle: (attributes) => ({ chain, editor }) => {
        const nodeName = getNodeName(editor, (attributes == null ? void 0 : attributes.tag) ?? getTag(editor));
        const currentStyle = removeWhiteSpace(
          editor.getAttributes(nodeName).style ?? ""
        );
        const currStyle = ` ${currentStyle} `;
        let newStyle;
        if (typeof attributes.style === "string") {
          const regex = new RegExp(attributes.style.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), "g");
          newStyle = currentStyle ? removeWhiteSpace(currStyle.replace(regex, "")) : void 0;
        } else {
          newStyle = currentStyle ? removeWhiteSpace(currStyle) : void 0;
        }
        let nodeStyle = void 0;
        const isNewTag = attributes.tag && getTag(editor) !== attributes.tag;
        if (newStyle !== currentStyle && !isNewTag) {
          nodeStyle = newStyle ?? attributes.style;
        } else {
          if (isNewTag) {
            nodeStyle = attributes.style;
          } else {
            nodeStyle = removeWhiteSpace(
              `${currentStyle ?? void 0} ${attributes.style ?? void 0}`
            );
          }
        }
        if (nodeStyle === "") {
          nodeStyle = void 0;
        }
        if (nodeName === "heading") {
          const level = attributes.level || editor.getAttributes(nodeName).level || this.options.level;
          return chain().setHeading({ level }).updateAttributes(nodeName, {
            style: nodeStyle,
            level,
            class: editor.getAttributes(nodeName).class ?? void 0
          }).unsetBlockquote().run();
        } else if (nodeName === "blockquote") {
          return chain().setParagraph().setBlockquote().updateAttributes(nodeName, {
            style: nodeStyle,
            class: editor.getAttributes(nodeName).class ?? void 0
          }).run();
        } else {
          return chain().setParagraph().updateAttributes(nodeName, {
            style: nodeStyle,
            class: editor.getAttributes(nodeName).class ?? void 0
          }).unsetBlockquote().run();
        }
      }
    };
  }
});
const Caption = Node.create({
  name: "caption",
  group: "block",
  content: "inline*",
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  },
  parseHTML() {
    return [{ tag: "caption" }];
  },
  renderHTML({ node }) {
    return ["caption", node.attrs, 0];
  }
});
const CustomHeading = Heading$1.extend({
  addAttributes() {
    return {
      level: {
        default: 1,
        rendered: false
      },
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
const CustomParagraph = Paragraph.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        // Customize the HTML parsing (for example, to load the initial content)
        parseHTML: (element) => element.getAttribute("class"),
        // … and customize the HTML rendering.
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
const CustomSpan = TextStyle.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
const findCaption = (state) => {
  const $pos = state.selection.$anchor;
  for (let d = $pos.depth; d > 0; d--) {
    const node = $pos.node(d);
    if (node.type.name == "table") {
      let position = -1;
      state.doc.nodesBetween($pos.before(d), $pos.after(d), (node2, pos) => {
        if (node2.type.name == "caption") {
          position = pos;
        }
      });
      return position;
    }
  }
  return -1;
};
const findTable = (state) => {
  const path = state.selection.$anchor.path;
  let currNr = -1;
  for (let i = 0; i < path.length; i++) {
    if (typeof path[i] === "number") {
      currNr = path[i];
      continue;
    }
    if (path[i].type.name === "table") {
      break;
    }
  }
  return currNr >= 0 ? currNr : -2;
};
const CustomTable = Table.extend({
  content: "caption? tableBody",
  tableRole: "presentation",
  addCommands() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      removeCaption: () => ({ editor, state }) => {
        return editor.chain().focus((findCaption(state) || -2) + 1).deleteNode("caption").run();
      },
      setCaption: (value) => ({ editor, state }) => {
        const newCaption = { type: "caption", content: [{ type: "text", text: value }] };
        return editor.chain().focus((findCaption(state) || -2) + 1).deleteNode("caption").focus(findTable(state) + 1).insertContentAt(findTable(state) + 1, newCaption).focus((findCaption(state) || -2) + 1).run();
      }
    };
  },
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => {
          return element.getAttribute("class");
        },
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      },
      cellSpacing: {
        default: 0,
        rendered: true,
        parseHTML: (element) => element.getAttribute("cellspacing"),
        renderHTML: (attributes) => {
          return {
            cellSpacing: attributes.cellSpacing
          };
        }
      },
      cellPadding: {
        default: 1,
        rendered: true,
        parseHTML: (element) => element.getAttribute("cellpadding"),
        renderHTML: (attributes) => {
          return {
            cellPadding: attributes.cellPadding
          };
        }
      },
      border: {
        default: 1,
        rendered: true,
        parseHTML: (element) => element.getAttribute("border"),
        renderHTML: (attributes) => {
          return {
            border: attributes.border
          };
        }
      },
      height: {
        default: 100,
        rendered: true,
        parseHTML: (element) => element.getAttribute("height"),
        renderHTML: (attributes) => {
          return {
            height: attributes.height
          };
        }
      },
      width: {
        default: 100,
        rendered: true,
        parseHTML: (element) => element.getAttribute("width"),
        renderHTML: (attributes) => {
          return {
            width: attributes.width
          };
        }
      }
    };
  },
  renderHTML({ HTMLAttributes }) {
    return ["table", mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  }
});
const CustomTableBody = Node.create({
  name: "tableBody",
  group: "block+",
  content: "tableRow+",
  tableRole: "table",
  parseHTML() {
    return [{ tag: "tbody" }];
  },
  renderHTML({ node }) {
    return ["tbody", node.attrs, 0];
  }
});
const CustomTableCell = TableCell.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      },
      valign: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("valign"),
        renderHTML: (attributes) => {
          return {
            valign: attributes.valign
          };
        }
      },
      id: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("id"),
        renderHTML: (attributes) => {
          return {
            id: attributes.id
          };
        }
      },
      hiddenheader: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("hiddenheader"),
        renderHTML: (attributes) => {
          return {
            hiddenheader: attributes.hiddenheader
          };
        }
      },
      height: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("height"),
        renderHTML: (attributes) => {
          return {
            height: attributes.height
          };
        }
      },
      width: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("width"),
        renderHTML: (attributes) => {
          return {
            width: attributes.width
          };
        }
      }
    };
  }
});
const CustomTableHeader = TableHeader.extend({
  // content: 'block*',
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      },
      scope: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("scope"),
        renderHTML: (attributes) => {
          return {
            scope: attributes.scope
          };
        }
      },
      valign: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("valign"),
        renderHTML: (attributes) => {
          return {
            valign: attributes.valign
          };
        }
      },
      id: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("id"),
        renderHTML: (attributes) => {
          return {
            id: attributes.id
          };
        }
      },
      hiddenheader: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("hiddenheader"),
        renderHTML: (attributes) => {
          return {
            hiddenheader: attributes.hiddenheader
          };
        }
      },
      height: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("height"),
        renderHTML: (attributes) => {
          return {
            height: attributes.height
          };
        }
      },
      width: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("width"),
        renderHTML: (attributes) => {
          return {
            width: attributes.width
          };
        }
      }
    };
  }
});
const CustomTableRow = TableRow.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
function EditorComponent({
  CallbackFunction,
  content,
  noToolbar = false,
  readOnly = false,
  returnMode = "html",
  disableTables = false,
  uischema,
  path
}) {
  const [toolbarView, setToolbarView] = React.useState("default");
  const extensions = [
    CustomSpan,
    Caption,
    Blockquote,
    Bold,
    BulletList,
    Code,
    CodeBlock,
    CustomHeading,
    CustomParagraph,
    Document,
    Dropcursor,
    HardBreak,
    Highlight,
    History,
    HorizontalRule,
    Italic,
    Link$1,
    ListItem,
    OrderedList,
    Strike,
    Subscript,
    Superscript,
    Text$1,
    TypographyExtension,
    UnderlineExtension,
    nodeWithClass,
    markWithClass,
    markWithStyle,
    nodeWithStyle,
    Image.configure({
      inline: true,
      HTMLAttributes: {
        // AEM editor forces this size
        width: 240,
        height: 140
      }
    }),
    TextAlign.configure({
      types: ["heading", "paragraph"]
    }),
    Focus.configure({
      className: "has-focus",
      mode: "all"
    })
  ];
  const extensionsWithTables = [
    ...extensions,
    CustomTable,
    CustomTableBody,
    CustomTableCell,
    CustomTableHeader,
    CustomTableRow
  ];
  const editor = useEditor({
    editable: !readOnly,
    extensions: disableTables ? extensions : extensionsWithTables,
    content: !noToolbar && (returnMode === "text" || returnMode === "markdown") ? content == null ? void 0 : content.replace(/\n/g, "<br />") : content,
    onSelectionUpdate({ transaction }) {
      if (noToolbar) {
        return;
      }
      const path2 = transaction.curSelection.$head.path;
      let isInTable = false;
      for (let i = 0; i < path2.length; i++) {
        const element = path2[i];
        if (typeof element === "number") {
          continue;
        }
        if (element.type.name === "table") {
          isInTable = true;
          break;
        }
      }
      setToolbarView(isInTable ? "table" : "default");
    }
  });
  const firstRender = React.useRef(true);
  React.useEffect(() => {
    if (firstRender.current) {
      firstRender.current = false;
      return;
    }
    if (returnMode === "text" || returnMode === "markdown") {
      CallbackFunction(editor == null ? void 0 : editor.getText());
    } else {
      CallbackFunction(editor == null ? void 0 : editor.getHTML());
    }
  }, [editor == null ? void 0 : editor.getHTML()]);
  if (!editor)
    return null;
  return /* @__PURE__ */ jsxs(Flex, { direction: "column", ...dataTestId(path), children: [
    !noToolbar && /* @__PURE__ */ jsx(
      TipTapToolbar,
      {
        disableTables,
        editor,
        readOnly,
        toolbarView,
        uischema
      }
    ),
    /* @__PURE__ */ jsx(
      EditorContent,
      {
        editor,
        className: `${noToolbar ? "no-toolbar" : ""} ${readOnly ? "read-only" : ""}`
      }
    )
  ] });
}
const InputTipTapTextArea = React__default.memo(
  ({
    config,
    data,
    enabled = true,
    handleChange,
    label,
    noToolbar = false,
    path,
    returnMode,
    schema,
    uischema,
    visible
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const [editorContent, setEditorContent] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const callbackFunction = (editorContent2) => {
      setEditorContent(editorContent2);
      {
        editorContent2 && window.postMessage("tipTapDebounce");
      }
    };
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, isHidden: !visible, children: [
      label && /* @__PURE__ */ jsx("label", { className: "spectrum-label", children: label }),
      ContextualHelpComponent(uischema, schema, config),
      /* @__PURE__ */ jsx(
        EditorComponent,
        {
          CallbackFunction: callbackFunction,
          path,
          content: editorContent,
          noToolbar: noToolbar ?? appliedUiSchemaOptions.noToolbar,
          readOnly: !enabled,
          returnMode: returnMode ?? appliedUiSchemaOptions.returnMode,
          uischema,
          disableTables: appliedUiSchemaOptions.disableTables
        }
      )
    ] });
  }
);
const SpectrumTextAreaControl = (props) => {
  var _a, _b;
  return /* @__PURE__ */ jsx(
    SpectrumInputControl,
    {
      ...props,
      customError: true,
      input: InputTipTapTextArea,
      noToolbar: true,
      returnMode: ((_b = (_a = props == null ? void 0 : props.uischema) == null ? void 0 : _a.options) == null ? void 0 : _b.returnMode) || "text"
    }
  );
};
const SpectrumTextAreaControlTester = rankWith(5, isMultiLineControl);
const SpectrumTextAreaControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumTextAreaControl));
const SpectrumTextControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputText });
};
const SpectrumTextControlTester = rankWith(4, isStringControl);
const SpectrumTextControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumTextControl));
const SpectrumLabelControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: Label });
const SpectrumLabelControlTester = rankWith(5, uiTypeIs("label"));
const SpectrumLabelControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumLabelControl));
const SpectrumTextAndButtonControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputTextAndButton });
const SpectrumTextAndButtonControlTester = rankWith(
  9,
  and(isStringControl, optionIs("textAndButton", true))
);
const SpectrumTextAndButtonControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumTextAndButtonControl));
const SpectrumDateControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputDate });
const SpectrumDateControlTester = rankWith(5, isDateControl);
const SpectrumDateControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumDateControl));
const SpectrumDateTimeControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputDateTime });
const SpectrumDateTimeControlTester = rankWith(5, isDateTimeControl);
const SpectrumDateTimeControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumDateTimeControl));
const SpectrumTimeControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputTime });
const SpectrumTimeControlTester = rankWith(5, isTimeControl);
const SpectrumTimeControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumTimeControl));
const SpectrumObjectRenderer = ({
  cells,
  enabled,
  label,
  path,
  renderers,
  rootSchema,
  schema,
  uischema,
  uischemas = [],
  visible
}) => {
  const detailUiSchema = findUISchema(
    uischemas,
    schema,
    uischema.scope,
    path,
    "Group",
    uischema,
    rootSchema
  );
  if (isEmpty(path)) {
    detailUiSchema.type = "VerticalLayout";
  } else {
    detailUiSchema.label = startCase(label);
  }
  return /* @__PURE__ */ jsx(
    JsonFormsDispatch,
    {
      cells,
      enabled,
      path,
      renderers,
      schema,
      uischema: detailUiSchema,
      visible
    }
  );
};
const SpectrumObjectControlTester = rankWith(2, isObjectControl);
const SpectrumObjectRenderer$1 = withJsonFormsDetailProps(withHandleChange(SpectrumObjectRenderer));
const mapStateToSpectrumArrayItemProps = (state, ownProps) => {
  var _a, _b, _c, _d, _e, _f;
  const { schema, path, index, uischema } = ownProps;
  const childPath = composePaths(path, `${index}`);
  const childData = Resolve.data(getData(state), childPath);
  const labelProp = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.elementLabelProp) || ((_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.childDataAsLabel) || (schema == null ? void 0 : schema.properties) && ((_c = Object.entries(schema.properties).find(([propName, prop]) => {
    return !["_model", "_model_path", "_path", "_variations", "_metadata"].includes(propName) && ["string", "number", "integer"].some((type) => {
      return prop.type === type || Array.isArray(prop.type) && prop.type.includes(type) && prop.type.includes("null") && prop.type.length === 2;
    });
  })) == null ? void 0 : _c[0]);
  const childLabel = labelProp && childData[labelProp] || (typeof ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.dataAsLabel) === "number" ? Object.values(childData)[(_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.dataAsLabel] : findValue(childData, (_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.dataAsLabel) ?? `Item ${index + 1}`);
  return {
    ...ownProps,
    childLabel,
    childData
  };
};
const ctxToSpectrumArrayItemProps = (ctx, ownProps) => mapStateToSpectrumArrayItemProps({ jsonforms: { ...ctx } }, ownProps);
const arrayStrictlyExtendsPrefix = (prefix, array) => {
  if (array.length <= prefix.length)
    return false;
  for (let i = 0; i < prefix.length; ++i) {
    if (prefix[i] !== array[i]) {
      return false;
    }
  }
  return true;
};
const arrayExtendsPrefix = (prefix, array) => {
  if (array.length < prefix.length)
    return false;
  for (let i = 0; i < prefix.length; ++i) {
    if (prefix[i] !== array[i]) {
      return false;
    }
  }
  return true;
};
const _Breadcrumbs = class {
  constructor(data = []) {
    __privateAdd(this, _copy);
    __privateAdd(this, _breadcrumbs, new ArrayKeyedMap());
    for (const { path, name } of data) {
      __privateGet(this, _breadcrumbs).set(path.split("."), name);
    }
  }
  get(path) {
    return __privateGet(this, _breadcrumbs).get(path.split("."));
  }
  addBreadcrumb({ path, name, crxPath }) {
    const explodedPath = path.split(".");
    const existingName = __privateGet(this, _breadcrumbs).get(explodedPath);
    if (path && name !== existingName && !(existingName && !name)) {
      if (crxPath) {
        window.postMessage(
          {
            type: "breadcrumb-added",
            crxPath
          },
          "*"
        );
      }
      const result = __privateMethod(this, _copy, copy_fn).call(this);
      __privateGet(result, _breadcrumbs).set(explodedPath, name);
      return result;
    } else {
      return this;
    }
  }
  deleteBreadcrumb(path) {
    const explodedPath = path.split(".");
    if (__privateGet(this, _breadcrumbs).get(explodedPath) !== void 0) {
      const result = __privateMethod(this, _copy, copy_fn).call(this);
      __privateGet(result, _breadcrumbs).delete(explodedPath);
      return result;
    } else {
      return this;
    }
  }
  truncateBreadcrumbsAtParent(path) {
    const parentPath = path.slice(0, path.lastIndexOf("."));
    return this.truncateBreadcrumbs(parentPath);
  }
  truncateBreadcrumbsAndDelete(path) {
    if (__privateGet(this, _breadcrumbs).hasPrefix(path.split("."))) {
      return this.truncateBreadcrumbs(path).deleteBreadcrumb(path);
    } else {
      return this;
    }
  }
  truncateBreadcrumbsAndAdd(path) {
    return this.leavePrefixesOnly(path).addBreadcrumb({ path, name: null });
  }
  truncateBreadcrumbs(path) {
    const explodedPath = path.split(".");
    const keysLongerThanPath = [...__privateGet(this, _breadcrumbs).keys()].filter(
      (breadcrumbPath) => arrayStrictlyExtendsPrefix(explodedPath, breadcrumbPath)
    );
    if (keysLongerThanPath.length) {
      const result = new _Breadcrumbs();
      const entriesLeft = [...__privateGet(this, _breadcrumbs).entries()].filter(
        ([breadcrumbPath, _]) => !arrayStrictlyExtendsPrefix(explodedPath, breadcrumbPath)
      );
      for (const [key, value] of entriesLeft) {
        __privateGet(result, _breadcrumbs).set(key, value);
      }
      return result;
    } else {
      return this;
    }
  }
  leavePrefixesOnly(path) {
    const explodedPath = (path == null ? void 0 : path.split(".")) || [];
    const nonPrefixes = [...__privateGet(this, _breadcrumbs).keys()].filter(
      (breadcrumbPath) => !arrayExtendsPrefix(breadcrumbPath, explodedPath)
    );
    if (nonPrefixes.length) {
      const result = new _Breadcrumbs();
      const entriesLeft = [...__privateGet(this, _breadcrumbs).entries()].filter(
        ([breadcrumbPath, _]) => arrayExtendsPrefix(breadcrumbPath, explodedPath)
      );
      for (const [key, value] of entriesLeft) {
        __privateGet(result, _breadcrumbs).set(key, value);
      }
      return result;
    } else {
      return this;
    }
  }
  clear() {
    return new _Breadcrumbs();
  }
  hasPrefix(path) {
    return Boolean(path) && __privateGet(this, _breadcrumbs).hasPrefix(path.split("."));
  }
  has(path) {
    return __privateGet(this, _breadcrumbs).has(path.split("."));
  }
  keys() {
    return [...__privateGet(this, _breadcrumbs).keys()].map((pathSegements) => pathSegements.join("."));
  }
  entries() {
    return [...__privateGet(this, _breadcrumbs).entries()].map(([pathSegments, name]) => [
      pathSegments.join("."),
      name
    ]);
  }
};
let Breadcrumbs = _Breadcrumbs;
_breadcrumbs = new WeakMap();
_copy = new WeakSet();
copy_fn = function() {
  const result = new _Breadcrumbs();
  __privateSet(result, _breadcrumbs, __privateGet(this, _breadcrumbs));
  return result;
};
const BreadcrumbsContext = React__default.createContext({
  breadcrumbs: new Breadcrumbs(),
  addBreadcrumb: () => {
  },
  deleteBreadcrumb: () => {
  },
  truncateBreadcrumbs: () => {
  },
  truncateBreadcrumbsAndDelete: () => {
  },
  truncateBreadcrumbsAndAdd: () => {
  },
  truncateBreadcrumbsAtParent: () => {
  },
  resetBreadcrumbs: () => {
  }
});
const useBreadcrumbs = () => {
  const breadcrumbsContext = React__default.useContext(BreadcrumbsContext);
  if (breadcrumbsContext === void 0) {
    throw new Error("useBreadcrumbs must be used within a BreadcrumbsProvider");
  }
  return breadcrumbsContext;
};
const BreadcrumbsProvider = ({ children }) => {
  const [breadcrumbs, setBreadcrumbs] = React__default.useState(new Breadcrumbs());
  const addBreadcrumb = React__default.useCallback(
    (breadcrumb) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.addBreadcrumb(breadcrumb));
    },
    [setBreadcrumbs]
  );
  const deleteBreadcrumb = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.deleteBreadcrumb(path));
    },
    [setBreadcrumbs]
  );
  const resetBreadcrumbs = React__default.useCallback(
    (data) => {
      setBreadcrumbs(new Breadcrumbs(data));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbs = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbs(path));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbsAtParent = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbsAtParent(path));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbsAndDelete = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbsAndDelete(path));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbsAndAdd = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbsAndAdd(path));
    },
    [setBreadcrumbs]
  );
  return /* @__PURE__ */ jsx(
    BreadcrumbsContext.Provider,
    {
      value: {
        breadcrumbs,
        addBreadcrumb,
        deleteBreadcrumb,
        resetBreadcrumbs,
        truncateBreadcrumbs,
        truncateBreadcrumbsAtParent,
        truncateBreadcrumbsAndDelete,
        truncateBreadcrumbsAndAdd
      },
      children
    }
  );
};
const RenderersConfigContext = React__default.createContext({
  externalizePath: (path) => path
});
const AddItemButton = ({
  path,
  onPressFunction
}) => {
  return /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
    /* @__PURE__ */ jsx(
      ActionButton,
      {
        onPress: () => onPressFunction(),
        isQuiet: true,
        "aria-label": "add a new item",
        UNSAFE_className: "add-item",
        ...dataTestId(`addItem-${path}`),
        children: /* @__PURE__ */ jsx(Add, { "aria-label": "Add a new Item", size: "L" })
      }
    ),
    /* @__PURE__ */ jsx(Tooltip, { children: "Add a new Item" })
  ] });
};
let indexOfFittingSchemaObject = {};
function swap(array, moveIndex, toIndex) {
  const item = array[moveIndex];
  const length = array.length;
  const diff = moveIndex - toIndex;
  if (diff > 0) {
    return [
      ...array.slice(0, toIndex),
      item,
      ...array.slice(toIndex, moveIndex),
      ...array.slice(moveIndex + 1, length)
    ];
  } else if (diff < 0) {
    const targetIndex = toIndex + 1;
    return [
      ...array.slice(0, moveIndex),
      ...array.slice(moveIndex + 1, targetIndex),
      item,
      ...array.slice(targetIndex, length)
    ];
  }
  return array;
}
function clamp(number, lower, upper) {
  number = +number;
  lower = +lower;
  upper = +upper;
  lower = lower === lower ? lower : 0;
  upper = upper === upper ? upper : 0;
  if (number === number) {
    number = number <= upper ? number : upper;
    number = number >= lower ? number : lower;
  }
  return number;
}
const DragAndDrop = ({
  data,
  enabled,
  handleChange,
  handleRemoveItem,
  indexOfFittingSchemaArray,
  moveUpIndex,
  onPressHandler,
  path,
  removeItems,
  renderers,
  schema,
  setMoveUpIndex,
  uischema,
  uischemas
}) => {
  var _a, _b;
  if (!data) {
    return null;
  }
  const sortModeDnD = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.sortMode) !== "arrows" ? true : false;
  const [upOrDown, setUpOrDown] = React__default.useState("up");
  const [rerender, setRerender] = React__default.useState(0);
  const [isMoving, setIsMoving] = React__default.useState(false);
  const [delayHandler, setDelayHandler] = React__default.useState(null);
  const [grabbedIndex, setGrabbedIndex] = React__default.useState(null);
  const [hoveredIndex, setHoveredIndex] = React__default.useState(null);
  const [touchMovement, setTouchMovement] = React__default.useState(false);
  const { breadcrumbs } = useBreadcrumbs();
  const order = React__default.useRef(data == null ? void 0 : data.map((_, index) => index));
  const COMPONENT_HEIGHT = 70;
  const fn = (order2, active = false) => (index) => active ? {
    y: order2.indexOf(index) * COMPONENT_HEIGHT,
    duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : 400,
    immediate: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? true : false,
    keys: false
  } : {
    y: order2.indexOf(index) * COMPONENT_HEIGHT,
    duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : 400,
    immediate: true,
    keys: false
  };
  const [springs, setSprings] = useSprings((data == null ? void 0 : data.length) ?? 0, fn(order.current));
  const sortableHandleRef = useSpringRef();
  const bind = useDrag(
    ({ args: [originalIndex], active, movement: [, y] }) => {
      if (originalIndex !== null && grabbedIndex !== null) {
        if (touchMovement) {
          setTouchMovement(false);
          setGrabbedIndex(null);
        }
        const curRow = clamp(
          Math.round((originalIndex * COMPONENT_HEIGHT + y) / COMPONENT_HEIGHT),
          0,
          (data == null ? void 0 : data.length) - 1
        );
        const newOrder = swap(
          order.current,
          order.current.indexOf(order.current[originalIndex]),
          order.current.indexOf(order.current[curRow])
        );
        setSprings.start(fn(newOrder, active));
        if (order.current.indexOf(order.current[originalIndex]) === order.current.indexOf(order.current[curRow]) || order.current === newOrder) {
          return;
        }
        if (!active) {
          finalChange(newOrder);
        }
      }
    },
    {
      pointer: { keys: false }
    }
  );
  const finalChange = (newOrder) => {
    order.current = newOrder;
    handleChange(
      path,
      data.map((_, index) => data[newOrder[index]])
    );
    setGrabbedIndex(null);
    setSprings.start(fn(newOrder, false));
    setIsMoving(false);
    setRerender((x) => x + 1);
  };
  let [keyboardClass, setKeyboardClass] = React__default.useState("");
  const move = (pressedKey, index) => {
    setIsMoving(true);
    let newOrder = false;
    let newGrabbedIndex = null;
    if (pressedKey === "ArrowUp" && index > 0) {
      setKeyboardClass("keyboardUp");
      newGrabbedIndex = index - 1;
      newOrder = swap(
        order.current,
        order.current.indexOf(order.current[index]),
        order.current.indexOf(order.current[index - 1])
      );
      setSprings.start(fn(newOrder, true));
      setTimeout(() => {
        setGrabbedIndex(index - 1);
        finalChange(newOrder);
        setKeyboardClass("");
        setGrabbedIndex(index - 1);
      }, 500);
      setUpOrDown("up");
    } else if (pressedKey === "ArrowDown" && index < (data == null ? void 0 : data.length) - 1) {
      setKeyboardClass("keyboardDown");
      newGrabbedIndex = index + 1;
      newOrder = swap(
        order.current,
        order.current.indexOf(order.current[index]),
        order.current.indexOf(order.current[index + 1])
      );
      setSprings.start(fn(newOrder, true));
      setTimeout(() => {
        setGrabbedIndex(index + 1);
        finalChange(newOrder);
        setKeyboardClass("");
      }, 500);
      setUpOrDown("down");
    }
    setTimeout(() => {
      setGrabbedIndex(newGrabbedIndex);
    }, 500);
  };
  const duplicateContent = (index) => {
    const newData = [...data, data[index]];
    order.current = newData.map((_, index2) => index2);
    handleChange(path, newData);
    setSprings.start(fn(newData, false));
  };
  React__default.useEffect(() => {
    order.current = data == null ? void 0 : data.map((_, index) => index);
    setGrabbedIndex(null);
    setSprings.start(fn(order.current, false));
  }, [data]);
  const enableTouch = (index) => {
    if (!sortModeDnD)
      return;
    setGrabbedIndex(index);
    setTouchMovement(true);
  };
  const showAddBetween = (index) => {
    setDelayHandler(
      setTimeout(() => {
        setHoveredIndex(index);
      }, 500)
    );
  };
  const hideAddBetween = () => {
    clearTimeout(delayHandler);
    setHoveredIndex(null);
  };
  const addBetween = (index, event) => {
    var _a2;
    setMoveUpIndex(index);
    onPressHandler();
    (_a2 = event == null ? void 0 : event.target) == null ? void 0 : _a2.blur();
  };
  React__default.useEffect(() => {
    if (moveUpIndex !== null) {
      const newOrder = swap(
        order.current,
        order.current.indexOf(order.current[data.length - 1]),
        order.current.indexOf(order.current[moveUpIndex])
      );
      finalChange(newOrder);
      setMoveUpIndex(null);
    } else {
      order.current = data == null ? void 0 : data.map((_, index) => index);
      setSprings.start(fn(order.current, false));
      finalChange(order.current);
      setMoveUpIndex(null);
    }
  }, [data.length]);
  const userIsOnMobileDevice = checkIfUserIsOnMobileDevice(
    navigator.userAgent.toLowerCase()
  );
  const textAreaLabel = (textAreaObject) => {
    var _a2;
    if (typeof ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.detail) !== "object") {
      return null;
    }
    const tempEl = document.createElement("div");
    tempEl.innerHTML = textAreaObject == null ? void 0 : textAreaObject.html;
    const firstElement = tempEl.firstChild;
    const firstText = firstElement == null ? void 0 : firstElement.firstChild;
    return firstText == null ? void 0 : firstText.textContent;
  };
  const noDetailedViewIsExpanded = ((_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.enableDetailedView) === false && data.filter((_, i) => breadcrumbs.hasPrefix(`${path}.${i}`)).map((_, i) => i).length > 0;
  const modalItem = (index, disabled = false) => /* @__PURE__ */ jsx(
    SpectrumArrayItemComponent$1,
    {
      customLabel: textAreaLabel(data[index]),
      duplicateItem: duplicateContent,
      enabled,
      index,
      indexOfFittingSchema: indexOfFittingSchemaArray,
      path,
      removeItem: handleRemoveItem,
      renderers,
      schema,
      uischema,
      uischemas,
      sortableHandle: /* @__PURE__ */ jsx(
        SortIcons,
        {
          data,
          disabled,
          grabbedIndex,
          index,
          keyboardClass,
          moveDown: () => () => move("ArrowDown", index),
          moveUp: () => () => move("ArrowUp", index),
          onBlur: () => setGrabbedIndex(null),
          onFocus: () => setGrabbedIndex(index),
          onKeyDown: (e) => {
            if (e.key === "ArrowUp" || e.key === "ArrowDown") {
              move(e.key, index);
            }
          },
          onMouseEnter: () => setGrabbedIndex(index),
          onMouseLeave: () => setGrabbedIndex(null),
          onTouchMove: () => enableTouch(index),
          path,
          removeItems,
          sortableHandleRef,
          uischema,
          upOrDown,
          userIsOnMobileDevice
        }
      )
    }
  );
  return /* @__PURE__ */ jsx(
    "div",
    {
      style: {
        display: "flex",
        flexDirection: "column",
        gap: "8px",
        marginBottom: "8px",
        position: "relative",
        touchAction: "none",
        transformOrigin: "50% 50% 0px",
        height: noDetailedViewIsExpanded ? "auto" : COMPONENT_HEIGHT * (data == null ? void 0 : data.length),
        minHeight: (data == null ? void 0 : data.length) ? COMPONENT_HEIGHT * (data == null ? void 0 : data.length) : 0
      },
      children: springs == null ? void 0 : springs.map(({ y }, index) => /* @__PURE__ */ createElement(
        animated$1.div,
        {
          ...bind(index),
          key: `${path}_${index}_${rerender}`,
          style: {
            position: noDetailedViewIsExpanded ? void 0 : "absolute",
            touchAction: "none",
            transformOrigin: "50% 50% 0px",
            width: "100%",
            y: noDetailedViewIsExpanded ? void 0 : y,
            zIndex: grabbedIndex === index ? 30 : 20
          },
          height: COMPONENT_HEIGHT + "px"
        },
        /* @__PURE__ */ jsx(
          "div",
          {
            style: {
              alignItems: "center",
              display: userIsOnMobileDevice ? "none" : "flex",
              height: noDetailedViewIsExpanded ? "8px" : void 0,
              justifyContent: "center",
              marginTop: noDetailedViewIsExpanded ? "-8px" : void 0,
              opacity: hoveredIndex === index ? 1 : 0,
              position: noDetailedViewIsExpanded ? "relative" : "absolute",
              top: noDetailedViewIsExpanded ? void 0 : "-20px",
              width: "100%",
              zIndex: 80
            },
            onMouseEnter: () => showAddBetween(index),
            onMouseLeave: () => hideAddBetween(),
            onFocus: () => setHoveredIndex(index),
            onBlur: () => hideAddBetween(),
            className: "add-container",
            children: /* @__PURE__ */ jsx(
              Button,
              {
                variant: "cta",
                onPress: (event) => addBetween(index, event),
                UNSAFE_style: { zIndex: 81 },
                children: /* @__PURE__ */ jsx(Add, {})
              }
            )
          },
          `${path}_${index}_addBetween`
        ),
        /* @__PURE__ */ jsx(
          Flex,
          {
            direction: "row",
            alignItems: "stretch",
            flex: "auto inherit",
            UNSAFE_style: { zIndex: grabbedIndex === index ? 30 : 20 },
            children: modalItem(index, isMoving || noDetailedViewIsExpanded)
          }
        )
      ))
    }
  );
};
const SortButtons = React__default.memo(
  ({
    autoFocus,
    data,
    disabled,
    index,
    moveDown,
    moveUp,
    path,
    upOrDown,
    userIsOnMobileDevice
  }) => {
    return /* @__PURE__ */ jsxs(Flex, { direction: "column", children: [
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            autoFocus: autoFocus && upOrDown === "up",
            isQuiet: true,
            onPress: () => moveUp,
            "aria-label": `move-item-${path}.${index}-up`,
            marginX: "size-10",
            UNSAFE_style: { position: "absolute", marginTop: "-5px" },
            UNSAFE_className: `${userIsOnMobileDevice ? "arrow-icon" : null} ${index <= 0 || disabled ? "disabledMovement" : null}`,
            isDisabled: index <= 0 || disabled,
            height: "size-325",
            children: /* @__PURE__ */ jsx(ArrowUp, { "aria-label": "ArrowUp", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: "Move upwards" })
      ] }),
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            autoFocus: autoFocus && upOrDown === "down",
            isQuiet: true,
            onPress: () => moveDown,
            "aria-label": `move-item-${path}.${index}-down`,
            marginX: "size-10",
            UNSAFE_style: { position: "absolute", marginTop: "15px" },
            UNSAFE_className: `${userIsOnMobileDevice ? "arrow-icon" : null} ${index >= data.length - 1 || disabled ? "disabledMovement" : ""}`,
            isDisabled: index >= data.length - 1 || disabled,
            height: "size-325",
            children: /* @__PURE__ */ jsx(ArrowDown, { "aria-label": "ArrowDown", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: "Move downwards" })
      ] })
    ] });
  }
);
const SortIcons = ({
  data,
  disabled,
  grabbedIndex,
  index,
  keyboardClass,
  moveDown,
  moveUp,
  onBlur,
  onFocus,
  onKeyDown,
  onMouseEnter,
  onMouseLeave,
  onTouchMove,
  path,
  removeItems,
  sortableHandleRef,
  uischema,
  upOrDown,
  userIsOnMobileDevice
}) => {
  var _a;
  const sortMode = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.sortMode) ?? "DragAndDrop";
  const isKeyboardUser = !!Array.from(document.getElementsByClassName("keyboard-user")).length;
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(Divider, { orientation: "vertical", size: "M", marginStart: "size-100" }),
    sortMode === "arrows" ? /* @__PURE__ */ jsx(
      "div",
      {
        className: `arrowContainer grabbable ${sortMode === "arrows" ? "" : "grabcursor"} ${disabled ? "disabledMovement" : ""}`,
        onBlur,
        onFocus,
        onKeyDown,
        onMouseEnter,
        onMouseLeave,
        onTouchMove,
        ref: sortableHandleRef,
        children: /* @__PURE__ */ jsx(
          SortButtons,
          {
            autoFocus: isKeyboardUser && grabbedIndex === index,
            data,
            disabled,
            index,
            moveDown,
            moveUp,
            path,
            removeItems,
            uischema,
            upOrDown,
            userIsOnMobileDevice
          }
        )
      }
    ) : /* @__PURE__ */ jsxs(
      "button",
      {
        disabled,
        ref: sortableHandleRef,
        autoFocus: isKeyboardUser && grabbedIndex === index,
        className: `grabbable ${disabled ? "disabledMovement" : ""}`,
        onFocus,
        onBlur,
        onMouseEnter,
        onMouseLeave,
        onTouchMove,
        onKeyDown,
        children: [
          /* @__PURE__ */ jsx(
            ArrowUp,
            {
              "aria-label": "Arrow Up",
              size: "S",
              alignSelf: "center",
              width: "100%",
              UNSAFE_className: keyboardClass === "keyboardUp" && index === grabbedIndex ? "keyboard-movement" : "keyboard-user"
            }
          ),
          /* @__PURE__ */ jsx(
            ArrowDown,
            {
              "aria-label": "Arrow Down",
              size: "S",
              alignSelf: "center",
              width: "100%",
              UNSAFE_className: keyboardClass === "keyboardDown" && index === grabbedIndex ? "keyboard-movement" : "keyboard-user"
            }
          ),
          /* @__PURE__ */ jsx(
            DragHandle,
            {
              "aria-label": "Drag and Drop Handle",
              size: "L",
              alignSelf: "center",
              width: "100%",
              UNSAFE_className: "mouse-drag-handle"
            }
          )
        ]
      }
    )
  ] });
};
const SpectrumItemHeader = ({
  childData,
  childLabel,
  customPicker,
  duplicateItem,
  enableDetailedView,
  expanded,
  index = 0,
  isDetailedViewHeader,
  jsonFormsDispatch,
  path,
  removeItem,
  setExpanded,
  sortableHandle = void 0,
  uischema
}) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j;
  const [deleteModalOpen, setDeleteModalOpen] = React__default.useState(false);
  const actionMenuTriggered = (action) => {
    const testArr = action.split("-");
    testArr[0] = testArr[0].toLowerCase();
    const actionName = testArr.join("");
    const lookupObj = {
      delete: () => setDeleteModalOpen(true),
      duplicate: () => duplicateItem ? duplicateItem(index) : null
    };
    lookupObj[actionName]();
  };
  const showItemNumber = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.showItemNumber) ?? false;
  const pathFilter = (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.pathFilter;
  let displayPath = "";
  if (typeof pathFilter === "string") {
    displayPath = ((_c = childData == null ? void 0 : childData._path) == null ? void 0 : _c.replace(pathFilter, "")) || "";
  } else {
    displayPath = ((_d = childData == null ? void 0 : childData._path) == null ? void 0 : _d.split("/").slice(3).join("/")) || "";
    if (displayPath) {
      displayPath = `/${displayPath}`;
    }
  }
  const [durationBeforeDelete, setDurationBeforeDelete] = React__default.useState(0);
  const onPressStartHandler = () => {
    if (expanded) {
      setExpanded(false);
      setDurationBeforeDelete(700);
    }
  };
  const onPressEndHandler = () => {
    setDeleteModalOpen(false);
    setTimeout(() => {
      removeItem(path, index)();
    }, durationBeforeDelete);
  };
  let ActionMenuItems = [
    { key: "delete", name: "Remove", icon: /* @__PURE__ */ jsx(Delete, { size: "S" }) },
    duplicateItem && { key: "duplicate", name: "Duplicate", icon: /* @__PURE__ */ jsx(Duplicate, { size: "S" }) }
  ];
  const imageSrc = typeof ((_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.dataAsImage) === "number" && childData ? Object.values(childData)[(_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.dataAsImage] : findValue(childData, (_g = uischema == null ? void 0 : uischema.options) == null ? void 0 : _g.dataAsImage) ?? void 0;
  const MediaPreview2 = (_h = uischema == null ? void 0 : uischema.options) == null ? void 0 : _h.mediaPreview;
  return /* @__PURE__ */ jsx(
    View,
    {
      "aria-selected": expanded,
      UNSAFE_className: "array-item-header",
      UNSAFE_style: expanded ? { zIndex: 50 } : {},
      children: /* @__PURE__ */ jsxs(Flex, { direction: "row", margin: "size-50", justifyContent: "space-between", alignItems: "center", children: [
        showItemNumber && /* @__PURE__ */ jsx(View, { UNSAFE_className: "spectrum-array-item-number", children: /* @__PURE__ */ jsx(Text, { children: index + 1 }) }),
        imageSrc && MediaPreview2 && /* @__PURE__ */ jsx(
          "img",
          {
            src: imageSrc,
            height: isDetailedViewHeader ? "45" : "50",
            alt: "Preview Picture",
            style: {
              aspectRatio: "1/1",
              objectFit: "cover",
              marginRight: "10px",
              marginLeft: "2px",
              marginTop: isDetailedViewHeader ? "10px" : "0px"
            }
          }
        ),
        ((_i = uischema == null ? void 0 : uischema.options) == null ? void 0 : _i.noAccordion) ? /* @__PURE__ */ jsx(View, { UNSAFE_className: "jsonforms-dispatch-container", children: jsonFormsDispatch }) : /* @__PURE__ */ jsxs(
          ActionButton,
          {
            flex: "1 1 auto",
            isQuiet: true,
            onPress: () => setExpanded(!expanded),
            "aria-label": `expand-item-${childLabel}`,
            ...dataTestId(`${path}.${index}`),
            children: [
              (childData == null ? void 0 : childData._path) && displayPath ? /* @__PURE__ */ jsxs(
                Text,
                {
                  UNSAFE_style: {
                    position: "absolute",
                    direction: "rtl",
                    opacity: 0.7,
                    bottom: -5,
                    left: 0,
                    fontSize: "12px",
                    height: 18,
                    maxWidth: "calc(100% - 12px)",
                    textOverflow: "ellipsis",
                    overflow: "hidden",
                    whiteSpace: "nowrap",
                    textAlign: "left",
                    alignSelf: "start",
                    justifyContent: "start"
                  },
                  children: [
                    "‎",
                    displayPath
                  ]
                }
              ) : null,
              /* @__PURE__ */ jsx(
                Text,
                {
                  UNSAFE_className: "spectrum-array-item-name",
                  UNSAFE_style: {
                    paddingLeft: 0,
                    textAlign: "left",
                    width: "100%",
                    transform: (childData == null ? void 0 : childData._path) && displayPath ? "translateY(-20%)" : "",
                    fontWeight: 600
                  },
                  children: childLabel
                }
              )
            ]
          }
        ),
        /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsxs(Flex, { gap: "size-0", children: [
          /* @__PURE__ */ jsx(
            ActionMenu,
            {
              align: "end",
              items: ActionMenuItems,
              onAction: actionMenuTriggered,
              isQuiet: true,
              children: (item) => /* @__PURE__ */ jsxs(Item, { textValue: `${item == null ? void 0 : item.name}-item-${childLabel}`, children: [
                /* @__PURE__ */ jsx(Text, { children: item == null ? void 0 : item.name }),
                (item == null ? void 0 : item.icon) ?? null
              ] }, item == null ? void 0 : item.key)
            }
          ),
          (customPicker == null ? void 0 : customPicker.enabled) && /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
            /* @__PURE__ */ jsx(
              ActionButton,
              {
                onPress: customPicker.handler,
                isQuiet: true,
                "aria-label": `change-reference-${childLabel}`,
                children: /* @__PURE__ */ jsx(FolderSearch, { "aria-label": "Change Reference", size: "S" })
              }
            ),
            /* @__PURE__ */ jsx(Tooltip, { children: "Change Content Fragment Reference" })
          ] }),
          ((_j = uischema == null ? void 0 : uischema.options) == null ? void 0 : _j.noAccordion) ? null : /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
            /* @__PURE__ */ jsx(
              ActionButton,
              {
                onPress: () => setExpanded(!expanded),
                isQuiet: true,
                "aria-label": `expand-item-${childLabel}`,
                ...dataTestId(`${path}.${index}-iconButton`),
                children: expanded ? enableDetailedView ? /* @__PURE__ */ jsx(Close, { "aria-label": "Close", size: "S" }) : /* @__PURE__ */ jsx(ChevronUp, { "aria-label": "Collapse", size: "S" }) : enableDetailedView ? /* @__PURE__ */ jsx(Edit, { "aria-label": "Edit", size: "S" }) : /* @__PURE__ */ jsx(ChevronDown, { "aria-label": "Expand", size: "S" })
              }
            ),
            /* @__PURE__ */ jsx(Tooltip, { children: expanded ? enableDetailedView ? "Close" : "Collapse" : enableDetailedView ? "Edit" : "Expand" })
          ] }),
          sortableHandle && (!enableDetailedView || enableDetailedView && !expanded) && /* @__PURE__ */ jsx(Fragment, { children: sortableHandle }),
          /* @__PURE__ */ jsx(
            DeleteDialog,
            {
              deleteModalOpen,
              onPressEndHandler: () => onPressEndHandler(),
              onPressStartHandler: () => onPressStartHandler(),
              setDeleteModalOpen
            }
          )
        ] }) })
      ] })
    }
  );
};
const SpectrumArrayItemComponent = React__default.memo(
  ({
    sortableHandle = void 0,
    childData,
    childLabel,
    customLabel,
    duplicateItem,
    enabled,
    index,
    path,
    removeItem,
    renderers,
    schema,
    uischema,
    uischemas = []
  }) => {
    var _a, _b, _c, _d, _e, _f, _g;
    let foundUISchema = findUISchema(uischemas, schema, uischema.scope, path);
    if (typeof ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.detail) === "object") {
      foundUISchema = (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.detail;
    }
    if (!childLabel || childLabel === "<p></p>") {
      childLabel = `Item ${index + 1}`;
    }
    const childPath = composePaths(path, `${index}`);
    const [isAnimating, setIsAnimating] = React__default.useState(false);
    const noAccordion = ((_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.noAccordion) ?? false;
    const enableDetailedView = ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.enableDetailedView) ?? true;
    const userIsOnMobileDevice = checkIfUserIsOnMobileDevice(
      navigator.userAgent.toLowerCase()
    );
    const { breadcrumbs, addBreadcrumb, truncateBreadcrumbsAndDelete } = useBreadcrumbs();
    const expanded = breadcrumbs.hasPrefix(childPath);
    const setExpanded = React__default.useCallback(
      (desiredState) => {
        if (desiredState) {
          addBreadcrumb({
            path: childPath,
            name: enableDetailedView ? customLabel || childLabel : null,
            crxPath: childData == null ? void 0 : childData._path
          });
        } else {
          truncateBreadcrumbsAndDelete(childPath);
        }
        if (desiredState === expanded) {
          return;
        }
        if (!userIsOnMobileDevice) {
          setIsAnimating(true);
        }
      },
      [
        expanded,
        customLabel,
        childLabel,
        enableDetailedView,
        breadcrumbs,
        truncateBreadcrumbsAndDelete,
        addBreadcrumb
      ]
    );
    React__default.useEffect(() => {
      if (breadcrumbs.hasPrefix(childPath)) {
        setExpanded(true);
      }
    }, [breadcrumbs]);
    React__default.useEffect(() => {
      if (!noAccordion && (!childData || Object.keys(childData).length === 0)) {
        setExpanded(true);
      }
    }, []);
    if ((_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.oneOfModal) {
      indexOfFittingSchemaObject["oneOfModal"] = true;
    }
    if ((_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.OneOfPicker) {
      indexOfFittingSchemaObject["OneOfPicker"] = true;
    }
    const customPickerHandler = () => {
      window.postMessage({
        type: "customPicker:open",
        open: true,
        schema,
        current: {
          path,
          index,
          data: childData
        }
      });
    };
    if (childPath.includes("multiContentReference"))
      ;
    const JsonFormsDispatchComponent = /* @__PURE__ */ jsx("div", { className: "array-item-content", children: /* @__PURE__ */ jsx(
      JsonFormsDispatch,
      {
        enabled,
        path: childPath,
        renderers,
        schema,
        uischema: foundUISchema || uischema,
        visible: false
      },
      childPath
    ) });
    const header = /* @__PURE__ */ jsx(
      SpectrumItemHeader,
      {
        childData,
        childLabel: customLabel || childLabel,
        customPicker: { enabled: (_g = uischema == null ? void 0 : uischema.options) == null ? void 0 : _g.picker, handler: customPickerHandler },
        data: void 0,
        duplicateItem,
        enableDetailedView,
        expanded,
        setExpanded,
        index,
        jsonFormsDispatch: JsonFormsDispatchComponent,
        path,
        removeItem,
        sortableHandle,
        uischema
      }
    );
    return /* @__PURE__ */ jsxs(
      View,
      {
        UNSAFE_className: `list-array-item ${expanded ? "expanded" : "collapsed"} ${noAccordion ? "no-accordion" : ""}`,
        borderColor: "dark",
        borderRadius: "medium",
        borderWidth: "thin",
        padding: "size-150",
        width: "100%",
        children: [
          header,
          expanded && !enableDetailedView && /* @__PURE__ */ jsx(View, { UNSAFE_className: "jsonforms-dispatch-wrapper", children: JsonFormsDispatchComponent }),
          enableDetailedView && /* @__PURE__ */ jsx(
            ModalItemAnimationWrapper,
            {
              enableDetailedView,
              expanded,
              setExpanded,
              isAnimating,
              path,
              setIsAnimating,
              children: expanded || isAnimating ? /* @__PURE__ */ jsxs(View, { UNSAFE_className: "jsonforms-dispatch-wrapper", children: [
                enableDetailedView && header,
                JsonFormsDispatchComponent
              ] }) : null
            }
          )
        ]
      }
    );
  }
);
const withContextToSpectrumArrayItemProps = (Component) => ({ ctx, props, sortableHandle }) => {
  const stateProps = ctxToSpectrumArrayItemProps(ctx, props);
  return /* @__PURE__ */ jsx(Component, { ...stateProps, ...sortableHandle });
};
const withJsonFormsSpectrumArrayItemProps = (Component) => withJsonFormsContext(withContextToSpectrumArrayItemProps(React__default.memo(Component)));
const SpectrumArrayItemComponent$1 = withJsonFormsSpectrumArrayItemProps(withHandleChange(SpectrumArrayItemComponent));
function AddDialog({
  handleClose,
  handleOnConfirm,
  open,
  schema,
  selectedIndex,
  setSelectedIndex,
  uischema
}) {
  var _a, _b;
  const usePickerInsteadOfListBox = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.picker;
  const handleListBoxChange = React__default.useCallback(
    (newOneOfIndex) => {
      if (newOneOfIndex.currentKey) {
        setSelectedIndex(newOneOfIndex.currentKey);
      }
    },
    [setSelectedIndex]
  );
  const handlePickerChange = React__default.useCallback(
    (newOneOfIndex) => {
      newOneOfIndex = Number(newOneOfIndex);
      setSelectedIndex(newOneOfIndex);
    },
    [setSelectedIndex]
  );
  return /* @__PURE__ */ jsx(DialogContainer, { onDismiss: handleClose, children: open && /* @__PURE__ */ jsxs(Dialog, { children: [
    /* @__PURE__ */ jsxs("div", { style: { gridColumn: "1 / -1" }, children: [
      /* @__PURE__ */ jsx(Heading, { margin: "size-100", children: "Add a new item" }),
      /* @__PURE__ */ jsx(Divider, {}),
      usePickerInsteadOfListBox ? /* @__PURE__ */ jsx(
        Picker,
        {
          "aria-label": "Select",
          margin: "size-100",
          onSelectionChange: handlePickerChange,
          selectedKey: String(selectedIndex),
          width: "calc(100% - size-200)",
          children: schema == null ? void 0 : schema.map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(Item, { children: oneOfRenderInfo.title ?? `Item ${oneOfIndex + 1}` }, oneOfIndex))
        }
      ) : /* @__PURE__ */ jsx(
        ListBox,
        {
          "aria-label": "Select",
          items: schema,
          margin: "size-100",
          onSelectionChange: (selected) => handleListBoxChange(selected),
          selectedKeys: String(selectedIndex),
          selectionMode: "single",
          width: "calc(100% - size-200)",
          maxHeight: "size-2400",
          children: (_b = schema == null ? void 0 : schema.oneOf) == null ? void 0 : _b.map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(Item, { children: oneOfRenderInfo.title ?? `Item ${oneOfIndex + 1}` }, oneOfIndex))
        }
      )
    ] }),
    /* @__PURE__ */ jsxs(ButtonGroup, { children: [
      /* @__PURE__ */ jsx(Button, { variant: "secondary", onPress: handleClose, children: "Cancel" }),
      /* @__PURE__ */ jsx(Button, { variant: "cta", onPress: () => handleOnConfirm(selectedIndex), autoFocus: true, children: "Confirm" })
    ] })
  ] }) });
}
const SpectrumArrayControl = React__default.memo(
  ({
    addItem,
    data,
    enabled,
    handleChange,
    label,
    moveDown,
    moveUp,
    path,
    removeItems,
    renderers,
    schema,
    uischema,
    uischemas
  }) => {
    var _a;
    const [addDialogIsOpen, setAddDialogIsOpen] = React__default.useState(false);
    const [moveUpIndex, setMoveUpIndex] = React__default.useState(null);
    const [selectedIndex, setSelectedIndex] = React__default.useState(0);
    const [indexOfFittingSchemaArray, setIndexOfFittingSchemaArray] = React__default.useState(
      (data == null ? void 0 : data.length) !== void 0 ? (data == null ? void 0 : data.map((boundData) => boundData ? void 0 : 999)) ?? [] : []
    );
    React__default.useEffect(() => {
      setIndexOfFittingSchemaArray(
        (data == null ? void 0 : data.length) !== void 0 ? (data == null ? void 0 : data.map((boundData) => boundData ? void 0 : 999)) ?? [] : []
      );
    }, []);
    const handleRemoveItem = React__default.useCallback(
      (path2, value) => () => {
        if (removeItems) {
          removeItems(path2, [value])();
        }
        indexOfFittingSchemaArray.splice(value, 1);
      },
      [removeItems]
    );
    const handleOnConfirm = React__default.useCallback(
      (indexOfFittingSchema) => {
        setIndexOfFittingSchemaArray([
          ...indexOfFittingSchemaArray,
          Math.floor(indexOfFittingSchema)
        ]);
        if (schema.oneOf) {
          addItem(path, createDefaultValue(schema.oneOf[indexOfFittingSchema]))();
        }
        indexOfFittingSchemaObject[path + `.${data == null ? void 0 : data.length}`] = selectedIndex;
        setSelectedIndex(0);
        setAddDialogIsOpen(false);
      },
      [
        setIndexOfFittingSchemaArray,
        indexOfFittingSchemaArray,
        schema.oneOf,
        addItem,
        createDefaultValue,
        setSelectedIndex,
        setAddDialogIsOpen
      ]
    );
    const duplicateContent = React__default.useCallback(
      (indexToDuplicate) => {
        handleChange(path, [
          ...data.filter((_, index) => index < indexToDuplicate),
          data[indexToDuplicate],
          data[indexToDuplicate],
          ...data.filter((_, index) => index > indexToDuplicate)
        ]);
      },
      [path, data]
    );
    const addItemPuttonPressedHandler = React__default.useCallback(() => {
      var _a2, _b, _c, _d;
      if ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.picker) {
        window.postMessage({
          type: "customPicker:open",
          open: true,
          schema,
          current: {
            path
          }
        });
      } else if (((_b = schema == null ? void 0 : schema.oneOf) == null ? void 0 : _b.length) === 1) {
        addItem(path, createDefaultValue(schema.oneOf[0]))();
      } else if (((_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.oneOfModal) || ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.modal)) {
        setAddDialogIsOpen(true);
      } else {
        addItem(path, createDefaultValue(schema ?? {}))();
      }
    }, [setAddDialogIsOpen]);
    const handleCustomPickerMessage = (e) => {
      var _a2, _b, _c, _d;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) === "customPicker:return" && ((_b = e == null ? void 0 : e.data) == null ? void 0 : _b.path) === path && ((_c = e == null ? void 0 : e.data) == null ? void 0 : _c.data)) {
        let newData = data ? [...data] : [];
        if (typeof ((_d = e == null ? void 0 : e.data) == null ? void 0 : _d.index) === "number") {
          newData[e.data.index] = e.data.data;
        } else {
          newData.push(e.data.data);
        }
        handleChange(path, newData);
      }
    };
    React__default.useEffect(() => {
      var _a2;
      if ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.picker) {
        window.addEventListener("message", handleCustomPickerMessage);
        return () => {
          window.removeEventListener("message", handleCustomPickerMessage);
        };
      }
    }, [data]);
    const sortMode = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.sortMode) ?? "DragAndDrop";
    const ArrayItem = (index) => /* @__PURE__ */ jsx(
      SpectrumArrayItemComponent$1,
      {
        duplicateItem: duplicateContent,
        enabled,
        index,
        path,
        removeItem: handleRemoveItem,
        renderers,
        schema,
        uischema,
        uischemas
      }
    );
    const closeAddDialog = React__default.useCallback(() => setAddDialogIsOpen(false), [setAddDialogIsOpen]);
    return /* @__PURE__ */ jsxs(View, { id: "jsonforms-array-wrapper", children: [
      /* @__PURE__ */ jsxs(Flex, { direction: "row", justifyContent: "space-between", children: [
        /* @__PURE__ */ jsx(Heading, { level: 4, children: label }),
        /* @__PURE__ */ jsx(
          AddDialog,
          {
            uischema,
            handleClose: closeAddDialog,
            selectedIndex,
            schema,
            setSelectedIndex,
            handleOnConfirm,
            open: addDialogIsOpen
          }
        )
      ] }),
      /* @__PURE__ */ jsxs(Flex, { id: `spectrum-renderer-arrayContentWrapper_${path}`, direction: "column", children: [
        (data == null ? void 0 : data.length) ? /* @__PURE__ */ jsx(Fragment, { children: sortMode ? /* @__PURE__ */ jsx(
          DragAndDrop,
          {
            data,
            enabled,
            handleChange,
            handleRemoveItem,
            indexOfFittingSchemaArray,
            moveDown,
            moveUp,
            moveUpIndex,
            onPressHandler: addItemPuttonPressedHandler,
            path,
            removeItems,
            renderers,
            schema,
            setMoveUpIndex,
            uischema,
            uischemas
          }
        ) : data.map((_, index) => {
          indexOfFittingSchemaObject[`${path}itemQuantity`] = data == null ? void 0 : data.length;
          return /* @__PURE__ */ jsx(
            Flex,
            {
              direction: "row",
              alignItems: "stretch",
              flex: "auto inherit",
              marginBottom: "size-100",
              children: ArrayItem(index)
            },
            index
          );
        }) }) : /* @__PURE__ */ jsx(Text, { children: "No data" }),
        /* @__PURE__ */ jsx(AddItemButton, { path, onPressFunction: addItemPuttonPressedHandler })
      ] })
    ] });
  }
);
const SpectrumArrayControl$1 = withHandleChange(SpectrumArrayControl);
const SpectrumArrayControlRenderer = React__default.memo(
  ({
    addItem,
    data,
    enabled,
    errors,
    id,
    moveDown,
    moveUp,
    path,
    removeItems,
    rootSchema,
    schema,
    uischema,
    uischemas = [],
    visible
  }) => {
    var _a;
    const controlElement = uischema;
    const labelDescription = Helpers.createLabelDescriptionFrom(controlElement, schema);
    const label = (labelDescription == null ? void 0 : labelDescription.show) ? (labelDescription == null ? void 0 : labelDescription.text) ?? "" : ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.label) ?? "";
    return visible ? /* @__PURE__ */ jsx(
      SpectrumArrayControl$1,
      {
        addItem,
        data,
        enabled,
        errors,
        id,
        label: label ?? "",
        moveDown,
        moveUp,
        path,
        removeItems,
        rootSchema,
        schema,
        uischema,
        uischemas,
        visible
      }
    ) : null;
  }
);
const SpectrumArrayModalControlRenderer = withJsonFormsArrayControlProps(withHandleChange(SpectrumArrayControlRenderer));
const SpectrumArrayModalControlTester = rankWith(
  4,
  and(
    uiTypeIs("Control"),
    schemaMatches((schema) => hasType(schema, "array") && !Array.isArray(schema.items))
  )
);
const isLayout = (uischema) => uischema.hasOwnProperty("elements");
const CombinatorProperties = ({
  combinatorKeyword,
  path,
  schema
}) => {
  const { [combinatorKeyword]: _, ...otherProps } = schema;
  const foundUISchema = Generate.uiSchema(otherProps, "VerticalLayout");
  let isLayoutWithElements = false;
  if (foundUISchema !== null && isLayout(foundUISchema)) {
    isLayoutWithElements = foundUISchema.elements.length > 0;
  }
  if (isLayoutWithElements) {
    return /* @__PURE__ */ jsx(JsonFormsDispatch, { schema: otherProps, path, uischema: foundUISchema });
  }
  return null;
};
const SpectrumAnyOfRenderer = ({
  cells,
  enabled,
  indexOfFittingSchema,
  path,
  renderers,
  rootSchema,
  schema,
  uischema,
  uischemas,
  visible
}) => {
  const [selectedAnyOf, setSelectedAnyOf] = React.useState(indexOfFittingSchema || 0);
  const handleChange = React.useCallback(
    (value) => setSelectedAnyOf(Number(value)),
    [setSelectedAnyOf]
  );
  const anyOf = "anyOf";
  let anyOfRenderInfos;
  if (schema == null ? void 0 : schema.anyOf) {
    anyOfRenderInfos = createCombinatorRenderInfos(
      schema.anyOf,
      rootSchema,
      anyOf,
      uischema,
      path,
      uischemas
    );
  }
  return /* @__PURE__ */ jsxs(View, { isHidden: !visible, UNSAFE_className: `anyof-renderer`, children: [
    /* @__PURE__ */ jsx(CombinatorProperties, { schema, combinatorKeyword: "anyOf", path }),
    anyOfRenderInfos && /* @__PURE__ */ jsxs(
      Tabs,
      {
        selectedKey: String(selectedAnyOf),
        onSelectionChange: handleChange,
        "aria-label": path,
        children: [
          /* @__PURE__ */ jsx(TabList, { children: anyOfRenderInfos == null ? void 0 : anyOfRenderInfos.map((anyOfRenderInfo, anyOfIndex) => /* @__PURE__ */ jsx(Item, { children: anyOfRenderInfo.label }, anyOfIndex)) }),
          /* @__PURE__ */ jsx(TabPanels, { children: anyOfRenderInfos == null ? void 0 : anyOfRenderInfos.map((anyOfRenderInfo, anyOfIndex) => /* @__PURE__ */ jsx(Item, { title: anyOfRenderInfo.label, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
            JsonFormsDispatch,
            {
              cells,
              enabled,
              path,
              renderers,
              schema: anyOfRenderInfo.schema,
              uischema: anyOfRenderInfo.uischema
            },
            anyOfIndex
          ) }) }, anyOfIndex)) })
        ]
      }
    )
  ] });
};
const SpectrumAnyOfRendererTester = rankWith(3, isAnyOfControl);
const SpectrumAnyOfRenderer$1 = withJsonFormsAnyOfProps(withHandleChange(SpectrumAnyOfRenderer));
const SpectrumTipTapRenderer = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputTipTapTextArea });
};
const SpectrumTipTapRendererTester = rankWith(20, optionIs("richText", true));
const SpectrumTipTapRenderer$1 = withJsonFormsControlProps(withHandleChange(SpectrumTipTapRenderer));
const InputCodeMirror = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    label,
    path,
    schema,
    uischema,
    visible
  }) => {
    let { colorScheme } = useProvider();
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const showSaveButton = appliedUiSchemaOptions.showSaveButton ?? false;
    const readOnly = appliedUiSchemaOptions.readOnly ?? schema.readOnly ?? false;
    const hideFormatButton = appliedUiSchemaOptions.hideFormatButton ?? false;
    const [value, setValue] = React__default.useState(data);
    const [initialValue, setInitialValue] = React__default.useState(data);
    const [cachedValue, setCachedValue] = React__default.useState(data);
    const err = getErr(value);
    const cachedErr = getErr(cachedValue);
    const saveAndFormat = () => {
      if (typeof cachedValue === "string") {
        handleChange(path, JSON.parse(cachedValue));
        setValue(JSON.parse(cachedValue));
      } else {
        handleChange(path, JSON.parse(JSON.stringify(cachedValue, circularReferenceReplacer())));
        setValue(JSON.parse(JSON.stringify(cachedValue, circularReferenceReplacer())));
      }
      setInitialValue(JSON.parse(JSON.stringify(JSON.parse(value), circularReferenceReplacer())));
    };
    const onChangeHandler = React__default.useCallback(
      (newValue, _viewUpdate) => {
        setCachedValue(newValue);
        setValue(newValue);
        if (!getErr(newValue) && !cachedErr && !showSaveButton) {
          handleChange(path, JSON.parse(newValue));
        }
      },
      [cachedValue]
    );
    function getErr(value2) {
      if (!value2) {
        return null;
      }
      try {
        if (typeof value2 === "string") {
          JSON.parse(value2);
        } else {
          JSON.parse(JSON.stringify(value2, circularReferenceReplacer()));
        }
        return null;
      } catch (err2) {
        return String(err2);
      }
    }
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, isHidden: !visible, children: [
      label && /* @__PURE__ */ jsx(
        "label",
        {
          className: "spectrum-label",
          style: { display: "flex", paddingTop: 4, paddingBottom: 5 },
          children: label
        }
      ),
      /* @__PURE__ */ jsx(
        CodeMirror,
        {
          value: JSON.stringify(initialValue, circularReferenceReplacer(), 2) || "",
          onChange: onChangeHandler,
          extensions: err || cachedErr ? [json(), linter(jsonParseLinter()), lintGutter()] : [json()],
          className: `spectrum-codemirror ${enabled ? "" : "read-only"}`,
          theme: colorScheme === "dark" ? "dark" : "light",
          editable: !readOnly && enabled,
          ...dataTestId(path)
        }
      ),
      !hideFormatButton && !readOnly && enabled && /* @__PURE__ */ jsx(View, { paddingTop: "size-50", children: /* @__PURE__ */ jsx(
        Button,
        {
          variant: "cta",
          onPress: saveAndFormat,
          isDisabled: !!err || !!cachedErr || JSON.stringify(value) === JSON.stringify(initialValue),
          ...dataTestId(`${path}-formatButton`),
          children: showSaveButton ? "Save" : "Format"
        }
      ) })
    ] });
  }
);
const SpectrumCodeMirror = (props) => {
  return /* @__PURE__ */ jsx(InputCodeMirror, { ...props, isValid: true });
};
const SpectrumCodeMirrorTester = rankWith(8, optionIs("codeMirror", true));
const SpectrumCodeMirror$1 = withJsonFormsControlProps(withHandleChange(SpectrumCodeMirror));
const SpectrumAllOfRenderer = ({
  cells,
  enabled,
  path,
  renderers,
  rootSchema,
  schema,
  uischema,
  uischemas,
  visible
}) => {
  const delegateUISchema = findMatchingUISchema(uischemas)(schema, uischema.scope, path);
  if (delegateUISchema) {
    return /* @__PURE__ */ jsx(View, { isHidden: !visible, children: /* @__PURE__ */ jsx(
      JsonFormsDispatch,
      {
        cells,
        enabled,
        path,
        renderers,
        schema,
        uischema: delegateUISchema
      }
    ) });
  }
  let allOfRenderInfos;
  if (schema == null ? void 0 : schema.allOf) {
    allOfRenderInfos = createCombinatorRenderInfos(
      schema.allOf,
      rootSchema,
      "allOf",
      uischema,
      path,
      uischemas
    );
  }
  return /* @__PURE__ */ jsx(View, { isHidden: !visible, children: allOfRenderInfos == null ? void 0 : allOfRenderInfos.map((allOfRenderInfo, allOfIndex) => /* @__PURE__ */ jsx(
    JsonFormsDispatch,
    {
      schema: allOfRenderInfo.schema,
      uischema: allOfRenderInfo.uischema,
      path,
      renderers,
      cells
    },
    allOfIndex
  )) });
};
const SpectrumAllOfRendererTester = rankWith(4, isAllOfControl);
const SpectrumAllOfRenderer$1 = withJsonFormsAllOfProps(withHandleChange(SpectrumAllOfRenderer));
const renderChildren = (layout, schema, styleProps, path, enabled) => {
  if (isEmpty(layout.elements)) {
    return [];
  }
  const { renderers, cells } = useJsonForms();
  return layout.elements.map((child, index) => {
    const style = typeof styleProps === "function" ? styleProps(index) : styleProps;
    return /* @__PURE__ */ jsx(View, { ...style, children: /* @__PURE__ */ jsx(
      JsonFormsDispatch,
      {
        renderers,
        cells,
        uischema: child,
        schema,
        path,
        enabled
      }
    ) }, `${path}-${index}`);
  });
};
const SpectrumGroupLayoutTester = rankWith(1, uiTypeIs("Group"));
const SpectrumGroupLayoutRenderer = ({
  enabled,
  path,
  schema,
  uischema,
  visible
}) => {
  const group = uischema;
  return /* @__PURE__ */ jsx(SpectrumProvider, { children: /* @__PURE__ */ jsxs(
    View,
    {
      borderColor: "dark",
      borderRadius: "medium",
      borderWidth: "thin",
      isHidden: visible === void 0 || visible === null ? false : !visible,
      padding: "size-250",
      children: [
        !isEmpty(group.label) ? /* @__PURE__ */ jsx(Heading, { level: 4, margin: 0, children: group.label }) : "",
        !isEmpty(group.label) ? /* @__PURE__ */ jsx(Divider, { size: "M", marginTop: "size-150", marginBottom: "size-200" }) : "",
        /* @__PURE__ */ jsx("div", { style: { boxSizing: "content-box" }, children: /* @__PURE__ */ jsx(Content, { children: renderChildren(group, schema, {}, path, enabled) }) })
      ]
    }
  ) });
};
const SpectrumGroupLayout = withJsonFormsLayoutProps(SpectrumGroupLayoutRenderer);
const SpectrumLayout = ({ children, visible, ...flexProps }) => {
  return /* @__PURE__ */ jsx(SpectrumProvider, { children: /* @__PURE__ */ jsx(
    Flex,
    {
      isHidden: visible === void 0 || visible === null ? false : !visible,
      gap: "size-100",
      ...flexProps,
      wrap: true,
      children
    }
  ) });
};
const SpectrumHorizontalLayoutTester = rankWith(
  1,
  uiTypeIs("HorizontalLayout")
);
const SpectrumHorizontalLayoutRenderer = ({
  schema,
  uischema,
  enabled,
  visible,
  path
}) => {
  var _a;
  const horizontalLayout = uischema;
  const spacing = ((_a = horizontalLayout.options) == null ? void 0 : _a.spacing) ?? [];
  const direction = "row";
  const childrenStyles = (i) => ({
    flexGrow: spacing[i] || 1,
    maxWidth: "100%",
    flexBasis: 0
  });
  return /* @__PURE__ */ jsx(
    SpectrumLayout,
    {
      direction,
      visible,
      enabled,
      path,
      uischema,
      schema,
      children: renderChildren(horizontalLayout, schema, childrenStyles, path, enabled)
    }
  );
};
const SpectrumHorizontalLayout = withJsonFormsLayoutProps(SpectrumHorizontalLayoutRenderer);
const SpectrumVerticalLayoutTester = rankWith(1, uiTypeIs("VerticalLayout"));
const SpectrumVerticalLayoutRenderer = ({
  enabled,
  path,
  schema,
  uischema,
  visible
}) => {
  const verticalLayout = uischema;
  const direction = "column";
  const childrenStyles = {
    flexGrow: 1,
    maxWidth: "100%",
    flexBasis: 0
  };
  return /* @__PURE__ */ jsx(
    SpectrumLayout,
    {
      direction,
      enabled,
      path,
      schema,
      uischema,
      visible,
      children: renderChildren(verticalLayout, schema, childrenStyles, path, enabled)
    }
  );
};
const SpectrumVerticalLayout = withJsonFormsLayoutProps(SpectrumVerticalLayoutRenderer);
const isSingleLevelCategorization = and(
  uiTypeIs("Categorization"),
  (uischema) => {
    const categorization = uischema;
    return categorization.elements && categorization.elements.length > 0 && categorization.elements.reduce((acc, e) => acc && e.type === "Category", true);
  }
);
const SpectrumCategorizationRendererTester = rankWith(
  1,
  isSingleLevelCategorization
);
const extractScopesAsPaths = (node) => {
  if (node == null ? void 0 : node.elements) {
    return node.elements.flatMap(extractScopesAsPaths);
  } else if (node == null ? void 0 : node.scope) {
    return [node.scope.replaceAll(/#?\/properties\//g, ".").replaceAll(/\//g, ".")];
  }
};
const SpectrumCategorizationRenderer = (props) => {
  var _a;
  const { data, path, schema, uischema, visible, enabled, ajv } = props;
  const categorization = uischema;
  const categories = categorization.elements.filter(
    (category, _index) => isVisible(category, data, "", ajv)
  );
  const { breadcrumbs } = useBreadcrumbs();
  const shortestOutstandingBreadcrumb = breadcrumbs.hasPrefix(path) ? (_a = breadcrumbs.keys().filter((breadcrumbPath) => breadcrumbPath.startsWith(path)).map((breadcrumbPath) => breadcrumbPath.slice(path.length)).filter((breadcrumbPath) => breadcrumbPath[0] === ".").sort((x, y) => x.length - y.length)) == null ? void 0 : _a[0] : void 0;
  const defaultOpenTab = (shortestOutstandingBreadcrumb ? categories.findIndex(
    (category) => extractScopesAsPaths(category).find(
      (scopeAsPath) => scopeAsPath === shortestOutstandingBreadcrumb
    )
  ) || 0 : 0).toString();
  return /* @__PURE__ */ jsx(View, { isHidden: !visible, children: /* @__PURE__ */ jsxs(
    Tabs,
    {
      "aria-label": "Categorization",
      isDisabled: enabled === void 0 ? false : !enabled,
      defaultSelectedKey: defaultOpenTab,
      children: [
        /* @__PURE__ */ jsx(TabList, { children: categories == null ? void 0 : categories.map((category, index) => {
          return /* @__PURE__ */ jsx(
            Item,
            {
              ...dataTestId(
                `${path}-${(category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`}-tabButton`
              ),
              children: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`
            },
            index
          );
        }) }),
        /* @__PURE__ */ jsx(TabPanels, { children: categories == null ? void 0 : categories.map((category, index) => /* @__PURE__ */ jsx(Item, { title: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
          SpectrumVerticalLayout,
          {
            uischema: {
              type: "VerticalLayout",
              elements: category.elements ?? []
            },
            schema,
            path,
            direction: "column",
            enabled: enabled === void 0 ? true : enabled,
            visible: visible === void 0 ? true : visible
          }
        ) }) }, index)) })
      ]
    }
  ) });
};
const SpectrumCategorizationRenderer$1 = withJsonFormsLayoutProps(withAjvProps(SpectrumCategorizationRenderer));
const SpectrumCategorizationStepperRendererTester = rankWith(
  2,
  and(uiTypeIs("Categorization"), categorizationHasCategory, optionIs("variant", "stepper"))
);
const SpectrumCategorizationStepperRenderer = (props) => {
  const { data, ajv, path, schema, visible, enabled, uischema, config } = props;
  const [step, setStep] = React__default.useState(0);
  const selectStep = (selectedItem) => {
    setStep(Number(selectedItem));
  };
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const categorization = uischema;
  const categories = categorization.elements.filter(
    (value, _index) => isVisible(value, data, "", ajv)
  );
  return /* @__PURE__ */ jsxs(Flex, { direction: "column", isHidden: !visible, UNSAFE_className: "categorization-stepper", children: [
    /* @__PURE__ */ jsxs(
      Tabs,
      {
        "aria-label": "Categorization with Stepper",
        isDisabled: enabled === void 0 ? false : !enabled,
        selectedKey: String(step),
        onSelectionChange: selectStep,
        children: [
          /* @__PURE__ */ jsx(TabList, { children: categories.map((category, index) => /* @__PURE__ */ jsx(Item, { children: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}` }, index)) }),
          /* @__PURE__ */ jsx(TabPanels, { children: categories.map((category, index) => /* @__PURE__ */ jsx(Item, { title: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
            SpectrumVerticalLayout,
            {
              uischema: {
                type: "VerticalLayout",
                elements: category.elements ?? []
              },
              schema,
              path,
              direction: "column",
              enabled: enabled === void 0 ? true : enabled,
              visible: visible === void 0 ? true : visible
            }
          ) }) }, index)) })
        ]
      }
    ),
    Boolean(appliedUiSchemaOptions.showNavButtons) ? /* @__PURE__ */ jsxs(ButtonGroup, { marginX: "size-160", marginBottom: "size-160", flex: "auto", align: "end", children: [
      /* @__PURE__ */ jsx(Button, { variant: "secondary", isDisabled: step <= 0, onPress: () => selectStep(step - 1), children: "Previous" }),
      /* @__PURE__ */ jsx(
        Button,
        {
          variant: "primary",
          isDisabled: step >= categories.length - 1,
          onPress: () => selectStep(step + 1),
          children: "Next"
        }
      )
    ] }) : /* @__PURE__ */ jsx(Fragment, {})
  ] });
};
const SpectrumCategorizationStepperRenderer$1 = withJsonFormsLayoutProps(withAjvProps(SpectrumCategorizationStepperRenderer));
const SpectrumLabelRendererTester = rankWith(1, uiTypeIs("Label"));
const SpectrumLabelRenderer = ({
  uischema,
  visible
}) => {
  const labelElement = uischema;
  const isHidden = !visible;
  return /* @__PURE__ */ jsx(Text, { isHidden, children: labelElement.text !== void 0 && labelElement.text !== null && labelElement.text });
};
const SpectrumLabelRenderer$1 = withJsonFormsLayoutProps(SpectrumLabelRenderer);
const oneOf = "oneOf";
const SpectrumOneOfRenderer = ({
  cells,
  data,
  enabled,
  handleChange,
  id,
  indexOfFittingSchema,
  path,
  renderers,
  rootSchema,
  schema,
  uischema,
  uischemas,
  visible
}) => {
  var _a, _b, _c, _d, _e, _f, _g;
  let oneOfRenderInfos;
  if (schema.oneOf) {
    oneOfRenderInfos = createCombinatorRenderInfos(
      schema.oneOf,
      rootSchema,
      oneOf,
      uischema,
      path,
      uischemas
    );
  }
  let indexFromDiscriminator = void 0;
  const discriminatingProperty = (_a = schema.discriminator) == null ? void 0 : _a.propertyName;
  if (discriminatingProperty) {
    const discriminatorValues = oneOfRenderInfos == null ? void 0 : oneOfRenderInfos.map(
      (info) => {
        var _a2, _b2;
        return (_b2 = (_a2 = info.schema.properties) == null ? void 0 : _a2[discriminatingProperty]) == null ? void 0 : _b2.const;
      }
    );
    indexFromDiscriminator = discriminatorValues == null ? void 0 : discriminatorValues.indexOf(data == null ? void 0 : data[discriminatingProperty]);
  }
  const [open, setOpen] = React__default.useState(false);
  let oneOfList = (_b = schema == null ? void 0 : schema.oneOf) == null ? void 0 : _b.map((item) => item["$ref"]);
  let oneOfPathList = oneOfList == null ? void 0 : oneOfList.map((item) => item == null ? void 0 : item.split("/").pop());
  const aemTitle = (_d = (_c = data == null ? void 0 : data._model) == null ? void 0 : _c._path) == null ? void 0 : _d.split("/").pop();
  const aemTitleShortener = oneOfPathList == null ? void 0 : oneOfPathList.indexOf(aemTitle);
  const selectedIndexFunction = () => {
    if (indexFromDiscriminator) {
      return indexFromDiscriminator;
    } else if (aemTitle && aemTitleShortener !== -1) {
      return aemTitleShortener;
    } else if (indexOfFittingSchema) {
      return indexOfFittingSchema;
    } else if (indexOfFittingSchemaObject[path]) {
      return indexOfFittingSchemaObject[path];
    } else {
      return 0;
    }
  };
  const [selectedIndex, setSelectedIndex] = React__default.useState(selectedIndexFunction());
  const [newSelectedIndex, setNewSelectedIndex] = React__default.useState(0);
  const handleClose = React__default.useCallback(() => setOpen(false), [setOpen]);
  if (!Number.isNaN(Number((_e = path.split(".")) == null ? void 0 : _e.pop()))) {
    oneOfRenderInfos = oneOfRenderInfos == null ? void 0 : oneOfRenderInfos.map((oneOfRenderInfo) => {
      if (oneOfRenderInfo.uischema.type === "ContentFragmentReferenceWithDetail") {
        return Object.assign({}, oneOfRenderInfo, {
          uischema: oneOfRenderInfo.uischema.elements[0]
        });
      } else {
        return oneOfRenderInfo;
      }
    });
  }
  const openNewTab = (newIndex) => {
    if (schema == null ? void 0 : schema.oneOf) {
      handleChange(path, createDefaultValue(schema == null ? void 0 : schema.oneOf[newIndex]));
    }
    setSelectedIndex(newIndex);
  };
  const confirm = React__default.useCallback(() => {
    openNewTab(newSelectedIndex);
    setOpen(false);
  }, [handleChange, createDefaultValue, newSelectedIndex]);
  const handleTabChange = React__default.useCallback(
    (newOneOfIndex) => {
      newOneOfIndex = Number(newOneOfIndex);
      setNewSelectedIndex(newOneOfIndex);
      if (isEmpty(data)) {
        openNewTab(newOneOfIndex);
      } else {
        setOpen(true);
      }
    },
    [setOpen, setSelectedIndex, data]
  );
  const usePickerInsteadOfTabs = indexOfFittingSchemaObject["OneOfPicker"] === true || ((_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.OneOfPicker) === true;
  const hideTabs = indexOfFittingSchemaObject["oneOfModal"] === true || ((_g = uischema == null ? void 0 : uischema.options) == null ? void 0 : _g.oneOfModal) === true;
  if (!oneOfRenderInfos)
    return null;
  return /* @__PURE__ */ jsxs(View, { isHidden: !visible, children: [
    /* @__PURE__ */ jsx(CombinatorProperties, { combinatorKeyword: "oneOf", path, schema }),
    usePickerInsteadOfTabs ? /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsx(
        Picker,
        {
          "aria-label": "Select",
          "aria-labelledby": "Select",
          isDisabled: enabled === void 0 ? false : !enabled,
          onSelectionChange: handleTabChange,
          selectedKey: String(selectedIndex),
          width: "100%",
          isHidden: hideTabs,
          children: oneOfRenderInfos.map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(Item, { children: oneOfRenderInfo.label }, oneOfIndex))
        }
      ),
      oneOfRenderInfos.filter((_oneOfRenderInfo, oneOfIndex) => oneOfIndex === selectedIndex).map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
        JsonFormsDispatch,
        {
          cells,
          path,
          renderers,
          schema: oneOfRenderInfo.schema,
          uischema: oneOfRenderInfo.uischema
        },
        oneOfIndex
      ) }) }, oneOfIndex))
    ] }) : /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsxs(
      Tabs,
      {
        "aria-label": "Select",
        isDisabled: enabled === void 0 ? false : !enabled,
        selectedKey: String(selectedIndex),
        onSelectionChange: handleTabChange,
        children: [
          /* @__PURE__ */ jsx(TabList, { isHidden: hideTabs, children: oneOfRenderInfos.map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(Item, { children: oneOfRenderInfo.label }, oneOfIndex)) }),
          /* @__PURE__ */ jsx(TabPanels, { children: oneOfRenderInfos.map((oneOfRenderInfo, oneOfIndex) => {
            return /* @__PURE__ */ jsx(Item, { title: oneOfRenderInfo.label, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
              JsonFormsDispatch,
              {
                cells,
                enabled,
                path,
                renderers,
                schema: oneOfRenderInfo.schema,
                uischema: oneOfRenderInfo.uischema
              },
              oneOfIndex
            ) }) }, oneOfIndex);
          }) })
        ]
      }
    ) }),
    /* @__PURE__ */ jsx(DialogContainer, { onDismiss: handleClose, children: open && /* @__PURE__ */ jsxs(Dialog, { children: [
      /* @__PURE__ */ jsx(Heading, { children: "Clear Form?" }),
      /* @__PURE__ */ jsx(Divider, {}),
      /* @__PURE__ */ jsx(Content, { children: "Your Data will be cleared if you navigate away from this Tab. Do you want to Clear your Form?" }),
      /* @__PURE__ */ jsxs(ButtonGroup, { children: [
        /* @__PURE__ */ jsx(Button, { variant: "secondary", onPress: handleClose, children: "Cancel" }),
        /* @__PURE__ */ jsx(
          Button,
          {
            variant: "cta",
            onPress: confirm,
            autoFocus: true,
            id: id && `oneOf-${id}-confirm-yes`,
            children: "Clear Form"
          }
        )
      ] })
    ] }) })
  ] });
};
const SpectrumOneOfRendererTester = (uischema, schema, context) => {
  return isOneOfControl(uischema, schema, context) ? 5 : -1;
};
const SpectrumOneOfRenderer$1 = withJsonFormsOneOfProps(withHandleChange(SpectrumOneOfRenderer));
function FragmentReferenceHeader({
  customPicker,
  data,
  expanded,
  setExpanded,
  isDetailedViewHeader,
  label,
  removeItem,
  uischema,
  path
}) {
  var _a, _b, _c, _d, _e, _f, _g;
  const noData = !data;
  const [deleteModalOpen, setDeleteModalOpen] = React__default.useState(false);
  const actionMenuTriggered = (action) => {
    const testArr = action.split("-");
    testArr[0] = testArr[0].toLowerCase();
    const actionName = testArr.join("");
    const lookupObj = {
      delete: () => setDeleteModalOpen(true)
    };
    lookupObj[actionName]();
  };
  const pathFilter = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.pathFilter;
  let displayPath = "";
  if (typeof pathFilter === "string") {
    displayPath = ((_b = data == null ? void 0 : data._path) == null ? void 0 : _b.replace(pathFilter, "")) || "";
  } else {
    displayPath = ((_c = data == null ? void 0 : data._path) == null ? void 0 : _c.split("/").slice(3).join("/")) || "";
    if (displayPath) {
      displayPath = `/${displayPath}`;
    }
  }
  const [durationBeforeDelete, setDurationBeforeDelete] = React__default.useState(0);
  const onPressStartHandler = () => {
    if (expanded) {
      setExpanded(false);
      setDurationBeforeDelete(700);
    }
  };
  const onPressEndHandler = () => {
    setDeleteModalOpen(false);
    setTimeout(() => {
      if (removeItem) {
        removeItem();
      }
    }, durationBeforeDelete);
  };
  const imageSrc = typeof ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.dataAsImage) === "number" && data ? Object.values(data)[(_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.dataAsImage] : findValue(data, (_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.dataAsImage) ?? void 0;
  const MediaPreview2 = (_g = uischema == null ? void 0 : uischema.options) == null ? void 0 : _g.mediaPreview;
  return /* @__PURE__ */ jsx(View, { "aria-selected": expanded, UNSAFE_className: "array-item-header", children: /* @__PURE__ */ jsxs(Flex, { direction: "row", margin: "size-50", justifyContent: "space-between", alignItems: "center", children: [
    /* @__PURE__ */ jsxs(
      ActionButton,
      {
        flex: "1 1 auto",
        isQuiet: true,
        onPress: () => setExpanded(!expanded),
        "aria-label": `expand-item-${label}`,
        isDisabled: noData,
        ...dataTestId(path),
        children: [
          imageSrc && MediaPreview2 && /* @__PURE__ */ jsx(
            "img",
            {
              src: imageSrc,
              height: isDetailedViewHeader ? "45" : "50",
              alt: "Preview Picture",
              style: {
                aspectRatio: "1/1",
                objectFit: "cover",
                marginRight: "10px",
                marginLeft: "2px",
                marginTop: isDetailedViewHeader ? "10px" : "0px"
              }
            }
          ),
          (data == null ? void 0 : data._path) && displayPath ? /* @__PURE__ */ jsxs(
            Text,
            {
              UNSAFE_style: {
                position: "absolute",
                direction: "rtl",
                opacity: 0.7,
                bottom: -5,
                left: 0,
                fontSize: "12px",
                height: 18,
                maxWidth: "calc(100% - 12px)",
                textOverflow: "ellipsis",
                overflow: "hidden",
                whiteSpace: "nowrap",
                textAlign: "left",
                alignSelf: "start",
                justifyContent: "start"
              },
              children: [
                "‎",
                displayPath
              ]
            }
          ) : null,
          /* @__PURE__ */ jsx(
            Text,
            {
              UNSAFE_className: "spectrum-array-item-name",
              UNSAFE_style: {
                paddingLeft: 0,
                textAlign: "left",
                width: "100%",
                transform: (data == null ? void 0 : data._path) && displayPath ? "translateY(-20%)" : "",
                fontWeight: 600
              },
              children: label
            }
          )
        ]
      }
    ),
    /* @__PURE__ */ jsx(View, { children: noData ? /* @__PURE__ */ jsx(Flex, { gap: "size-0", children: /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ActionButton,
        {
          onPress: customPicker.handler,
          isQuiet: true,
          "aria-label": `change-reference-${label}`,
          ...dataTestId(`change-reference-${path}`),
          children: /* @__PURE__ */ jsx(FolderSearch, { "aria-label": "Change Reference", size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Change Content Fragment Reference" })
    ] }) }) : /* @__PURE__ */ jsxs(Flex, { gap: "size-0", children: [
      /* @__PURE__ */ jsx(ActionMenu, { align: "end", onAction: actionMenuTriggered, isQuiet: true, children: /* @__PURE__ */ jsxs(Item, { textValue: `Clear-item-${label}`, children: [
        /* @__PURE__ */ jsx(Text, { children: "Clear" }),
        /* @__PURE__ */ jsx(Delete, { size: "S" })
      ] }, "delete") }),
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            onPress: customPicker.handler,
            isQuiet: true,
            "aria-label": `change-reference-${label}`,
            ...dataTestId(`change-reference-${path}`),
            children: /* @__PURE__ */ jsx(FolderSearch, { "aria-label": "Change Reference", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: "Change Content Fragment Reference" })
      ] }),
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            onPress: () => setExpanded(!expanded),
            isQuiet: true,
            "aria-label": `expand-item-${label}`,
            ...dataTestId(`${path}-iconButton`),
            children: expanded ? /* @__PURE__ */ jsx(Close, { "aria-label": "Close", size: "S" }) : /* @__PURE__ */ jsx(Edit, { "aria-label": "Edit", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: expanded ? "Close" : "Edit" })
      ] }),
      /* @__PURE__ */ jsx(
        DeleteDialog,
        {
          cancelBtnText: "Cancel",
          confirmBtnText: "Clear",
          contentText: "Are you sure you want to clear this item?",
          deleteModalOpen,
          headingText: "Clear Item?",
          onPressEndHandler: () => onPressEndHandler(),
          onPressStartHandler: () => onPressStartHandler(),
          setDeleteModalOpen
        }
      )
    ] }) })
  ] }) });
}
const FragmentReference = React__default.memo(
  ({
    data,
    path,
    label,
    schema,
    uischema,
    allowedSchemas,
    handleChange,
    enabled,
    picker
  }) => {
    var _a, _b, _c;
    label = label || ((_a = data == null ? void 0 : data._metadata) == null ? void 0 : _a.stringMetadata.find((item) => item.name === "title").value) || ((_b = data == null ? void 0 : data._model) == null ? void 0 : _b.title) || (uischema == null ? void 0 : uischema.label) || "No Title found";
    const [isAnimating, setIsAnimating] = React__default.useState(false);
    const { breadcrumbs, addBreadcrumb, truncateBreadcrumbsAtParent } = useBreadcrumbs();
    const expanded = breadcrumbs.hasPrefix(path);
    const setExpanded = React__default.useCallback(
      (desiredState) => {
        if (desiredState) {
          addBreadcrumb({
            path,
            name: label || null,
            crxPath: data == null ? void 0 : data._path
          });
        } else {
          truncateBreadcrumbsAtParent(path);
        }
        setIsAnimating(true);
        setTimeout(() => {
          setIsAnimating(false);
        }, 100);
      },
      [path, label, addBreadcrumb, truncateBreadcrumbsAtParent, breadcrumbs]
    );
    React__default.useEffect(() => {
      if (breadcrumbs.hasPrefix(path)) {
        setExpanded(true);
      }
    }, [breadcrumbs]);
    const customPickerHandler = () => {
      window.postMessage({
        type: "customPicker:open",
        open: true,
        schema: allowedSchemas,
        current: {
          path,
          index: 0,
          data
        }
      });
    };
    const handleCustomPickerMessage = (e) => {
      var _a2, _b2, _c2;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) === "customPicker:return" && ((_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.path) === path && ((_c2 = e == null ? void 0 : e.data) == null ? void 0 : _c2.data)) {
        handleChange(path, e.data.data);
      }
    };
    React__default.useEffect(() => {
      if (picker) {
        window.addEventListener("message", handleCustomPickerMessage);
      }
      return () => {
        if (picker) {
          window.removeEventListener("message", handleCustomPickerMessage);
        }
      };
    }, [data]);
    const header = (isDetailedViewHeader) => {
      var _a2;
      return /* @__PURE__ */ jsx(
        FragmentReferenceHeader,
        {
          customPicker: { enabled: (_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.picker, handler: customPickerHandler },
          data,
          expanded,
          setExpanded,
          isDetailedViewHeader,
          label,
          path,
          removeItem: () => handleChange(path, null),
          uischema
        }
      );
    };
    const { renderers, cells } = useJsonForms();
    return /* @__PURE__ */ jsxs(
      View,
      {
        UNSAFE_className: `list-array-item enableDetailedView ${expanded ? "expanded" : "collapsed"} ${((_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.noAccordion) ? "no-accordion" : ""}`,
        borderWidth: "thin",
        borderColor: "dark",
        borderRadius: "medium",
        padding: "size-150",
        width: "100%",
        children: [
          header(false),
          /* @__PURE__ */ jsx(
            ModalItemAnimationWrapper,
            {
              expanded,
              setExpanded,
              header: header(true),
              isAnimating,
              path,
              setIsAnimating,
              elements: /* @__PURE__ */ jsx(
                JsonFormsDispatch,
                {
                  renderers,
                  cells,
                  uischema,
                  schema,
                  path,
                  enabled
                }
              )
            }
          )
        ]
      }
    );
  }
);
const FragmentReference$1 = withHandleChange(FragmentReference);
const SpectrumFragmentReferenceControl = React__default.memo(
  ({
    data,
    enabled,
    handleChange,
    label,
    path,
    renderers,
    rootSchema,
    schema,
    uischema,
    uischemas,
    visible
  }) => {
    var _a, _b;
    const oneOfRenderInfos = schema.oneOf ? createCombinatorRenderInfos(schema.oneOf, rootSchema, "oneOf", uischema, path, uischemas) : [
      {
        schema,
        uischema: findUISchema(uischemas, schema, uischema.scope, path, void 0, uischema),
        label
      }
    ];
    let indexFromDiscriminator = 0;
    const discriminatingProperty = (_a = schema.discriminator) == null ? void 0 : _a.propertyName;
    if (discriminatingProperty) {
      const discriminatorValues = oneOfRenderInfos == null ? void 0 : oneOfRenderInfos.map(
        (info2) => {
          var _a2, _b2;
          return (_b2 = (_a2 = info2.schema.properties) == null ? void 0 : _a2[discriminatingProperty]) == null ? void 0 : _b2.const;
        }
      );
      indexFromDiscriminator = discriminatorValues == null ? void 0 : discriminatorValues.indexOf(data == null ? void 0 : data[discriminatingProperty]);
    }
    const info = oneOfRenderInfos[indexFromDiscriminator > 0 ? indexFromDiscriminator : 0];
    return /* @__PURE__ */ jsxs(View, { children: [
      /* @__PURE__ */ jsx(Flex, { direction: "row", justifyContent: "space-between", children: /* @__PURE__ */ jsx(Heading, { level: 4, children: label }) }),
      /* @__PURE__ */ jsx(Flex, { direction: "column", gap: "size-100", children: /* @__PURE__ */ jsx(Flex, { direction: "row", alignItems: "stretch", flex: "auto inherit", children: /* @__PURE__ */ jsx(
        FragmentReference$1,
        {
          data,
          enabled,
          path,
          renderers,
          schema: info.schema,
          allowedSchemas: oneOfRenderInfos.map((info2) => info2.schema),
          uischema: info.uischema,
          visible,
          handleChange,
          picker: (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.picker
        }
      ) }) })
    ] });
  }
);
const SpectrumFragmentReferenceControl$1 = withJsonFormsOneOfProps(withHandleChange(SpectrumFragmentReferenceControl));
const SpectrumFragmentReferenceControlTester = rankWith(
  10,
  and(isControl, optionIs("fragmentReference", true))
);
const SpectrumContentReferenceControl = React__default.memo(
  ({
    config,
    data,
    enabled,
    errors,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    rootSchema,
    schema,
    uischema,
    visible
  }) => {
    var _a, _b, _c, _d, _e, _f, _g;
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const [inputText, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const idlePostMessage = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.idlePostMessage;
    const assetPickerOptions = (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.assetPicker;
    const { externalizePath } = useContext(RenderersConfigContext);
    const previewMedia = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.previewMedia) ?? false;
    const externalizeAsset = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.externalizeAsset) ?? false;
    const previewMediaSuffix = typeof data === "string" ? data == null ? void 0 : data.substring((data == null ? void 0 : data.lastIndexOf(".")) + 1) : false;
    const sendMessage = () => {
      const message = {
        type: "assetPickerOpen",
        jsonFormsPath: path
        /* rootPath: 'x_rootPath',
        selectedPath: '_path', */
      };
      const targetOrigin = "*";
      window.postMessage(message, targetOrigin);
    };
    window.addEventListener("message", (e) => {
      var _a2, _b2;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) && ((_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.type) === "assetPickerClose") {
        if (e.data.jsonFormsPath !== path)
          return;
        onChange(e.data.selectedPath);
      }
    });
    const firstRender = React__default.useRef(true);
    if (idlePostMessage) {
      React__default.useEffect(() => {
        if (firstRender.current) {
          firstRender.current = false;
          return;
        }
        const delayDebounceFn = setTimeout(() => {
          sendMessage();
        }, 3e3);
        return () => clearTimeout(delayDebounceFn);
      }, [inputText]);
    }
    React__default.useEffect(() => {
      onChange(data);
    }, [data]);
    return /* @__PURE__ */ jsx(View, { width: "100%", children: /* @__PURE__ */ jsxs(Flex, { direction: "column", gap: "size-100", children: [
      /* @__PURE__ */ jsxs(Flex, { direction: "row", alignItems: "stretch", flex: "auto inherit", children: [
        /* @__PURE__ */ jsx(
          InputText,
          {
            data,
            handleChange,
            isValid: isValid ?? true,
            label: !((_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.noLabel) ? label : void 0,
            path,
            required,
            schema,
            uischema,
            rootSchema,
            enabled,
            id,
            errors,
            visible
          }
        ),
        /* @__PURE__ */ jsxs(
          ActionButton,
          {
            onPress: () => sendMessage(),
            "aria-label": (assetPickerOptions == null ? void 0 : assetPickerOptions.buttonText) ?? `Asset Picker`,
            UNSAFE_className: "assetpicker-button",
            UNSAFE_style: (assetPickerOptions == null ? void 0 : assetPickerOptions.icon) === false || (assetPickerOptions == null ? void 0 : assetPickerOptions.buttonText) === false ? { marginTop: ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.noLabel) ? 0 : 25 } : {
              paddingRight: (assetPickerOptions == null ? void 0 : assetPickerOptions.buttonText) ? 8 : 0,
              marginTop: ((_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.noLabel) ? 0 : 24
            },
            children: [
              (assetPickerOptions == null ? void 0 : assetPickerOptions.icon) === false ? void 0 : ((_g = (_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.assetPickerOptions) == null ? void 0 : _g.icon) === "url" ? /* @__PURE__ */ jsx(Link, { size: "S" }) : (assetPickerOptions == null ? void 0 : assetPickerOptions.icon) === "asset" ? /* @__PURE__ */ jsx(Asset, { size: "S" }) : /* @__PURE__ */ jsx(FolderOpen, { size: "S" }),
              assetPickerOptions == null ? void 0 : assetPickerOptions.buttonText
            ]
          }
        )
      ] }),
      previewMedia ? previewMediaSuffix === "mp4" || previewMediaSuffix === "ogg" || previewMediaSuffix === "webm" ? /* @__PURE__ */ jsxs(
        "video",
        {
          controls: true,
          src: externalizeAsset ? `${externalizeAsset}${externalizePath == null ? void 0 : externalizePath(data)}` : data,
          width: 200,
          style: { marginTop: 10 },
          children: [
            'Sorry, but the Media "',
            data,
            `" couldn't be displayed.`
          ]
        }
      ) : /* @__PURE__ */ jsx(
        "img",
        {
          src: externalizeAsset ? `${externalizeAsset}${externalizePath == null ? void 0 : externalizePath(data)}` : data,
          alt: `Preview of ${data}`,
          width: 200,
          style: { marginTop: 10 },
          onError: (e) => {
            e.currentTarget.src = "https://jenkinselite.com/wp-content/uploads/2018/11/no_media.png";
          }
        }
      ) : null
    ] }) });
  }
);
const SpectrumContentReferenceControl$1 = withJsonFormsOneOfProps(withHandleChange(SpectrumContentReferenceControl));
const SpectrumContentReferenceControlTester = rankWith(
  10,
  and(isControl, optionIs("contentReference", true))
);
const ListWithDetailMasterItem = React__default.memo(
  ({ childLabel, handleSelect, index, path, removeItem, selected }) => {
    const [deleteIndex, setdeleteIndex] = React__default.useState(0);
    const [open, setOpen] = React__default.useState(false);
    const handleClose = React__default.useCallback(() => setOpen(false), [setOpen]);
    const itemLabel = childLabel === "" || !childLabel ? `Item ${index + 1}` : childLabel;
    const setOpenAndsetDeleteIndex = (index2) => {
      setOpen(true);
      setdeleteIndex(index2);
    };
    const deleteItem = (path2) => {
      handleClose();
      removeItem(path2, deleteIndex)();
    };
    return /* @__PURE__ */ jsx("div", { className: "list-with-detail-master-item-row", "aria-selected": selected, children: /* @__PURE__ */ jsxs(Flex, { direction: "row", margin: "size-50", justifyContent: "space-between", alignItems: "center", children: [
      /* @__PURE__ */ jsx(View, { UNSAFE_className: "list-with-detail-master-item-number", children: /* @__PURE__ */ jsx(Text, { children: index + 1 }) }),
      /* @__PURE__ */ jsx(
        ActionButton,
        {
          flex: "auto",
          isQuiet: true,
          onPress: handleSelect(index),
          "aria-label": `select-item-${itemLabel}`,
          children: /* @__PURE__ */ jsx(Text, { UNSAFE_style: { textAlign: "left", maxWidth: "30ch" }, children: itemLabel })
        }
      ),
      /* @__PURE__ */ jsxs(View, { children: [
        /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
          /* @__PURE__ */ jsx(
            ActionButton,
            {
              onPress: () => setOpenAndsetDeleteIndex(index),
              "aria-label": `delete-item-${itemLabel}`,
              children: /* @__PURE__ */ jsx(Delete, { "aria-label": "Delete", size: "S" })
            }
          ),
          /* @__PURE__ */ jsx(Tooltip, { children: "Delete" })
        ] }),
        /* @__PURE__ */ jsx(DialogContainer, { onDismiss: handleClose, children: open && /* @__PURE__ */ jsxs(Dialog, { children: [
          /* @__PURE__ */ jsx(Heading, { children: "Delete Item?" }),
          /* @__PURE__ */ jsx(Divider, {}),
          /* @__PURE__ */ jsx(Content, { children: "Are you sure you wish to delete this item?" }),
          /* @__PURE__ */ jsxs(ButtonGroup, { children: [
            /* @__PURE__ */ jsx(Button, { variant: "secondary", onPress: handleClose, children: "Cancel" }),
            /* @__PURE__ */ jsx(Button, { variant: "cta", onPress: () => deleteItem(path), autoFocus: true, children: "Delete" })
          ] })
        ] }) })
      ] })
    ] }) });
  }
);
const ListWithDetailMasterItem$1 = withJsonFormsMasterListItemProps(ListWithDetailMasterItem);
const ArrayLayoutToolbar = React__default.memo(
  ({ label, errors, addItem, path, createDefault }) => {
    return /* @__PURE__ */ jsxs(Flex, { direction: "row", alignItems: "center", children: [
      /* @__PURE__ */ jsx(Heading, { level: 4, children: label }),
      /* @__PURE__ */ jsx(View, { marginEnd: "auto", children: errors.length !== 0 && /* @__PURE__ */ jsx(ErrorIndicator, { errors }) }),
      /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(Button, { "aria-label": "add", onPress: addItem(path, createDefault()), variant: "primary", children: /* @__PURE__ */ jsx(Add, { "aria-label": "Add", size: "S" }) }),
        /* @__PURE__ */ jsx(Tooltip, { children: `Add to ${label}` })
      ] }) })
    ] });
  }
);
const SpectrumListWithDetailRenderer = React__default.memo(
  ({
    addItem,
    cells,
    config,
    data,
    enabled,
    errors,
    path,
    removeItems,
    renderers,
    required = false,
    schema,
    uischema,
    uischemas = [],
    visible
  }) => {
    const [selectedIndex, setSelectedIndex] = React__default.useState(void 0);
    const handleRemoveItem = React__default.useCallback(
      (p, value) => () => {
        setSelectedIndex(void 0);
        if (removeItems) {
          removeItems(p, [value])();
        }
      },
      [removeItems]
    );
    const handleListItemClick = React__default.useCallback(
      (index) => () => setSelectedIndex(index),
      [setSelectedIndex]
    );
    const handleCreateDefaultValue = React__default.useCallback(
      () => createDefaultValue(schema ?? {}),
      [createDefaultValue]
    );
    const foundUISchema = findUISchema(
      uischemas,
      schema,
      uischema.scope,
      path,
      void 0,
      uischema
    );
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const addItemAndSelectNewItem = (p, v) => () => {
      addItem(p, v)();
      setSelectedIndex(data);
    };
    return /* @__PURE__ */ jsxs(View, { isHidden: !visible, children: [
      /* @__PURE__ */ jsx(
        ArrayLayoutToolbar,
        {
          addItem: addItemAndSelectNewItem,
          createDefault: handleCreateDefaultValue,
          errors,
          label: computeLabel(
            (schema == null ? void 0 : schema.title) ?? (schema == null ? void 0 : schema.default),
            required,
            appliedUiSchemaOptions.hideRequiredAsterisk
          ),
          path
        }
      ),
      /* @__PURE__ */ jsxs(Flex, { direction: "row", children: [
        /* @__PURE__ */ jsx(Flex, { direction: "column", marginY: "size-200", marginEnd: "size-200", children: data > 0 ? Array.from(Array(data)).map((_, index) => /* @__PURE__ */ jsx(
          ListWithDetailMasterItem$1,
          {
            handleSelect: handleListItemClick,
            index,
            path,
            removeItem: handleRemoveItem,
            schema,
            selected: selectedIndex === index
          },
          index
        )) : /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsx("p", { children: "No data" }) }) }),
        /* @__PURE__ */ jsx(View, { flex: "auto", children: selectedIndex !== void 0 ? /* @__PURE__ */ jsx(
          JsonFormsDispatch,
          {
            cells,
            enabled,
            path: composePaths(path, `${selectedIndex}`),
            renderers,
            schema,
            uischema: foundUISchema,
            visible
          }
        ) : /* @__PURE__ */ jsx(Heading, { level: 4, children: "No Selection" }) })
      ] })
    ] });
  }
);
const SpectrumListWithDetailTester = rankWith(4, uiTypeIs("ListWithDetail"));
const SpectrumListWithDetailRenderer$1 = withJsonFormsArrayLayoutProps(withHandleChange(SpectrumListWithDetailRenderer));
const SpectrumRenderers = [
  { tester: inputControlTester, renderer: InputControl$1 },
  { tester: MediaPreviewControlTester, renderer: MediaPreviewControl$1 },
  {
    tester: SpectrumListWithDetailTester,
    renderer: SpectrumListWithDetailRenderer$1
  },
  {
    tester: SpectrumAnyOfStringOrEnumControlTester,
    renderer: SpectrumAnyOfStringOrEnumControl$1
  },
  { tester: SpectrumBooleanControlTester, renderer: SpectrumBooleanControl$1 },
  {
    tester: SpectrumBooleanButtonControlTester,
    renderer: SpectrumBooleanButtonControl$1
  },
  { tester: SpectrumCheckboxControlTester, renderer: SpectrumCheckboxControl$1 },
  { tester: SpectrumSwitchControlTester, renderer: SpectrumSwitchControl$1 },
  { tester: SpectrumDateControlTester, renderer: SpectrumDateControl$1 },
  { tester: SpectrumDateTimeControlTester, renderer: SpectrumDateTimeControl$1 },
  { tester: SpectrumEnumControlTester, renderer: SpectrumEnumControl$1 },
  {
    tester: SpectrumOneOfEnumControlTester,
    renderer: SpectrumOneOfEnumControl$1
  },
  {
    tester: SpectrumMultiOneOfEnumControlTester,
    renderer: SpectrumMultiOneOfEnumControl$1
  },
  { tester: SpectrumIntegerControlTester, renderer: SpectrumIntegerControl$1 },
  {
    tester: SpectrumRadioGroupControlTester,
    renderer: SpectrumRadioGroupControl$1
  },
  { tester: SpectrumRatingControlTester, renderer: SpectrumRatingControl$1 },
  { tester: SpectrumNumberControlTester, renderer: SpectrumNumberControl$1 },
  { tester: SpectrumTextAreaControlTester, renderer: SpectrumTextAreaControl$1 },
  { tester: SpectrumTextControlTester, renderer: SpectrumTextControl$1 },
  { tester: SpectrumLabelControlTester, renderer: SpectrumLabelControl$1 },
  {
    tester: SpectrumTextAndButtonControlTester,
    renderer: SpectrumTextAndButtonControl$1
  },
  { tester: SpectrumTimeControlTester, renderer: SpectrumTimeControl$1 },
  {
    tester: SpectrumArrayModalControlTester,
    renderer: SpectrumArrayModalControlRenderer
  },
  { tester: SpectrumLabelRendererTester, renderer: SpectrumLabelRenderer$1 },
  {
    tester: SpectrumCategorizationRendererTester,
    renderer: SpectrumCategorizationRenderer$1
  },
  {
    tester: SpectrumCategorizationStepperRendererTester,
    renderer: SpectrumCategorizationStepperRenderer$1
  },
  { tester: SpectrumObjectControlTester, renderer: SpectrumObjectRenderer$1 },
  {
    tester: SpectrumOneOfRadioGroupControlTester,
    renderer: SpectrumOneOfRadioGroupControl$1
  },
  {
    tester: SpectrumOneOfRendererTester,
    renderer: SpectrumOneOfRenderer$1
  },
  {
    tester: SpectrumAnyOfRendererTester,
    renderer: SpectrumAnyOfRenderer$1
  },
  {
    tester: SpectrumTipTapRendererTester,
    renderer: SpectrumTipTapRenderer$1
  },
  {
    tester: SpectrumCodeMirrorTester,
    renderer: SpectrumCodeMirror$1
  },
  {
    tester: SpectrumAllOfRendererTester,
    renderer: SpectrumAllOfRenderer$1
  },
  {
    tester: SpectrumSliderControlTester,
    renderer: SpectrumSliderControl$1
  },
  { tester: SpectrumGroupLayoutTester, renderer: SpectrumGroupLayout },
  {
    tester: SpectrumFragmentReferenceControlTester,
    renderer: SpectrumFragmentReferenceControl$1
  },
  { tester: SpectrumVerticalLayoutTester, renderer: SpectrumVerticalLayout },
  {
    tester: SpectrumHorizontalLayoutTester,
    renderer: SpectrumHorizontalLayout
  },
  {
    tester: SpectrumContentReferenceControlTester,
    renderer: SpectrumContentReferenceControl$1
  }
];
const SpectrumCells = [
  { tester: SpectrumBooleanCellTester, cell: SpectrumBooleanCell$1 },
  { tester: SpectrumBooleanButtonCellTester, cell: SpectrumBooleanButtonCell$1 },
  { tester: SpectrumCheckboxCellTester, cell: SpectrumCheckboxCell$1 },
  { tester: SpectrumSwitchCellTester, cell: SpectrumSwitchCell$1 },
  { tester: SpectrumEnumCellTester, cell: SpectrumEnumCell$1 },
  { tester: SpectrumIntegerCellTester, cell: SpectrumIntegerCell$1 },
  { tester: SpectrumNumberCellTester, cell: SpectrumNumberCell$1 },
  { tester: SpectrumSliderCellTester, cell: SpectrumSliderCell$1 },
  { tester: SpectrumTextAreaCellTester, cell: SpectrumTextAreaCell$1 },
  { tester: SpectrumTextCellTester, cell: SpectrumTextCell$1 }
];
export {
  Breadcrumbs,
  BreadcrumbsContext,
  BreadcrumbsProvider,
  CustomizableCells as Customizable,
  DeleteDialog,
  DetectKeyboardUser,
  ErrorIndicator,
  InputControl$1 as InputControl,
  MediaPreviewControl$1 as MediaPreviewControl,
  MediaPreviewControlTester,
  ModalItemAnimationWrapper,
  RenderersConfigContext,
  SpectrumAllOfRenderer$1 as SpectrumAllOfRenderer,
  SpectrumAllOfRendererTester,
  SpectrumAnyOfRenderer$1 as SpectrumAnyOfRenderer,
  SpectrumAnyOfRendererTester,
  SpectrumAnyOfStringOrEnumControl$1 as SpectrumAnyOfStringOrEnumControl,
  SpectrumAnyOfStringOrEnumControlTester,
  SpectrumArrayModalControlRenderer as SpectrumArrayModalControl,
  SpectrumArrayModalControlTester,
  SpectrumBooleanButtonCell$1 as SpectrumBooleanButtonCell,
  SpectrumBooleanButtonCellTester,
  SpectrumBooleanButtonControl$1 as SpectrumBooleanButtonControl,
  SpectrumBooleanButtonControlTester,
  SpectrumBooleanCell$1 as SpectrumBooleanCell,
  SpectrumBooleanCellTester,
  SpectrumBooleanControl$1 as SpectrumBooleanControl,
  SpectrumBooleanControlTester,
  SpectrumCategorizationRenderer$1 as SpectrumCategorizationRenderer,
  SpectrumCategorizationRendererTester,
  SpectrumCategorizationStepperRenderer$1 as SpectrumCategorizationStepperRenderer,
  SpectrumCategorizationStepperRendererTester,
  SpectrumCells,
  SpectrumCheckboxCell$1 as SpectrumCheckboxCell,
  SpectrumCheckboxCellTester,
  SpectrumCheckboxControl$1 as SpectrumCheckboxControl,
  SpectrumCheckboxControlTester,
  SpectrumCodeMirror$1 as SpectrumCodeMirror,
  SpectrumCodeMirrorTester,
  SpectrumContentReferenceControl$1 as SpectrumContentReferenceControl,
  SpectrumContentReferenceControlTester,
  SpectrumDateControl$1 as SpectrumDateControl,
  SpectrumDateControlTester,
  SpectrumDateTimeControl$1 as SpectrumDateTimeControl,
  SpectrumDateTimeControlTester,
  SpectrumEnumCell$1 as SpectrumEnumCell,
  SpectrumEnumCellTester,
  SpectrumEnumControl$1 as SpectrumEnumControl,
  SpectrumEnumControlTester,
  SpectrumFragmentReferenceControl$1 as SpectrumFragmentReferenceControl,
  SpectrumFragmentReferenceControlTester,
  SpectrumGroupLayout,
  SpectrumGroupLayoutTester,
  SpectrumHorizontalLayout,
  SpectrumHorizontalLayoutTester,
  SpectrumIntegerCell$1 as SpectrumIntegerCell,
  SpectrumIntegerCellTester,
  SpectrumIntegerControl$1 as SpectrumIntegerControl,
  SpectrumIntegerControlTester,
  SpectrumLabelControl$1 as SpectrumLabelControl,
  SpectrumLabelControlTester,
  SpectrumLabelRenderer$1 as SpectrumLabelRenderer,
  SpectrumLabelRendererTester,
  SpectrumListWithDetailRenderer$1 as SpectrumListWithDetailRenderer,
  SpectrumListWithDetailTester,
  SpectrumMultiOneOfEnumControl$1 as SpectrumMultiOneOfEnumControl,
  SpectrumMultiOneOfEnumControlTester,
  SpectrumNumberCell$1 as SpectrumNumberCell,
  SpectrumNumberCellTester,
  SpectrumNumberControl$1 as SpectrumNumberControl,
  SpectrumNumberControlTester,
  SpectrumObjectControlTester,
  SpectrumObjectRenderer$1 as SpectrumObjectRenderer,
  SpectrumOneOfEnumControl$1 as SpectrumOneOfEnumControl,
  SpectrumOneOfEnumControlTester,
  SpectrumOneOfRadioGroupControl$1 as SpectrumOneOfRadioGroupControl,
  SpectrumOneOfRadioGroupControlTester,
  SpectrumOneOfRenderer$1 as SpectrumOneOfRenderer,
  SpectrumOneOfRendererTester,
  SpectrumRadioGroupControl$1 as SpectrumRadioGroupControl,
  SpectrumRadioGroupControlTester,
  SpectrumRatingControl$1 as SpectrumRatingControl,
  SpectrumRatingControlTester,
  SpectrumRenderers,
  SpectrumSliderCell$1 as SpectrumSliderCell,
  SpectrumSliderCellTester,
  SpectrumSliderControl$1 as SpectrumSliderControl,
  SpectrumSliderControlTester,
  SpectrumSwitchCell$1 as SpectrumSwitchCell,
  SpectrumSwitchCellTester,
  SpectrumSwitchControl$1 as SpectrumSwitchControl,
  SpectrumSwitchControlTester,
  SpectrumTextAndButtonControl$1 as SpectrumTextAndButtonControl,
  SpectrumTextAndButtonControlTester,
  SpectrumTextAreaCell$1 as SpectrumTextAreaCell,
  SpectrumTextAreaCellTester,
  SpectrumTextAreaControl$1 as SpectrumTextAreaControl,
  SpectrumTextAreaControlTester,
  SpectrumTextCell$1 as SpectrumTextCell,
  SpectrumTextCellTester,
  SpectrumTextControl$1 as SpectrumTextControl,
  SpectrumTextControlTester,
  SpectrumTimeControl$1 as SpectrumTimeControl,
  SpectrumTimeControlTester,
  SpectrumTipTapRenderer$1 as SpectrumTipTapRenderer,
  SpectrumTipTapRendererTester,
  SpectrumVerticalLayout,
  SpectrumVerticalLayoutTester,
  allCopiesUpdater,
  areEqual,
  checkIfUserIsOnMobileDevice,
  circularReferenceReplacer,
  cssToObject,
  dataTestId,
  findValue,
  inputControlTester,
  isEmpty,
  isISODate,
  lengthErrorMessage,
  objectToCss,
  resolveSubSchemas,
  settings,
  useBreadcrumbs,
  useDebouncedChange,
  useFocus,
  valueErrorMessage,
  withAjvProps,
  withHandleChange,
  withJsonFormsArrayControlProps
};
